   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Parser V4.8.32.1 - 30 Mar 2010
   3                     ; Generator V4.3.4 - 23 Mar 2010
  43                     ; 45 void COMP_DeInit(void)
  43                     ; 46 {
  45                     	switch	.text
  46  0000               _COMP_DeInit:
  50                     ; 48   COMP->CSR1 = (uint8_t) COMP_CSR1_RESET_VALUE;
  52  0000 725f5440      	clr	21568
  53                     ; 51   COMP->CSR2 = (uint8_t) COMP_CSR2_RESET_VALUE;
  55  0004 725f5441      	clr	21569
  56                     ; 54   COMP->CSR3 = (uint8_t) COMP_CSR3_RESET_VALUE;
  58  0008 35c05442      	mov	21570,#192
  59                     ; 57   COMP->CSR4 = (uint8_t) COMP_CSR4_RESET_VALUE;
  61  000c 725f5443      	clr	21571
  62                     ; 60   COMP->CSR5 = (uint8_t) COMP_CSR5_RESET_VALUE;
  64  0010 725f5444      	clr	21572
  65                     ; 61 }
  68  0014 81            	ret
 236                     ; 74 void COMP_Init(COMP_InvertingInput_Typedef COMP_InvertingInput,
 236                     ; 75                COMP_OutputSelect_Typedef COMP_OutputSelect, COMP_Speed_TypeDef COMP_Speed)
 236                     ; 76 {
 237                     	switch	.text
 238  0015               _COMP_Init:
 240  0015 89            	pushw	x
 241       00000000      OFST:	set	0
 244                     ; 78   assert_param(IS_COMP_INVERTING_INPUT(COMP_InvertingInput));
 246                     ; 79   assert_param(IS_COMP_OUTPUT(COMP_OutputSelect));
 248                     ; 80   assert_param(IS_COMP_SPEED(COMP_Speed));
 250                     ; 83   COMP->CSR3 &= (uint8_t) (~COMP_CSR3_INSEL);
 252  0016 c65442        	ld	a,21570
 253  0019 a4c7          	and	a,#199
 254  001b c75442        	ld	21570,a
 255                     ; 85   COMP->CSR3 |= (uint8_t) COMP_InvertingInput;
 257  001e 9e            	ld	a,xh
 258  001f ca5442        	or	a,21570
 259  0022 c75442        	ld	21570,a
 260                     ; 88   COMP->CSR3 &= (uint8_t) (~COMP_CSR3_OUTSEL);
 262  0025 c65442        	ld	a,21570
 263  0028 a43f          	and	a,#63
 264  002a c75442        	ld	21570,a
 265                     ; 90   COMP->CSR3 |= (uint8_t) COMP_OutputSelect;
 267  002d 9f            	ld	a,xl
 268  002e ca5442        	or	a,21570
 269  0031 c75442        	ld	21570,a
 270                     ; 93   COMP->CSR2 &= (uint8_t) (~COMP_CSR2_SPEED);
 272  0034 72155441      	bres	21569,#2
 273                     ; 95   COMP->CSR2 |= (uint8_t) COMP_Speed;
 275  0038 c65441        	ld	a,21569
 276  003b 1a05          	or	a,(OFST+5,sp)
 277  003d c75441        	ld	21569,a
 278                     ; 96 }
 281  0040 85            	popw	x
 282  0041 81            	ret
 338                     ; 104 void COMP_VrefintToCOMP1Connect(FunctionalState NewState)
 338                     ; 105 {
 339                     	switch	.text
 340  0042               _COMP_VrefintToCOMP1Connect:
 344                     ; 107   assert_param(IS_FUNCTIONAL_STATE(NewState));
 346                     ; 109   if (NewState != DISABLE)
 348  0042 4d            	tnz	a
 349  0043 2706          	jreq	L141
 350                     ; 112     COMP->CSR3 |= COMP_CSR3_VREFEN;
 352  0045 72145442      	bset	21570,#2
 354  0049 2004          	jra	L341
 355  004b               L141:
 356                     ; 117     COMP->CSR3 &= (uint8_t)(~COMP_CSR3_VREFEN);
 358  004b 72155442      	bres	21570,#2
 359  004f               L341:
 360                     ; 119 }
 363  004f 81            	ret
 458                     ; 128 void COMP_EdgeConfig(COMP_Selection_TypeDef COMP_Selection, COMP_Edge_TypeDef COMP_Edge)
 458                     ; 129 {
 459                     	switch	.text
 460  0050               _COMP_EdgeConfig:
 462  0050 89            	pushw	x
 463       00000000      OFST:	set	0
 466                     ; 131   assert_param(IS_COMP_ALL_PERIPH(COMP_Selection));
 468                     ; 132   assert_param(IS_COMP_EDGE(COMP_Edge));
 470                     ; 135   if (COMP_Selection == COMP_Selection_COMP1)
 472  0051 9e            	ld	a,xh
 473  0052 a101          	cp	a,#1
 474  0054 2611          	jrne	L112
 475                     ; 138     COMP->CSR1 &= (uint8_t) (~COMP_CSR1_CMP1);
 477  0056 c65440        	ld	a,21568
 478  0059 a4fc          	and	a,#252
 479  005b c75440        	ld	21568,a
 480                     ; 141     COMP->CSR1 |= (uint8_t) COMP_Edge;
 482  005e 9f            	ld	a,xl
 483  005f ca5440        	or	a,21568
 484  0062 c75440        	ld	21568,a
 486  0065 2010          	jra	L312
 487  0067               L112:
 488                     ; 147     COMP->CSR2 &= (uint8_t) (~COMP_CSR2_CMP2);
 490  0067 c65441        	ld	a,21569
 491  006a a4fc          	and	a,#252
 492  006c c75441        	ld	21569,a
 493                     ; 150     COMP->CSR2 |= (uint8_t) COMP_Edge;
 495  006f c65441        	ld	a,21569
 496  0072 1a02          	or	a,(OFST+2,sp)
 497  0074 c75441        	ld	21569,a
 498  0077               L312:
 499                     ; 152 }
 502  0077 85            	popw	x
 503  0078 81            	ret
 571                     ; 161 COMP_OutputLevel_TypeDef COMP_GetOutputLevel(COMP_Selection_TypeDef COMP_Selection)
 571                     ; 162 {
 572                     	switch	.text
 573  0079               _COMP_GetOutputLevel:
 575  0079 88            	push	a
 576       00000001      OFST:	set	1
 579                     ; 166   assert_param(IS_COMP_ALL_PERIPH(COMP_Selection));
 581                     ; 169   if (COMP_Selection == COMP_Selection_COMP1)
 583  007a a101          	cp	a,#1
 584  007c 2611          	jrne	L742
 585                     ; 172     if ((COMP->CSR1 & COMP_CSR1_CMP1OUT) != (uint8_t) RESET)
 587  007e c65440        	ld	a,21568
 588  0081 a508          	bcp	a,#8
 589  0083 2706          	jreq	L152
 590                     ; 175       compout = (COMP_OutputLevel_TypeDef) COMP_OutputLevel_High;
 592  0085 a601          	ld	a,#1
 593  0087 6b01          	ld	(OFST+0,sp),a
 595  0089 2013          	jra	L552
 596  008b               L152:
 597                     ; 181       compout = (COMP_OutputLevel_TypeDef) COMP_OutputLevel_Low;
 599  008b 0f01          	clr	(OFST+0,sp)
 600  008d 200f          	jra	L552
 601  008f               L742:
 602                     ; 188     if ((COMP->CSR2 & COMP_CSR2_CMP2OUT) != (uint8_t) RESET)
 604  008f c65441        	ld	a,21569
 605  0092 a508          	bcp	a,#8
 606  0094 2706          	jreq	L752
 607                     ; 191       compout = (COMP_OutputLevel_TypeDef) COMP_OutputLevel_High;
 609  0096 a601          	ld	a,#1
 610  0098 6b01          	ld	(OFST+0,sp),a
 612  009a 2002          	jra	L552
 613  009c               L752:
 614                     ; 197       compout = (COMP_OutputLevel_TypeDef) COMP_OutputLevel_Low;
 616  009c 0f01          	clr	(OFST+0,sp)
 617  009e               L552:
 618                     ; 202   return (COMP_OutputLevel_TypeDef)(compout);
 620  009e 7b01          	ld	a,(OFST+0,sp)
 623  00a0 5b01          	addw	sp,#1
 624  00a2 81            	ret
 659                     ; 211 void COMP_WindowCmd(FunctionalState NewState)
 659                     ; 212 {
 660                     	switch	.text
 661  00a3               _COMP_WindowCmd:
 665                     ; 214   assert_param(IS_FUNCTIONAL_STATE(NewState));
 667                     ; 216   if (NewState != DISABLE)
 669  00a3 4d            	tnz	a
 670  00a4 2706          	jreq	L103
 671                     ; 219     COMP->CSR3 |= (uint8_t) COMP_CSR3_WNDWE;
 673  00a6 72125442      	bset	21570,#1
 675  00aa 2004          	jra	L303
 676  00ac               L103:
 677                     ; 224     COMP->CSR3 &= (uint8_t)(~COMP_CSR3_WNDWE);
 679  00ac 72135442      	bres	21570,#1
 680  00b0               L303:
 681                     ; 226 }
 684  00b0 81            	ret
 729                     ; 236 void COMP_ITConfig(COMP_Selection_TypeDef COMP_Selection, FunctionalState NewState)
 729                     ; 237 {
 730                     	switch	.text
 731  00b1               _COMP_ITConfig:
 733  00b1 89            	pushw	x
 734       00000000      OFST:	set	0
 737                     ; 239   assert_param(IS_COMP_ALL_PERIPH(COMP_Selection));
 739                     ; 240   assert_param(IS_FUNCTIONAL_STATE(NewState));
 741                     ; 243   if (COMP_Selection == COMP_Selection_COMP1)
 743  00b2 9e            	ld	a,xh
 744  00b3 a101          	cp	a,#1
 745  00b5 2610          	jrne	L723
 746                     ; 245     if (NewState != DISABLE)
 748  00b7 9f            	ld	a,xl
 749  00b8 4d            	tnz	a
 750  00b9 2706          	jreq	L133
 751                     ; 248       COMP->CSR1 |= (uint8_t) COMP_CSR1_IE1;
 753  00bb 721a5440      	bset	21568,#5
 755  00bf 2014          	jra	L533
 756  00c1               L133:
 757                     ; 253       COMP->CSR1 &= (uint8_t)(~COMP_CSR1_IE1);
 759  00c1 721b5440      	bres	21568,#5
 760  00c5 200e          	jra	L533
 761  00c7               L723:
 762                     ; 258     if (NewState != DISABLE)
 764  00c7 0d02          	tnz	(OFST+2,sp)
 765  00c9 2706          	jreq	L733
 766                     ; 261       COMP->CSR2 |= (uint8_t) COMP_CSR2_IE2;
 768  00cb 721a5441      	bset	21569,#5
 770  00cf 2004          	jra	L533
 771  00d1               L733:
 772                     ; 266       COMP->CSR2 &= (uint8_t)(~COMP_CSR2_IE2);
 774  00d1 721b5441      	bres	21569,#5
 775  00d5               L533:
 776                     ; 269 }
 779  00d5 85            	popw	x
 780  00d6 81            	ret
 900                     ; 281 void COMP_TriggerConfig(COMP_TriggerGroup_TypeDef COMP_TriggerGroup,
 900                     ; 282                         COMP_TriggerPin_TypeDef COMP_TriggerPin,
 900                     ; 283                         FunctionalState NewState)
 900                     ; 284 {
 901                     	switch	.text
 902  00d7               _COMP_TriggerConfig:
 904  00d7 89            	pushw	x
 905       00000000      OFST:	set	0
 908                     ; 286   assert_param(IS_COMP_TRIGGERGROUP(COMP_TriggerGroup));
 910                     ; 287   assert_param(IS_COMP_TRIGGERPIN(COMP_TriggerPin));
 912                     ; 289   switch (COMP_TriggerGroup)
 914  00d8 9e            	ld	a,xh
 916                     ; 336     default:
 916                     ; 337       break;
 917  00d9 4a            	dec	a
 918  00da 270b          	jreq	L343
 919  00dc 4a            	dec	a
 920  00dd 2721          	jreq	L543
 921  00df 4a            	dec	a
 922  00e0 273d          	jreq	L743
 923  00e2 4a            	dec	a
 924  00e3 2753          	jreq	L153
 925  00e5 206e          	jra	L334
 926  00e7               L343:
 927                     ; 291     case COMP_TriggerGroup_InvertingInput:
 927                     ; 292 
 927                     ; 293       if (NewState != DISABLE)
 929  00e7 0d05          	tnz	(OFST+5,sp)
 930  00e9 270b          	jreq	L534
 931                     ; 295         COMP->CSR4 &= (uint8_t) ~COMP_TriggerPin;
 933  00eb 7b02          	ld	a,(OFST+2,sp)
 934  00ed 43            	cpl	a
 935  00ee c45443        	and	a,21571
 936  00f1 c75443        	ld	21571,a
 938  00f4 205f          	jra	L334
 939  00f6               L534:
 940                     ; 299         COMP->CSR4 |= (uint8_t) COMP_TriggerPin;
 942  00f6 c65443        	ld	a,21571
 943  00f9 1a02          	or	a,(OFST+2,sp)
 944  00fb c75443        	ld	21571,a
 945  00fe 2055          	jra	L334
 946  0100               L543:
 947                     ; 303     case COMP_TriggerGroup_NonInvertingInput:
 947                     ; 304       if (NewState != DISABLE)
 949  0100 0d05          	tnz	(OFST+5,sp)
 950  0102 270e          	jreq	L144
 951                     ; 306         COMP->CSR4 &= (uint8_t) ~((uint8_t)(COMP_TriggerPin << 3));
 953  0104 7b02          	ld	a,(OFST+2,sp)
 954  0106 48            	sll	a
 955  0107 48            	sll	a
 956  0108 48            	sll	a
 957  0109 43            	cpl	a
 958  010a c45443        	and	a,21571
 959  010d c75443        	ld	21571,a
 961  0110 2043          	jra	L334
 962  0112               L144:
 963                     ; 310         COMP->CSR4 |= (uint8_t) (COMP_TriggerPin << 3);
 965  0112 7b02          	ld	a,(OFST+2,sp)
 966  0114 48            	sll	a
 967  0115 48            	sll	a
 968  0116 48            	sll	a
 969  0117 ca5443        	or	a,21571
 970  011a c75443        	ld	21571,a
 971  011d 2036          	jra	L334
 972  011f               L743:
 973                     ; 314     case COMP_TriggerGroup_VREFINTOutput:
 973                     ; 315       if (NewState != DISABLE)
 975  011f 0d05          	tnz	(OFST+5,sp)
 976  0121 270b          	jreq	L544
 977                     ; 317         COMP->CSR5 &= (uint8_t) ~COMP_TriggerPin;
 979  0123 7b02          	ld	a,(OFST+2,sp)
 980  0125 43            	cpl	a
 981  0126 c45444        	and	a,21572
 982  0129 c75444        	ld	21572,a
 984  012c 2027          	jra	L334
 985  012e               L544:
 986                     ; 321         COMP->CSR5 |= (uint8_t) COMP_TriggerPin;
 988  012e c65444        	ld	a,21572
 989  0131 1a02          	or	a,(OFST+2,sp)
 990  0133 c75444        	ld	21572,a
 991  0136 201d          	jra	L334
 992  0138               L153:
 993                     ; 325     case COMP_TriggerGroup_DACOutput:
 993                     ; 326       if (NewState != DISABLE)
 995  0138 0d05          	tnz	(OFST+5,sp)
 996  013a 270e          	jreq	L154
 997                     ; 328         COMP->CSR5 &= (uint8_t) ~((uint8_t)(COMP_TriggerPin << 3));
 999  013c 7b02          	ld	a,(OFST+2,sp)
1000  013e 48            	sll	a
1001  013f 48            	sll	a
1002  0140 48            	sll	a
1003  0141 43            	cpl	a
1004  0142 c45444        	and	a,21572
1005  0145 c75444        	ld	21572,a
1007  0148 200b          	jra	L334
1008  014a               L154:
1009                     ; 332         COMP->CSR5 |= (uint8_t) (COMP_TriggerPin << 3);
1011  014a 7b02          	ld	a,(OFST+2,sp)
1012  014c 48            	sll	a
1013  014d 48            	sll	a
1014  014e 48            	sll	a
1015  014f ca5444        	or	a,21572
1016  0152 c75444        	ld	21572,a
1017  0155               L353:
1018                     ; 336     default:
1018                     ; 337       break;
1020  0155               L334:
1021                     ; 339 }
1024  0155 85            	popw	x
1025  0156 81            	ret
1061                     ; 347 void COMP_VrefintOutputCmd(FunctionalState NewState)
1061                     ; 348 {
1062                     	switch	.text
1063  0157               _COMP_VrefintOutputCmd:
1067                     ; 350   assert_param(IS_FUNCTIONAL_STATE(NewState));
1069                     ; 352   if (NewState != DISABLE)
1071  0157 4d            	tnz	a
1072  0158 2706          	jreq	L374
1073                     ; 355     COMP->CSR3 |= (uint8_t) COMP_CSR3_VREFOUTEN;
1075  015a 72105442      	bset	21570,#0
1077  015e 2004          	jra	L574
1078  0160               L374:
1079                     ; 360     COMP->CSR3 &= (uint8_t) (~COMP_CSR3_VREFOUTEN);
1081  0160 72115442      	bres	21570,#0
1082  0164               L574:
1083                     ; 362 }
1086  0164 81            	ret
1122                     ; 370 void COMP_SchmittTriggerCmd(FunctionalState NewState)
1122                     ; 371 {
1123                     	switch	.text
1124  0165               _COMP_SchmittTriggerCmd:
1128                     ; 373   assert_param(IS_FUNCTIONAL_STATE(NewState));
1130                     ; 375   if (NewState != DISABLE)
1132  0165 4d            	tnz	a
1133  0166 2706          	jreq	L515
1134                     ; 378     COMP->CSR1 |= (uint8_t) COMP_CSR1_STE;
1136  0168 72145440      	bset	21568,#2
1138  016c 2004          	jra	L715
1139  016e               L515:
1140                     ; 383     COMP->CSR1 &= (uint8_t) (~COMP_CSR1_STE);
1142  016e 72155440      	bres	21568,#2
1143  0172               L715:
1144                     ; 385 }
1147  0172 81            	ret
1213                     ; 393 FlagStatus COMP_GetFlagStatus(COMP_Selection_TypeDef COMP_Selection)
1213                     ; 394 {
1214                     	switch	.text
1215  0173               _COMP_GetFlagStatus:
1217  0173 88            	push	a
1218       00000001      OFST:	set	1
1221                     ; 395   FlagStatus bitstatus = RESET;
1223                     ; 398   assert_param(IS_COMP_ALL_PERIPH(COMP_Selection));
1225                     ; 401   if (COMP_Selection == COMP_Selection_COMP1)
1227  0174 a101          	cp	a,#1
1228  0176 2611          	jrne	L355
1229                     ; 403     if ((COMP->CSR1 & COMP_CSR1_EF1) != (uint8_t) RESET)
1231  0178 c65440        	ld	a,21568
1232  017b a510          	bcp	a,#16
1233  017d 2706          	jreq	L555
1234                     ; 406       bitstatus = SET;
1236  017f a601          	ld	a,#1
1237  0181 6b01          	ld	(OFST+0,sp),a
1239  0183 2013          	jra	L165
1240  0185               L555:
1241                     ; 411       bitstatus = RESET;
1243  0185 0f01          	clr	(OFST+0,sp)
1244  0187 200f          	jra	L165
1245  0189               L355:
1246                     ; 416     if ((COMP->CSR2 & COMP_CSR2_EF2) != (uint8_t) RESET)
1248  0189 c65441        	ld	a,21569
1249  018c a510          	bcp	a,#16
1250  018e 2706          	jreq	L365
1251                     ; 419       bitstatus = SET;
1253  0190 a601          	ld	a,#1
1254  0192 6b01          	ld	(OFST+0,sp),a
1256  0194 2002          	jra	L165
1257  0196               L365:
1258                     ; 424       bitstatus = RESET;
1260  0196 0f01          	clr	(OFST+0,sp)
1261  0198               L165:
1262                     ; 429   return (FlagStatus)(bitstatus);
1264  0198 7b01          	ld	a,(OFST+0,sp)
1267  019a 5b01          	addw	sp,#1
1268  019c 81            	ret
1303                     ; 438 void COMP_ClearFlag(COMP_Selection_TypeDef COMP_Selection)
1303                     ; 439 {
1304                     	switch	.text
1305  019d               _COMP_ClearFlag:
1309                     ; 441   assert_param(IS_COMP_ALL_PERIPH(COMP_Selection));
1311                     ; 443   if (COMP_Selection == COMP_Selection_COMP1)
1313  019d a101          	cp	a,#1
1314  019f 2606          	jrne	L506
1315                     ; 446     COMP->CSR1 &= (uint8_t) (~COMP_CSR1_EF1);
1317  01a1 72195440      	bres	21568,#4
1319  01a5 2004          	jra	L706
1320  01a7               L506:
1321                     ; 451     COMP->CSR2 &= (uint8_t) (~COMP_CSR2_EF2);
1323  01a7 72195441      	bres	21569,#4
1324  01ab               L706:
1325                     ; 453 }
1328  01ab 81            	ret
1392                     ; 461 ITStatus COMP_GetITStatus(COMP_Selection_TypeDef COMP_Selection)
1392                     ; 462 {
1393                     	switch	.text
1394  01ac               _COMP_GetITStatus:
1396  01ac 89            	pushw	x
1397       00000002      OFST:	set	2
1400                     ; 463   ITStatus bitstatus = RESET;
1402                     ; 464   uint8_t itstatus = 0x00, itenable = 0x00;
1406                     ; 467   assert_param(IS_COMP_ALL_PERIPH(COMP_Selection));
1408                     ; 469   if (COMP_Selection == COMP_Selection_COMP1)
1410  01ad a101          	cp	a,#1
1411  01af 2620          	jrne	L346
1412                     ; 472     itstatus = (uint8_t) (COMP->CSR1 & COMP_CSR1_EF1);
1414  01b1 c65440        	ld	a,21568
1415  01b4 a410          	and	a,#16
1416  01b6 6b01          	ld	(OFST-1,sp),a
1417                     ; 475     itenable = (uint8_t) (COMP->CSR1 & COMP_CSR1_IE1);
1419  01b8 c65440        	ld	a,21568
1420  01bb a420          	and	a,#32
1421  01bd 6b02          	ld	(OFST+0,sp),a
1422                     ; 477     if ((itstatus != (uint8_t) RESET) && (itenable != (uint8_t) RESET))
1424  01bf 0d01          	tnz	(OFST-1,sp)
1425  01c1 270a          	jreq	L546
1427  01c3 0d02          	tnz	(OFST+0,sp)
1428  01c5 2706          	jreq	L546
1429                     ; 480       bitstatus = SET;
1431  01c7 a601          	ld	a,#1
1432  01c9 6b02          	ld	(OFST+0,sp),a
1434  01cb 2022          	jra	L156
1435  01cd               L546:
1436                     ; 485       bitstatus = RESET;
1438  01cd 0f02          	clr	(OFST+0,sp)
1439  01cf 201e          	jra	L156
1440  01d1               L346:
1441                     ; 491     itstatus = (uint8_t) (COMP->CSR2 & COMP_CSR2_EF2);
1443  01d1 c65441        	ld	a,21569
1444  01d4 a410          	and	a,#16
1445  01d6 6b01          	ld	(OFST-1,sp),a
1446                     ; 494     itenable = (uint8_t) (COMP->CSR2 & COMP_CSR2_IE2);
1448  01d8 c65441        	ld	a,21569
1449  01db a420          	and	a,#32
1450  01dd 6b02          	ld	(OFST+0,sp),a
1451                     ; 496     if ((itstatus != (uint8_t)RESET) && (itenable != (uint8_t)RESET))
1453  01df 0d01          	tnz	(OFST-1,sp)
1454  01e1 270a          	jreq	L356
1456  01e3 0d02          	tnz	(OFST+0,sp)
1457  01e5 2706          	jreq	L356
1458                     ; 499       bitstatus = SET;
1460  01e7 a601          	ld	a,#1
1461  01e9 6b02          	ld	(OFST+0,sp),a
1463  01eb 2002          	jra	L156
1464  01ed               L356:
1465                     ; 504       bitstatus = RESET;
1467  01ed 0f02          	clr	(OFST+0,sp)
1468  01ef               L156:
1469                     ; 509   return (ITStatus) bitstatus;
1471  01ef 7b02          	ld	a,(OFST+0,sp)
1474  01f1 85            	popw	x
1475  01f2 81            	ret
1511                     ; 518 void COMP_ClearITPendingBit(COMP_Selection_TypeDef COMP_Selection)
1511                     ; 519 {
1512                     	switch	.text
1513  01f3               _COMP_ClearITPendingBit:
1517                     ; 521   assert_param(IS_COMP_ALL_PERIPH(COMP_Selection));
1519                     ; 523   if (COMP_Selection == COMP_Selection_COMP1)
1521  01f3 a101          	cp	a,#1
1522  01f5 2606          	jrne	L576
1523                     ; 526     COMP->CSR1 &= (uint8_t) (~COMP_CSR1_EF1);
1525  01f7 72195440      	bres	21568,#4
1527  01fb 2004          	jra	L776
1528  01fd               L576:
1529                     ; 531     COMP->CSR2 &= (uint8_t) (~COMP_CSR2_EF2);
1531  01fd 72195441      	bres	21569,#4
1532  0201               L776:
1533                     ; 533 }
1536  0201 81            	ret
1549                     	xdef	_COMP_ClearITPendingBit
1550                     	xdef	_COMP_GetITStatus
1551                     	xdef	_COMP_ClearFlag
1552                     	xdef	_COMP_GetFlagStatus
1553                     	xdef	_COMP_SchmittTriggerCmd
1554                     	xdef	_COMP_VrefintOutputCmd
1555                     	xdef	_COMP_TriggerConfig
1556                     	xdef	_COMP_ITConfig
1557                     	xdef	_COMP_WindowCmd
1558                     	xdef	_COMP_GetOutputLevel
1559                     	xdef	_COMP_EdgeConfig
1560                     	xdef	_COMP_VrefintToCOMP1Connect
1561                     	xdef	_COMP_Init
1562                     	xdef	_COMP_DeInit
1581                     	end
