   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Parser V4.8.32.1 - 30 Mar 2010
   3                     ; Generator V4.3.4 - 23 Mar 2010
  76                     ; 85 void FLASH_Unlock(FLASH_MemType_TypeDef FLASH_MemType)
  76                     ; 86 {
  78                     	switch	.text
  79  0000               _FLASH_Unlock:
  81  0000 88            	push	a
  82       00000000      OFST:	set	0
  85                     ; 88   assert_param(IS_FLASH_MEMORY_TYPE(FLASH_MemType));
  87                     ; 91   if (FLASH_MemType == FLASH_MemType_Program)
  89  0001 a1fd          	cp	a,#253
  90  0003 2608          	jrne	L73
  91                     ; 93     FLASH->PUKR = FLASH_RASS_KEY1;
  93  0005 35565052      	mov	20562,#86
  94                     ; 94     FLASH->PUKR = FLASH_RASS_KEY2;
  96  0009 35ae5052      	mov	20562,#174
  97  000d               L73:
  98                     ; 98   if (FLASH_MemType == FLASH_MemType_Data)
 100  000d 7b01          	ld	a,(OFST+1,sp)
 101  000f a1f7          	cp	a,#247
 102  0011 2608          	jrne	L14
 103                     ; 100     FLASH->DUKR = FLASH_RASS_KEY2; /* Warning: keys are reversed on data memory !!! */
 105  0013 35ae5053      	mov	20563,#174
 106                     ; 101     FLASH->DUKR = FLASH_RASS_KEY1;
 108  0017 35565053      	mov	20563,#86
 109  001b               L14:
 110                     ; 103 }
 113  001b 84            	pop	a
 114  001c 81            	ret
 149                     ; 111 void FLASH_Lock(FLASH_MemType_TypeDef FLASH_MemType)
 149                     ; 112 {
 150                     	switch	.text
 151  001d               _FLASH_Lock:
 155                     ; 114   assert_param(IS_FLASH_MEMORY_TYPE(FLASH_MemType));
 157                     ; 116   FLASH->IAPSR &= (uint8_t)FLASH_MemType;
 159  001d c45054        	and	a,20564
 160  0020 c75054        	ld	20564,a
 161                     ; 117 }
 164  0023 81            	ret
 187                     ; 124 void FLASH_DeInit(void)
 187                     ; 125 {
 188                     	switch	.text
 189  0024               _FLASH_DeInit:
 193                     ; 126   FLASH->CR1 = FLASH_CR1_RESET_VALUE;
 195  0024 725f5050      	clr	20560
 196                     ; 127   FLASH->CR2 = FLASH_CR2_RESET_VALUE;
 198  0028 725f5051      	clr	20561
 199                     ; 128   FLASH->IAPSR = FLASH_IAPSR_RESET_VALUE;
 201  002c 35405054      	mov	20564,#64
 202                     ; 129   (void) FLASH->IAPSR; /* Reading of this register causes the clearing of status flags */
 204  0030 c65054        	ld	a,20564
 205                     ; 130 }
 208  0033 81            	ret
 263                     ; 138 void FLASH_ITConfig(FunctionalState NewState)
 263                     ; 139 {
 264                     	switch	.text
 265  0034               _FLASH_ITConfig:
 269                     ; 142   assert_param(IS_FUNCTIONAL_STATE(NewState));
 271                     ; 144   if (NewState != DISABLE)
 273  0034 4d            	tnz	a
 274  0035 2706          	jreq	L711
 275                     ; 147     FLASH->CR1 |= FLASH_CR1_IE;
 277  0037 72125050      	bset	20560,#1
 279  003b 2004          	jra	L121
 280  003d               L711:
 281                     ; 152     FLASH->CR1 &= (uint8_t)(~FLASH_CR1_IE);
 283  003d 72135050      	bres	20560,#1
 284  0041               L121:
 285                     ; 154 }
 288  0041 81            	ret
 322                     ; 161 void FLASH_EraseByte(uint32_t Address)
 322                     ; 162 {
 323                     	switch	.text
 324  0042               _FLASH_EraseByte:
 326       00000000      OFST:	set	0
 329                     ; 164   assert_param(IS_FLASH_ADDRESS(Address));
 331                     ; 166   *(PointerAttr uint8_t*) (uint16_t)Address = FLASH_CLEAR_BYTE; /* Erase byte */
 333  0042 1e05          	ldw	x,(OFST+5,sp)
 334  0044 7f            	clr	(x)
 335                     ; 167 }
 338  0045 81            	ret
 381                     ; 174 void FLASH_ProgramByte(uint32_t Address, uint8_t Data)
 381                     ; 175 {
 382                     	switch	.text
 383  0046               _FLASH_ProgramByte:
 385       00000000      OFST:	set	0
 388                     ; 177   assert_param(IS_FLASH_ADDRESS(Address));
 390                     ; 179   *(PointerAttr uint8_t*) (uint16_t)Address = Data;
 392  0046 7b07          	ld	a,(OFST+7,sp)
 393  0048 1e05          	ldw	x,(OFST+5,sp)
 394  004a f7            	ld	(x),a
 395                     ; 180 }
 398  004b 81            	ret
 441                     ; 188 void FLASH_ProgramWord(uint32_t Address, uint32_t Data)
 441                     ; 189 {
 442                     	switch	.text
 443  004c               _FLASH_ProgramWord:
 445       00000000      OFST:	set	0
 448                     ; 191   assert_param(IS_FLASH_ADDRESS(Address));
 450                     ; 193   FLASH->CR2 |= FLASH_CR2_WPRG;
 452  004c 721c5051      	bset	20561,#6
 453                     ; 196   *((PointerAttr uint8_t*)(uint16_t)Address)       = *((uint8_t*)(&Data));   
 455  0050 7b07          	ld	a,(OFST+7,sp)
 456  0052 1e05          	ldw	x,(OFST+5,sp)
 457  0054 f7            	ld	(x),a
 458                     ; 198   *(((PointerAttr uint8_t*)(uint16_t)Address) + 1) = *((uint8_t*)(&Data) + 1);
 460  0055 7b08          	ld	a,(OFST+8,sp)
 461  0057 1e05          	ldw	x,(OFST+5,sp)
 462  0059 e701          	ld	(1,x),a
 463                     ; 200   *(((PointerAttr uint8_t*)(uint16_t)Address) + 2) = *((uint8_t*)(&Data) + 2); 
 465  005b 7b09          	ld	a,(OFST+9,sp)
 466  005d 1e05          	ldw	x,(OFST+5,sp)
 467  005f e702          	ld	(2,x),a
 468                     ; 202   *(((PointerAttr uint8_t*)(uint16_t)Address) + 3) = *((uint8_t*)(&Data) + 3); 
 470  0061 7b0a          	ld	a,(OFST+10,sp)
 471  0063 1e05          	ldw	x,(OFST+5,sp)
 472  0065 e703          	ld	(3,x),a
 473                     ; 203 }
 476  0067 81            	ret
 521                     ; 211 void FLASH_ProgramOptionByte(uint16_t Address, uint8_t Data)
 521                     ; 212 {
 522                     	switch	.text
 523  0068               _FLASH_ProgramOptionByte:
 525  0068 89            	pushw	x
 526       00000000      OFST:	set	0
 529                     ; 214   assert_param(IS_OPTION_BYTE_ADDRESS(Address));
 531                     ; 217   FLASH->CR2 |= FLASH_CR2_OPT;
 533  0069 721e5051      	bset	20561,#7
 534                     ; 220   *((PointerAttr uint8_t*)Address) = Data;
 536  006d 7b05          	ld	a,(OFST+5,sp)
 537  006f 1e01          	ldw	x,(OFST+1,sp)
 538  0071 f7            	ld	(x),a
 539                     ; 222   FLASH_WaitForLastOperation(FLASH_MemType_Program);
 541  0072 a6fd          	ld	a,#253
 542  0074 cd0112        	call	_FLASH_WaitForLastOperation
 544                     ; 225   FLASH->CR2 &= (uint8_t)(~FLASH_CR2_OPT);
 546  0077 721f5051      	bres	20561,#7
 547                     ; 226 }
 550  007b 85            	popw	x
 551  007c 81            	ret
 587                     ; 233 void FLASH_EraseOptionByte(uint16_t Address)
 587                     ; 234 {
 588                     	switch	.text
 589  007d               _FLASH_EraseOptionByte:
 593                     ; 236   assert_param(IS_OPTION_BYTE_ADDRESS(Address));
 595                     ; 239   FLASH->CR2 |= FLASH_CR2_OPT;
 597  007d 721e5051      	bset	20561,#7
 598                     ; 242   *((PointerAttr uint8_t*)Address) = FLASH_CLEAR_BYTE;
 600  0081 7f            	clr	(x)
 601                     ; 244   FLASH_WaitForLastOperation(FLASH_MemType_Program);
 603  0082 a6fd          	ld	a,#253
 604  0084 cd0112        	call	_FLASH_WaitForLastOperation
 606                     ; 247   FLASH->CR2 &= (uint8_t)(~FLASH_CR2_OPT);
 608  0087 721f5051      	bres	20561,#7
 609                     ; 248 }
 612  008b 81            	ret
 646                     ; 255 uint8_t FLASH_ReadByte(uint32_t Address)
 646                     ; 256 {
 647                     	switch	.text
 648  008c               _FLASH_ReadByte:
 650       00000000      OFST:	set	0
 653                     ; 258   return(*(PointerAttr uint8_t *) (uint16_t)Address);
 655  008c 1e05          	ldw	x,(OFST+5,sp)
 656  008e f6            	ld	a,(x)
 659  008f 81            	ret
 717                     ; 266 void FLASH_SetProgrammingTime(FLASH_ProgramTime_TypeDef FLASH_ProgTime)
 717                     ; 267 {
 718                     	switch	.text
 719  0090               _FLASH_SetProgrammingTime:
 723                     ; 269   assert_param(IS_FLASH_PROGRAM_TIME(FLASH_ProgTime));
 725                     ; 271   FLASH->CR1 &= (uint8_t)(~FLASH_CR1_FIX);
 727  0090 72115050      	bres	20560,#0
 728                     ; 272   FLASH->CR1 |= (uint8_t)FLASH_ProgTime;
 730  0094 ca5050        	or	a,20560
 731  0097 c75050        	ld	20560,a
 732                     ; 273 }
 735  009a 81            	ret
 791                     ; 283 void FLASH_PowerWaitModeConfig(FLASH_Power_TypeDef FLASH_Power)
 791                     ; 284 {
 792                     	switch	.text
 793  009b               _FLASH_PowerWaitModeConfig:
 797                     ; 286   assert_param(IS_FLASH_POWER(FLASH_Power));
 799                     ; 289   if (FLASH_Power != FLASH_Power_On)
 801  009b a101          	cp	a,#1
 802  009d 2706          	jreq	L733
 803                     ; 291     FLASH->CR1 |= (uint8_t)FLASH_CR1_WAITM;
 805  009f 72145050      	bset	20560,#2
 807  00a3 2004          	jra	L143
 808  00a5               L733:
 809                     ; 296     FLASH->CR1 &= (uint8_t)(~FLASH_CR1_WAITM);
 811  00a5 72155050      	bres	20560,#2
 812  00a9               L143:
 813                     ; 298 }
 816  00a9 81            	ret
 841                     ; 305 FLASH_ProgramTime_TypeDef FLASH_GetProgrammingTime(void)
 841                     ; 306 {
 842                     	switch	.text
 843  00aa               _FLASH_GetProgrammingTime:
 847                     ; 307   return((FLASH_ProgramTime_TypeDef)(FLASH->CR1 & FLASH_CR1_FIX));
 849  00aa c65050        	ld	a,20560
 850  00ad a401          	and	a,#1
 853  00af 81            	ret
 887                     ; 315 uint16_t FLASH_GetBootSize(void)
 887                     ; 316 {
 888                     	switch	.text
 889  00b0               _FLASH_GetBootSize:
 891  00b0 89            	pushw	x
 892       00000002      OFST:	set	2
 895                     ; 317   uint16_t temp = 0;
 897                     ; 320   temp = (uint16_t)((uint16_t)OPT->UBC * (uint16_t)128);
 899  00b1 c64802        	ld	a,18434
 900  00b4 5f            	clrw	x
 901  00b5 97            	ld	xl,a
 902  00b6 4f            	clr	a
 903  00b7 02            	rlwa	x,a
 904  00b8 44            	srl	a
 905  00b9 56            	rrcw	x
 906  00ba 1f01          	ldw	(OFST-1,sp),x
 907                     ; 323   if (OPT->UBC > 0x7F)
 909  00bc c64802        	ld	a,18434
 910  00bf a180          	cp	a,#128
 911  00c1 2505          	jrult	L173
 912                     ; 325     temp = 8192;
 914  00c3 ae2000        	ldw	x,#8192
 915  00c6 1f01          	ldw	(OFST-1,sp),x
 916  00c8               L173:
 917                     ; 329   return(temp);
 919  00c8 1e01          	ldw	x,(OFST-1,sp)
 922  00ca 5b02          	addw	sp,#2
 923  00cc 81            	ret
 957                     ; 338 uint16_t FLASH_GetCodeSize(void)
 957                     ; 339 {
 958                     	switch	.text
 959  00cd               _FLASH_GetCodeSize:
 961  00cd 89            	pushw	x
 962       00000002      OFST:	set	2
 965                     ; 340   uint16_t temp = 0;
 967                     ; 343   temp = (uint16_t)((uint16_t)OPT->PCODESIZE * (uint16_t)128);
 969  00ce c64807        	ld	a,18439
 970  00d1 5f            	clrw	x
 971  00d2 97            	ld	xl,a
 972  00d3 4f            	clr	a
 973  00d4 02            	rlwa	x,a
 974  00d5 44            	srl	a
 975  00d6 56            	rrcw	x
 976  00d7 1f01          	ldw	(OFST-1,sp),x
 977                     ; 346   if (OPT->PCODESIZE > 0x7F)
 979  00d9 c64807        	ld	a,18439
 980  00dc a180          	cp	a,#128
 981  00de 2505          	jrult	L114
 982                     ; 348     temp = 8192;
 984  00e0 ae2000        	ldw	x,#8192
 985  00e3 1f01          	ldw	(OFST-1,sp),x
 986  00e5               L114:
 987                     ; 352   return(temp);
 989  00e5 1e01          	ldw	x,(OFST-1,sp)
 992  00e7 5b02          	addw	sp,#2
 993  00e9 81            	ret
1030                     ; 361 FunctionalState FLASH_GetReadOutProtectionStatus(void)
1030                     ; 362 {
1031                     	switch	.text
1032  00ea               _FLASH_GetReadOutProtectionStatus:
1034  00ea 88            	push	a
1035       00000001      OFST:	set	1
1038                     ; 363   FunctionalState state = DISABLE;
1040                     ; 365   if (OPT->ROP == FLASH_READOUTPROTECTION_KEY)
1042  00eb c64800        	ld	a,18432
1043  00ee a1aa          	cp	a,#170
1044  00f0 2606          	jrne	L134
1045                     ; 368     state =  ENABLE;
1047  00f2 a601          	ld	a,#1
1048  00f4 6b01          	ld	(OFST+0,sp),a
1050  00f6 2002          	jra	L334
1051  00f8               L134:
1052                     ; 373     state =  DISABLE;
1054  00f8 0f01          	clr	(OFST+0,sp)
1055  00fa               L334:
1056                     ; 376   return state;
1058  00fa 7b01          	ld	a,(OFST+0,sp)
1061  00fc 5b01          	addw	sp,#1
1062  00fe 81            	ret
1171                     ; 386 FlagStatus FLASH_GetFlagStatus(FLASH_FLAG_TypeDef FLASH_FLAG)
1171                     ; 387 {
1172                     	switch	.text
1173  00ff               _FLASH_GetFlagStatus:
1175  00ff 88            	push	a
1176       00000001      OFST:	set	1
1179                     ; 388   FlagStatus status = RESET;
1181                     ; 389   assert_param(IS_FLASH_FLAGS(FLASH_FLAG));
1183                     ; 392   if ((FLASH->IAPSR  & (uint8_t)FLASH_FLAG) != (uint8_t)RESET)
1185  0100 c45054        	and	a,20564
1186  0103 2706          	jreq	L505
1187                     ; 394     status = SET; /* Flash_FLAG is set*/
1189  0105 a601          	ld	a,#1
1190  0107 6b01          	ld	(OFST+0,sp),a
1192  0109 2002          	jra	L705
1193  010b               L505:
1194                     ; 398     status = RESET; /* Flash_FLAG is reset*/
1196  010b 0f01          	clr	(OFST+0,sp)
1197  010d               L705:
1198                     ; 402   return status;
1200  010d 7b01          	ld	a,(OFST+0,sp)
1203  010f 5b01          	addw	sp,#1
1204  0111 81            	ret
1289                     ; 524 FLASH_Status_TypeDef FLASH_WaitForLastOperation(FLASH_MemType_TypeDef FLASH_MemType) IN_RAM
1289                     ; 525 {
1290                     	switch	.text
1291  0112               _FLASH_WaitForLastOperation:
1293  0112 5205          	subw	sp,#5
1294       00000005      OFST:	set	5
1297                     ; 526   uint32_t timeout = OPERATION_TIMEOUT;
1299  0114 aeffff        	ldw	x,#65535
1300  0117 1f03          	ldw	(OFST-2,sp),x
1301  0119 ae0000        	ldw	x,#0
1302  011c 1f01          	ldw	(OFST-4,sp),x
1303                     ; 527   uint8_t flagstatus = 0x00;
1305  011e 0f05          	clr	(OFST+0,sp)
1306                     ; 529   if (FLASH_MemType == FLASH_MemType_Program)
1308  0120 a1fd          	cp	a,#253
1309  0122 2631          	jrne	L765
1311  0124 2010          	jra	L555
1312  0126               L355:
1313                     ; 533       flagstatus = (uint8_t)(FLASH->IAPSR & (uint8_t)(FLASH_IAPSR_EOP |
1313                     ; 534                              FLASH_IAPSR_WR_PG_DIS));
1315  0126 c65054        	ld	a,20564
1316  0129 a405          	and	a,#5
1317  012b 6b05          	ld	(OFST+0,sp),a
1318                     ; 535       timeout--;
1320  012d 96            	ldw	x,sp
1321  012e 1c0001        	addw	x,#OFST-4
1322  0131 a601          	ld	a,#1
1323  0133 cd0000        	call	c_lgsbc
1325  0136               L555:
1326                     ; 531   while ((flagstatus == 0x00) && (timeout != 0x00))
1328  0136 0d05          	tnz	(OFST+0,sp)
1329  0138 2628          	jrne	L365
1331  013a 96            	ldw	x,sp
1332  013b 1c0001        	addw	x,#OFST-4
1333  013e cd0000        	call	c_lzmp
1335  0141 26e3          	jrne	L355
1336  0143 201d          	jra	L365
1337  0145               L565:
1338                     ; 542       flagstatus = (uint8_t)(FLASH->IAPSR & (uint8_t)(FLASH_IAPSR_HVOFF |
1338                     ; 543                              FLASH_IAPSR_WR_PG_DIS));
1340  0145 c65054        	ld	a,20564
1341  0148 a441          	and	a,#65
1342  014a 6b05          	ld	(OFST+0,sp),a
1343                     ; 544       timeout--;
1345  014c 96            	ldw	x,sp
1346  014d 1c0001        	addw	x,#OFST-4
1347  0150 a601          	ld	a,#1
1348  0152 cd0000        	call	c_lgsbc
1350  0155               L765:
1351                     ; 540     while ((flagstatus == 0x00) && (timeout != 0x00))
1353  0155 0d05          	tnz	(OFST+0,sp)
1354  0157 2609          	jrne	L365
1356  0159 96            	ldw	x,sp
1357  015a 1c0001        	addw	x,#OFST-4
1358  015d cd0000        	call	c_lzmp
1360  0160 26e3          	jrne	L565
1361  0162               L365:
1362                     ; 547   if (timeout == 0x00 )
1364  0162 96            	ldw	x,sp
1365  0163 1c0001        	addw	x,#OFST-4
1366  0166 cd0000        	call	c_lzmp
1368  0169 2604          	jrne	L575
1369                     ; 549   flagstatus = FLASH_Status_TimeOut;
1371  016b a602          	ld	a,#2
1372  016d 6b05          	ld	(OFST+0,sp),a
1373  016f               L575:
1374                     ; 552   return((FLASH_Status_TypeDef)flagstatus);
1376  016f 7b05          	ld	a,(OFST+0,sp)
1379  0171 5b05          	addw	sp,#5
1380  0173 81            	ret
1416                     ; 567 void FLASH_PowerRunModeConfig(FLASH_Power_TypeDef FLASH_Power) IN_RAM
1416                     ; 568 {
1417                     	switch	.text
1418  0174               _FLASH_PowerRunModeConfig:
1422                     ; 570   assert_param(IS_FLASH_POWER(FLASH_Power));
1424                     ; 572   if (FLASH_Power != FLASH_Power_On)
1426  0174 a101          	cp	a,#1
1427  0176 2706          	jreq	L516
1428                     ; 574   FLASH->CR1 |= (uint8_t)FLASH_CR1_EEPM;
1430  0178 72165050      	bset	20560,#3
1432  017c 2004          	jra	L716
1433  017e               L516:
1434                     ; 578     FLASH->CR1 &= (uint8_t)(~FLASH_CR1_EEPM);
1436  017e 72175050      	bres	20560,#3
1437  0182               L716:
1438                     ; 580 }
1441  0182 81            	ret
1505                     ; 593 FLASH_PowerStatus_TypeDef FLASH_GetPowerStatus(void) IN_RAM
1505                     ; 594 {
1506                     	switch	.text
1507  0183               _FLASH_GetPowerStatus:
1511                     ; 595   return((FLASH_PowerStatus_TypeDef)(FLASH->CR1 & (uint8_t)0x0C));
1513  0183 c65050        	ld	a,20560
1514  0186 a40c          	and	a,#12
1517  0188 81            	ret
1621                     ; 611 void FLASH_ProgramBlock(uint16_t BlockNum, FLASH_MemType_TypeDef FLASH_MemType,
1621                     ; 612                         FLASH_ProgramMode_TypeDef FLASH_ProgMode, uint8_t *Buffer) IN_RAM
1621                     ; 613 {
1622                     	switch	.text
1623  0189               _FLASH_ProgramBlock:
1625  0189 89            	pushw	x
1626  018a 5206          	subw	sp,#6
1627       00000006      OFST:	set	6
1630                     ; 614   uint16_t Count = 0;
1632                     ; 615   uint32_t startaddress = 0;
1634                     ; 618   assert_param(IS_FLASH_MEMORY_TYPE(FLASH_MemType));
1636                     ; 619   assert_param(IS_FLASH_PROGRAM_MODE(FLASH_ProgMode));
1638                     ; 620   if (FLASH_MemType == FLASH_MemType_Program)
1640  018c 7b0b          	ld	a,(OFST+5,sp)
1641  018e a1fd          	cp	a,#253
1642  0190 260c          	jrne	L717
1643                     ; 622   assert_param(IS_FLASH_PROGRAM_BLOCK_NUMBER(BlockNum));
1645                     ; 623     startaddress = FLASH_PROGRAM_START_PHYSICAL_ADDRESS;
1647  0192 ae8000        	ldw	x,#32768
1648  0195 1f03          	ldw	(OFST-3,sp),x
1649  0197 ae0000        	ldw	x,#0
1650  019a 1f01          	ldw	(OFST-5,sp),x
1652  019c 200a          	jra	L127
1653  019e               L717:
1654                     ; 627     assert_param(IS_FLASH_DATA_EEPROM_BLOCK_NUMBER(BlockNum));
1656                     ; 628     startaddress = FLASH_DATA_EEPROM_START_PHYSICAL_ADDRESS;
1658  019e ae1000        	ldw	x,#4096
1659  01a1 1f03          	ldw	(OFST-3,sp),x
1660  01a3 ae0000        	ldw	x,#0
1661  01a6 1f01          	ldw	(OFST-5,sp),x
1662  01a8               L127:
1663                     ; 632   startaddress = startaddress + ((uint32_t)BlockNum * FLASH_BLOCK_SIZE);
1665  01a8 1e07          	ldw	x,(OFST+1,sp)
1666  01aa a680          	ld	a,#128
1667  01ac cd0000        	call	c_cmulx
1669  01af 96            	ldw	x,sp
1670  01b0 1c0001        	addw	x,#OFST-5
1671  01b3 cd0000        	call	c_lgadd
1673                     ; 635   if (FLASH_ProgMode == FLASH_ProgramMode_Standard)
1675  01b6 0d0c          	tnz	(OFST+6,sp)
1676  01b8 2606          	jrne	L327
1677                     ; 638   FLASH->CR2 |= FLASH_CR2_PRG;
1679  01ba 72105051      	bset	20561,#0
1681  01be 2004          	jra	L527
1682  01c0               L327:
1683                     ; 643   FLASH->CR2 |= FLASH_CR2_FPRG;
1685  01c0 72185051      	bset	20561,#4
1686  01c4               L527:
1687                     ; 647   for (Count = 0; Count < FLASH_BLOCK_SIZE; Count++)
1689  01c4 5f            	clrw	x
1690  01c5 1f05          	ldw	(OFST-1,sp),x
1691  01c7               L727:
1692                     ; 650   *((PointerAttr uint8_t*) (uint16_t)startaddress + Count) = ((uint8_t)(Buffer[Count]));
1694  01c7 1e0d          	ldw	x,(OFST+7,sp)
1695  01c9 72fb05        	addw	x,(OFST-1,sp)
1696  01cc f6            	ld	a,(x)
1697  01cd 1e03          	ldw	x,(OFST-3,sp)
1698  01cf 72fb05        	addw	x,(OFST-1,sp)
1699  01d2 f7            	ld	(x),a
1700                     ; 647   for (Count = 0; Count < FLASH_BLOCK_SIZE; Count++)
1702  01d3 1e05          	ldw	x,(OFST-1,sp)
1703  01d5 1c0001        	addw	x,#1
1704  01d8 1f05          	ldw	(OFST-1,sp),x
1707  01da 1e05          	ldw	x,(OFST-1,sp)
1708  01dc a30080        	cpw	x,#128
1709  01df 25e6          	jrult	L727
1710                     ; 655 }
1713  01e1 5b08          	addw	sp,#8
1714  01e3 81            	ret
1777                     ; 668 void FLASH_EraseBlock(uint16_t BlockNum, FLASH_MemType_TypeDef FLASH_MemType) IN_RAM
1777                     ; 669 {
1778                     	switch	.text
1779  01e4               _FLASH_EraseBlock:
1781  01e4 89            	pushw	x
1782  01e5 5206          	subw	sp,#6
1783       00000006      OFST:	set	6
1786                     ; 670   uint32_t startaddress = 0;
1788                     ; 678   assert_param(IS_FLASH_MEMORY_TYPE(FLASH_MemType));
1790                     ; 679   if (FLASH_MemType == FLASH_MemType_Program)
1792  01e7 7b0b          	ld	a,(OFST+5,sp)
1793  01e9 a1fd          	cp	a,#253
1794  01eb 260c          	jrne	L767
1795                     ; 681   assert_param(IS_FLASH_PROGRAM_BLOCK_NUMBER(BlockNum));
1797                     ; 682     startaddress = FLASH_PROGRAM_START_PHYSICAL_ADDRESS;
1799  01ed ae8000        	ldw	x,#32768
1800  01f0 1f05          	ldw	(OFST-1,sp),x
1801  01f2 ae0000        	ldw	x,#0
1802  01f5 1f03          	ldw	(OFST-3,sp),x
1804  01f7 200a          	jra	L177
1805  01f9               L767:
1806                     ; 686     assert_param(IS_FLASH_DATA_EEPROM_BLOCK_NUMBER(BlockNum));
1808                     ; 687     startaddress = FLASH_DATA_EEPROM_START_PHYSICAL_ADDRESS;
1810  01f9 ae1000        	ldw	x,#4096
1811  01fc 1f05          	ldw	(OFST-1,sp),x
1812  01fe ae0000        	ldw	x,#0
1813  0201 1f03          	ldw	(OFST-3,sp),x
1814  0203               L177:
1815                     ; 692   pwFlash = (PointerAttr uint32_t *)(uint16_t)(startaddress + ((uint32_t)BlockNum * FLASH_BLOCK_SIZE));
1817  0203 1e07          	ldw	x,(OFST+1,sp)
1818  0205 a680          	ld	a,#128
1819  0207 cd0000        	call	c_cmulx
1821  020a 96            	ldw	x,sp
1822  020b 1c0003        	addw	x,#OFST-3
1823  020e cd0000        	call	c_ladd
1825  0211 be02          	ldw	x,c_lreg+2
1826  0213 1f01          	ldw	(OFST-5,sp),x
1827                     ; 698   FLASH->CR2 |= FLASH_CR2_ERASE;
1829  0215 721a5051      	bset	20561,#5
1830                     ; 701   *pwFlash = (uint32_t)0;
1832  0219 1e01          	ldw	x,(OFST-5,sp)
1833  021b a600          	ld	a,#0
1834  021d e703          	ld	(3,x),a
1835  021f a600          	ld	a,#0
1836  0221 e702          	ld	(2,x),a
1837  0223 a600          	ld	a,#0
1838  0225 e701          	ld	(1,x),a
1839  0227 a600          	ld	a,#0
1840  0229 f7            	ld	(x),a
1841                     ; 708 }
1844  022a 5b08          	addw	sp,#8
1845  022c 81            	ret
1858                     	xdef	_FLASH_EraseBlock
1859                     	xdef	_FLASH_ProgramBlock
1860                     	xdef	_FLASH_GetPowerStatus
1861                     	xdef	_FLASH_PowerRunModeConfig
1862                     	xdef	_FLASH_WaitForLastOperation
1863                     	xdef	_FLASH_GetFlagStatus
1864                     	xdef	_FLASH_PowerWaitModeConfig
1865                     	xdef	_FLASH_GetReadOutProtectionStatus
1866                     	xdef	_FLASH_GetCodeSize
1867                     	xdef	_FLASH_GetBootSize
1868                     	xdef	_FLASH_SetProgrammingTime
1869                     	xdef	_FLASH_GetProgrammingTime
1870                     	xdef	_FLASH_EraseOptionByte
1871                     	xdef	_FLASH_ProgramOptionByte
1872                     	xdef	_FLASH_ReadByte
1873                     	xdef	_FLASH_ProgramWord
1874                     	xdef	_FLASH_EraseByte
1875                     	xdef	_FLASH_ProgramByte
1876                     	xdef	_FLASH_ITConfig
1877                     	xdef	_FLASH_Lock
1878                     	xdef	_FLASH_Unlock
1879                     	xdef	_FLASH_DeInit
1880                     	xref.b	c_lreg
1899                     	xref	c_ladd
1900                     	xref	c_lgadd
1901                     	xref	c_cmulx
1902                     	xref	c_lzmp
1903                     	xref	c_lgsbc
1904                     	end
