   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Parser V4.8.32.1 - 30 Mar 2010
   3                     ; Generator V4.3.4 - 23 Mar 2010
  54                     ; 45 void LCD_DeInit(void)
  54                     ; 46 {
  56                     	switch	.text
  57  0000               _LCD_DeInit:
  59  0000 88            	push	a
  60       00000001      OFST:	set	1
  63                     ; 47   uint8_t counter = 0;
  65                     ; 49   LCD->CR1 = LCD_CR1_RESET_VALUE;
  67  0001 725f5400      	clr	21504
  68                     ; 50   LCD->CR2 = LCD_CR2_RESET_VALUE;
  70  0005 725f5401      	clr	21505
  71                     ; 51   LCD->CR3 = LCD_CR3_RESET_VALUE;
  73  0009 725f5402      	clr	21506
  74                     ; 52   LCD->FRQ = LCD_FRQ_RESET_VALUE;
  76  000d 725f5403      	clr	21507
  77                     ; 54   for (counter = 0;counter < 0x05; counter++)
  79  0011 0f01          	clr	(OFST+0,sp)
  80  0013               L72:
  81                     ; 56     LCD->PM[counter] = LCD_PM_RESET_VALUE;
  83  0013 7b01          	ld	a,(OFST+0,sp)
  84  0015 5f            	clrw	x
  85  0016 97            	ld	xl,a
  86  0017 724f5404      	clr	(21508,x)
  87                     ; 54   for (counter = 0;counter < 0x05; counter++)
  89  001b 0c01          	inc	(OFST+0,sp)
  92  001d 7b01          	ld	a,(OFST+0,sp)
  93  001f a105          	cp	a,#5
  94  0021 25f0          	jrult	L72
  95                     ; 59   for (counter = 0;counter < 0x16; counter++)
  97  0023 0f01          	clr	(OFST+0,sp)
  98  0025               L53:
  99                     ; 61     LCD->RAM[counter] =  LCD_RAM_RESET_VALUE;
 101  0025 7b01          	ld	a,(OFST+0,sp)
 102  0027 5f            	clrw	x
 103  0028 97            	ld	xl,a
 104  0029 724f540c      	clr	(21516,x)
 105                     ; 59   for (counter = 0;counter < 0x16; counter++)
 107  002d 0c01          	inc	(OFST+0,sp)
 110  002f 7b01          	ld	a,(OFST+0,sp)
 111  0031 a116          	cp	a,#22
 112  0033 25f0          	jrult	L53
 113                     ; 64   LCD->CR4 = LCD_CR4_RESET_VALUE;
 115  0035 725f542f      	clr	21551
 116                     ; 66 }
 119  0039 84            	pop	a
 120  003a 81            	ret
 523                     ; 77 void LCD_Init(LCD_Prescaler_TypeDef LCD_Prescaler, LCD_Divider_TypeDef LCD_Divider,
 523                     ; 78               LCD_Duty_TypeDef LCD_Duty, LCD_Bias_TypeDef LCD_Bias,
 523                     ; 79               LCD_VoltageSource_TypeDef LCD_VoltageSource)
 523                     ; 80 {
 524                     	switch	.text
 525  003b               _LCD_Init:
 527  003b 89            	pushw	x
 528       00000000      OFST:	set	0
 531                     ; 82   assert_param(IS_LCD_CLOCK_PRESCALER(LCD_Prescaler));
 533                     ; 83   assert_param(IS_LCD_CLOCK_DIVIDER(LCD_Divider));
 535                     ; 84   assert_param(IS_LCD_DUTY(LCD_Duty));
 537                     ; 85   assert_param(IS_LCD_BIAS(LCD_Bias));
 539                     ; 86   assert_param(IS_LCD_VOLTAGE_SOURCE(LCD_VoltageSource));
 541                     ; 88   LCD->FRQ &= (uint8_t)(~LCD_FRQ_PS);     /* Clear the prescaler bits */
 543  003c c65403        	ld	a,21507
 544  003f a40f          	and	a,#15
 545  0041 c75403        	ld	21507,a
 546                     ; 89   LCD->FRQ |= LCD_Prescaler;
 548  0044 9e            	ld	a,xh
 549  0045 ca5403        	or	a,21507
 550  0048 c75403        	ld	21507,a
 551                     ; 91   LCD->FRQ &= (uint8_t)(~LCD_FRQ_DIV);     /* Clear the divider bits */
 553  004b c65403        	ld	a,21507
 554  004e a4f0          	and	a,#240
 555  0050 c75403        	ld	21507,a
 556                     ; 92   LCD->FRQ |= LCD_Divider;
 558  0053 9f            	ld	a,xl
 559  0054 ca5403        	or	a,21507
 560  0057 c75403        	ld	21507,a
 561                     ; 95   LCD->CR1 &= (uint8_t)(~LCD_CR1_DUTY);    /* Clear the duty bits */
 563  005a c65400        	ld	a,21504
 564  005d a4f9          	and	a,#249
 565  005f c75400        	ld	21504,a
 566                     ; 96   LCD->CR4 &= (uint8_t)(~LCD_CR4_DUTY8);   /* Clear the DUTY8 bit */
 568  0062 7213542f      	bres	21551,#1
 569                     ; 98   if (LCD_Duty == LCD_Duty_1_8)
 571  0066 7b05          	ld	a,(OFST+5,sp)
 572  0068 a120          	cp	a,#32
 573  006a 260f          	jrne	L152
 574                     ; 100     LCD->CR4 |= (uint8_t)((uint8_t)((uint8_t)LCD_Duty & (uint8_t)0xF0) >> 4);
 576  006c 7b05          	ld	a,(OFST+5,sp)
 577  006e a4f0          	and	a,#240
 578  0070 4e            	swap	a
 579  0071 a40f          	and	a,#15
 580  0073 ca542f        	or	a,21551
 581  0076 c7542f        	ld	21551,a
 583  0079 200a          	jra	L352
 584  007b               L152:
 585                     ; 104     LCD->CR1 |= (uint8_t)((uint8_t)LCD_Duty & (uint8_t)0x0F);
 587  007b 7b05          	ld	a,(OFST+5,sp)
 588  007d a40f          	and	a,#15
 589  007f ca5400        	or	a,21504
 590  0082 c75400        	ld	21504,a
 591  0085               L352:
 592                     ; 108   LCD->CR1 &= (uint8_t)(~LCD_CR1_B2);      /* Clear the B2 bit */
 594  0085 72115400      	bres	21504,#0
 595                     ; 109   LCD->CR4 &= (uint8_t)(~LCD_CR4_B4);      /* Clear the B4 bit */
 597  0089 7211542f      	bres	21551,#0
 598                     ; 111   if (LCD_Bias == LCD_Bias_1_4)
 600  008d 7b06          	ld	a,(OFST+6,sp)
 601  008f a110          	cp	a,#16
 602  0091 2619          	jrne	L552
 603                     ; 113     LCD->CR1 |= (uint8_t)((uint8_t)LCD_Bias & (uint8_t)0x0F);
 605  0093 7b06          	ld	a,(OFST+6,sp)
 606  0095 a40f          	and	a,#15
 607  0097 ca5400        	or	a,21504
 608  009a c75400        	ld	21504,a
 609                     ; 114     LCD->CR4 |= (uint8_t)((uint8_t)((uint8_t)LCD_Bias & (uint8_t)0xF0) >> 4);
 611  009d 7b06          	ld	a,(OFST+6,sp)
 612  009f a4f0          	and	a,#240
 613  00a1 4e            	swap	a
 614  00a2 a40f          	and	a,#15
 615  00a4 ca542f        	or	a,21551
 616  00a7 c7542f        	ld	21551,a
 618  00aa 200a          	jra	L752
 619  00ac               L552:
 620                     ; 118     LCD->CR1 |= (uint8_t)((uint8_t)LCD_Bias & (uint8_t)0x0F);
 622  00ac 7b06          	ld	a,(OFST+6,sp)
 623  00ae a40f          	and	a,#15
 624  00b0 ca5400        	or	a,21504
 625  00b3 c75400        	ld	21504,a
 626  00b6               L752:
 627                     ; 121   LCD->CR2 &= (uint8_t)(~LCD_CR2_VSEL);    /* Clear the voltage source bit */
 629  00b6 72115401      	bres	21505,#0
 630                     ; 122   LCD->CR2 |= LCD_VoltageSource;
 632  00ba c65401        	ld	a,21505
 633  00bd 1a07          	or	a,(OFST+7,sp)
 634  00bf c75401        	ld	21505,a
 635                     ; 124 }
 638  00c2 85            	popw	x
 639  00c3 81            	ret
 694                     ; 132 void LCD_Cmd(FunctionalState NewState)
 694                     ; 133 {
 695                     	switch	.text
 696  00c4               _LCD_Cmd:
 700                     ; 135   assert_param(IS_FUNCTIONAL_STATE(NewState));
 702                     ; 137   if (NewState != DISABLE)
 704  00c4 4d            	tnz	a
 705  00c5 2706          	jreq	L703
 706                     ; 139     LCD->CR3 |= LCD_CR3_LCDEN; /* Enable the LCD peripheral*/
 708  00c7 721c5402      	bset	21506,#6
 710  00cb 2004          	jra	L113
 711  00cd               L703:
 712                     ; 143     LCD->CR3 &= (uint8_t)(~LCD_CR3_LCDEN); /* Disable the LCD peripheral*/
 714  00cd 721d5402      	bres	21506,#6
 715  00d1               L113:
 716                     ; 146 }
 719  00d1 81            	ret
 754                     ; 154 void LCD_ITConfig(FunctionalState NewState)
 754                     ; 155 {
 755                     	switch	.text
 756  00d2               _LCD_ITConfig:
 760                     ; 157   assert_param(IS_FUNCTIONAL_STATE(NewState));
 762                     ; 159   if (NewState != DISABLE)
 764  00d2 4d            	tnz	a
 765  00d3 2706          	jreq	L133
 766                     ; 161     LCD->CR3 |= LCD_CR3_SOFIE; /* Enable interrupt*/
 768  00d5 721a5402      	bset	21506,#5
 770  00d9 2004          	jra	L333
 771  00db               L133:
 772                     ; 165     LCD->CR3 &= (uint8_t)(~LCD_CR3_SOFIE); /* Disable interrupt*/
 774  00db 721b5402      	bres	21506,#5
 775  00df               L333:
 776                     ; 168 }
 779  00df 81            	ret
 814                     ; 175 void LCD_HighDriveCmd(FunctionalState NewState)
 814                     ; 176 {
 815                     	switch	.text
 816  00e0               _LCD_HighDriveCmd:
 820                     ; 178   assert_param(IS_FUNCTIONAL_STATE(NewState));
 822                     ; 180   if (NewState != DISABLE)
 824  00e0 4d            	tnz	a
 825  00e1 2706          	jreq	L353
 826                     ; 182     LCD->CR2 |= LCD_CR2_HD; /* Permanently enable low resistance divider */
 828  00e3 72185401      	bset	21505,#4
 830  00e7 2004          	jra	L553
 831  00e9               L353:
 832                     ; 186     LCD->CR2 &= (uint8_t)(~LCD_CR2_HD); /* Permanently disable low resistance divider */
 834  00e9 72195401      	bres	21505,#4
 835  00ed               L553:
 836                     ; 189 }
 839  00ed 81            	ret
 946                     ; 197 void LCD_PulseOnDurationConfig(LCD_PulseOnDuration_TypeDef LCD_PulseOnDuration)
 946                     ; 198 {
 947                     	switch	.text
 948  00ee               _LCD_PulseOnDurationConfig:
 950  00ee 88            	push	a
 951       00000000      OFST:	set	0
 954                     ; 200   assert_param(IS_LCD_PULSE_DURATION(LCD_PulseOnDuration));
 956                     ; 202   LCD->CR2 &= (uint8_t)(~LCD_CR2_PON); /* Clear the pulses on duration bits */
 958  00ef c65401        	ld	a,21505
 959  00f2 a41f          	and	a,#31
 960  00f4 c75401        	ld	21505,a
 961                     ; 203   LCD->CR2 |= LCD_PulseOnDuration;
 963  00f7 c65401        	ld	a,21505
 964  00fa 1a01          	or	a,(OFST+1,sp)
 965  00fc c75401        	ld	21505,a
 966                     ; 205 }
 969  00ff 84            	pop	a
 970  0100 81            	ret
1067                     ; 212 void LCD_DeadTimeConfig(LCD_DeadTime_TypeDef LCD_DeadTime)
1067                     ; 213 {
1068                     	switch	.text
1069  0101               _LCD_DeadTimeConfig:
1071  0101 88            	push	a
1072       00000000      OFST:	set	0
1075                     ; 215   assert_param(IS_LCD_DEAD_TIME(LCD_DeadTime));
1077                     ; 217   LCD->CR3 &= (uint8_t)(~LCD_CR3_DEAD);  /* Clear the dead time bits  */
1079  0102 c65402        	ld	a,21506
1080  0105 a4f8          	and	a,#248
1081  0107 c75402        	ld	21506,a
1082                     ; 219   LCD->CR3 |= LCD_DeadTime;
1084  010a c65402        	ld	a,21506
1085  010d 1a01          	or	a,(OFST+1,sp)
1086  010f c75402        	ld	21506,a
1087                     ; 221 }
1090  0112 84            	pop	a
1091  0113 81            	ret
1243                     ; 233 void LCD_BlinkConfig(LCD_BlinkMode_TypeDef LCD_BlinkMode,
1243                     ; 234                      LCD_BlinkFrequency_TypeDef LCD_BlinkFrequency)
1243                     ; 235 {
1244                     	switch	.text
1245  0114               _LCD_BlinkConfig:
1249                     ; 237   assert_param(IS_LCD_BLINK_MODE(LCD_BlinkMode));
1251                     ; 238   assert_param(IS_LCD_BLINK_FREQUENCY(LCD_BlinkFrequency));
1253                     ; 240   LCD->CR1 &= (uint8_t)(~LCD_CR1_BLINK); /* Clear the blink mode bits */
1255  0114 c65400        	ld	a,21504
1256  0117 a43f          	and	a,#63
1257  0119 c75400        	ld	21504,a
1258                     ; 241   LCD->CR1 |= LCD_BlinkMode; /* Config the LCD Blink Mode */
1260  011c 9e            	ld	a,xh
1261  011d ca5400        	or	a,21504
1262  0120 c75400        	ld	21504,a
1263                     ; 243   LCD->CR1 &= (uint8_t)(~LCD_CR1_BLINKF); /* Clear the blink frequency bits */
1265  0123 c65400        	ld	a,21504
1266  0126 a4c7          	and	a,#199
1267  0128 c75400        	ld	21504,a
1268                     ; 244   LCD->CR1 |= LCD_BlinkFrequency; /* Config the LCD Blink Frequency */
1270  012b 9f            	ld	a,xl
1271  012c ca5400        	or	a,21504
1272  012f c75400        	ld	21504,a
1273                     ; 246 }
1276  0132 81            	ret
1373                     ; 254 void LCD_ContrastConfig(LCD_Contrast_TypeDef LCD_Contrast)
1373                     ; 255 {
1374                     	switch	.text
1375  0133               _LCD_ContrastConfig:
1377  0133 88            	push	a
1378       00000000      OFST:	set	0
1381                     ; 257   assert_param(IS_LCD_CONTRAST(LCD_Contrast));
1383                     ; 259   LCD->CR2 &= (uint8_t)(~LCD_CR2_CC); /* Clear the contrast bits  */
1385  0134 c65401        	ld	a,21505
1386  0137 a4f1          	and	a,#241
1387  0139 c75401        	ld	21505,a
1388                     ; 260   LCD->CR2 |= LCD_Contrast; /* Select the maximum voltage value Vlcd */
1390  013c c65401        	ld	a,21505
1391  013f 1a01          	or	a,(OFST+1,sp)
1392  0141 c75401        	ld	21505,a
1393                     ; 262 }
1396  0144 84            	pop	a
1397  0145 81            	ret
1496                     ; 272 void LCD_PortMaskConfig(LCD_PortMaskRegister_TypeDef LCD_PortMaskRegister, uint8_t LCD_Mask)
1496                     ; 273 {
1497                     	switch	.text
1498  0146               _LCD_PortMaskConfig:
1500  0146 89            	pushw	x
1501       00000000      OFST:	set	0
1504                     ; 275   assert_param(IS_LCD_PORT_MASK(LCD_PortMaskRegister));
1506                     ; 278   LCD->PM[LCD_PortMaskRegister] =  LCD_Mask;
1508  0147 9e            	ld	a,xh
1509  0148 5f            	clrw	x
1510  0149 97            	ld	xl,a
1511  014a 7b02          	ld	a,(OFST+2,sp)
1512  014c d75404        	ld	(21508,x),a
1513                     ; 280 }
1516  014f 85            	popw	x
1517  0150 81            	ret
1721                     ; 290 void LCD_WriteRAM(LCD_RAMRegister_TypeDef LCD_RAMRegister, uint8_t LCD_Data)
1721                     ; 291 {
1722                     	switch	.text
1723  0151               _LCD_WriteRAM:
1725  0151 89            	pushw	x
1726       00000000      OFST:	set	0
1729                     ; 293   assert_param(IS_LCD_RAM_REGISTER(LCD_RAMRegister));
1731                     ; 296   LCD->RAM[LCD_RAMRegister] =  LCD_Data;
1733  0152 9e            	ld	a,xh
1734  0153 5f            	clrw	x
1735  0154 97            	ld	xl,a
1736  0155 7b02          	ld	a,(OFST+2,sp)
1737  0157 d7540c        	ld	(21516,x),a
1738                     ; 298 }
1741  015a 85            	popw	x
1742  015b 81            	ret
1799                     ; 307 void LCD_PageSelect(LCD_PageSelection_TypeDef LCD_PageSelection)
1799                     ; 308 {
1800                     	switch	.text
1801  015c               _LCD_PageSelect:
1805                     ; 310   assert_param(IS_LCD_PAGE_SELECT(LCD_PageSelection));
1807                     ; 312   LCD->CR4 &= (uint8_t)(~LCD_CR4_PAGECOM); /* Clear the PAGE COM bit */
1809  015c 7215542f      	bres	21551,#2
1810                     ; 313   LCD->CR4 |= LCD_PageSelection; /* Select the LCD page */
1812  0160 ca542f        	or	a,21551
1813  0163 c7542f        	ld	21551,a
1814                     ; 315 }
1817  0166 81            	ret
1873                     ; 321 FlagStatus LCD_GetFlagStatus(void)
1873                     ; 322 {
1874                     	switch	.text
1875  0167               _LCD_GetFlagStatus:
1877  0167 88            	push	a
1878       00000001      OFST:	set	1
1881                     ; 323   FlagStatus status = RESET;
1883                     ; 326   if ((LCD->CR3 & (uint8_t)LCD_CR3_SOF) != (uint8_t)RESET)
1885  0168 c65402        	ld	a,21506
1886  016b a510          	bcp	a,#16
1887  016d 2706          	jreq	L7201
1888                     ; 328     status = SET; /* Flag is set */
1890  016f a601          	ld	a,#1
1891  0171 6b01          	ld	(OFST+0,sp),a
1893  0173 2002          	jra	L1301
1894  0175               L7201:
1895                     ; 332     status = RESET; /* Flag is reset*/
1897  0175 0f01          	clr	(OFST+0,sp)
1898  0177               L1301:
1899                     ; 335   return status;
1901  0177 7b01          	ld	a,(OFST+0,sp)
1904  0179 5b01          	addw	sp,#1
1905  017b 81            	ret
1928                     ; 344 void LCD_ClearFlag(void)
1928                     ; 345 {
1929                     	switch	.text
1930  017c               _LCD_ClearFlag:
1934                     ; 347   LCD->CR3 |= (uint8_t)(LCD_CR3_SOFC);
1936  017c 72165402      	bset	21506,#3
1937                     ; 349 }
1940  0180 81            	ret
1985                     ; 356 ITStatus LCD_GetITStatus(void)
1985                     ; 357 {
1986                     	switch	.text
1987  0181               _LCD_GetITStatus:
1989  0181 88            	push	a
1990       00000001      OFST:	set	1
1993                     ; 358   ITStatus pendingbitstatus = RESET;
1995                     ; 359   uint8_t enablestatus = 0;
1997                     ; 361   enablestatus = (uint8_t)((uint8_t)LCD->CR3 & LCD_CR3_SOFIE);
1999  0182 c65402        	ld	a,21506
2000  0185 a420          	and	a,#32
2001  0187 6b01          	ld	(OFST+0,sp),a
2002                     ; 363   if (((LCD->CR3 & LCD_CR3_SOF) != RESET) && enablestatus)
2004  0189 c65402        	ld	a,21506
2005  018c a510          	bcp	a,#16
2006  018e 270a          	jreq	L5601
2008  0190 0d01          	tnz	(OFST+0,sp)
2009  0192 2706          	jreq	L5601
2010                     ; 366     pendingbitstatus = SET;
2012  0194 a601          	ld	a,#1
2013  0196 6b01          	ld	(OFST+0,sp),a
2015  0198 2002          	jra	L7601
2016  019a               L5601:
2017                     ; 371     pendingbitstatus = RESET;
2019  019a 0f01          	clr	(OFST+0,sp)
2020  019c               L7601:
2021                     ; 374   return  pendingbitstatus;
2023  019c 7b01          	ld	a,(OFST+0,sp)
2026  019e 5b01          	addw	sp,#1
2027  01a0 81            	ret
2051                     ; 383 void LCD_ClearITPendingBit(void)
2051                     ; 384 {
2052                     	switch	.text
2053  01a1               _LCD_ClearITPendingBit:
2057                     ; 386   LCD->CR3 |= (uint8_t)(LCD_CR3_SOFC);
2059  01a1 72165402      	bset	21506,#3
2060                     ; 388 }
2063  01a5 81            	ret
2076                     	xdef	_LCD_ClearITPendingBit
2077                     	xdef	_LCD_GetITStatus
2078                     	xdef	_LCD_ClearFlag
2079                     	xdef	_LCD_GetFlagStatus
2080                     	xdef	_LCD_PageSelect
2081                     	xdef	_LCD_WriteRAM
2082                     	xdef	_LCD_PortMaskConfig
2083                     	xdef	_LCD_BlinkConfig
2084                     	xdef	_LCD_ContrastConfig
2085                     	xdef	_LCD_DeadTimeConfig
2086                     	xdef	_LCD_PulseOnDurationConfig
2087                     	xdef	_LCD_HighDriveCmd
2088                     	xdef	_LCD_ITConfig
2089                     	xdef	_LCD_Cmd
2090                     	xdef	_LCD_Init
2091                     	xdef	_LCD_DeInit
2110                     	end
