   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Parser V4.8.32.1 - 30 Mar 2010
   3                     ; Generator V4.3.4 - 23 Mar 2010
 136                     ; 45 void SPI_DeInit(SPI_TypeDef* SPIx)
 136                     ; 46 {
 138                     	switch	.text
 139  0000               _SPI_DeInit:
 143                     ; 47   SPIx->CR1    = SPI_CR1_RESET_VALUE;
 145  0000 7f            	clr	(x)
 146                     ; 48   SPIx->CR2    = SPI_CR2_RESET_VALUE;
 148  0001 6f01          	clr	(1,x)
 149                     ; 49   SPIx->CR3    = SPI_CR3_RESET_VALUE;
 151  0003 6f02          	clr	(2,x)
 152                     ; 50   SPIx->SR     = SPI_SR_RESET_VALUE;
 154  0005 a602          	ld	a,#2
 155  0007 e703          	ld	(3,x),a
 156                     ; 51   SPIx->CRCPR  = SPI_CRCPR_RESET_VALUE;
 158  0009 a607          	ld	a,#7
 159  000b e705          	ld	(5,x),a
 160                     ; 52 }
 163  000d 81            	ret
 489                     ; 74 void SPI_Init(SPI_TypeDef* SPIx, SPI_FirstBit_TypeDef SPI_FirstBit,
 489                     ; 75               SPI_BaudRatePrescaler_TypeDef SPI_BaudRatePrescaler,
 489                     ; 76               SPI_Mode_TypeDef SPI_Mode, SPI_CPOL_TypeDef SPI_CPOL,
 489                     ; 77               SPI_CPHA_TypeDef SPI_CPHA, SPI_DirectionMode_TypeDef SPI_Data_Direction,
 489                     ; 78               SPI_NSS_TypeDef SPI_Slave_Management, uint8_t CRCPolynomial)
 489                     ; 79 {
 490                     	switch	.text
 491  000e               _SPI_Init:
 493  000e 89            	pushw	x
 494  000f 88            	push	a
 495       00000001      OFST:	set	1
 498                     ; 81   assert_param(IS_SPI_FIRSTBIT(SPI_FirstBit));
 500                     ; 82   assert_param(IS_SPI_BAUDRATE_PRESCALER(SPI_BaudRatePrescaler));
 502                     ; 83   assert_param(IS_SPI_MODE(SPI_Mode));
 504                     ; 84   assert_param(IS_SPI_POLARITY(SPI_CPOL));
 506                     ; 85   assert_param(IS_SPI_PHASE(SPI_CPHA));
 508                     ; 86   assert_param(IS_SPI_DATA_DIRECTION(SPI_Data_Direction));
 510                     ; 87   assert_param(IS_SPI_SLAVEMANAGEMENT(SPI_Slave_Management));
 512                     ; 88   assert_param(IS_SPI_CRC_POLYNOMIAL(CRCPolynomial));
 514                     ; 91   SPIx->CR1 = (uint8_t)((uint8_t)((uint8_t)SPI_FirstBit |
 514                     ; 92                                   (uint8_t)SPI_BaudRatePrescaler) |
 514                     ; 93                         (uint8_t)((uint8_t)SPI_CPOL |
 514                     ; 94                                   SPI_CPHA));
 516  0010 7b09          	ld	a,(OFST+8,sp)
 517  0012 1a0a          	or	a,(OFST+9,sp)
 518  0014 6b01          	ld	(OFST+0,sp),a
 519  0016 7b06          	ld	a,(OFST+5,sp)
 520  0018 1a07          	or	a,(OFST+6,sp)
 521  001a 1a01          	or	a,(OFST+0,sp)
 522  001c 1e02          	ldw	x,(OFST+1,sp)
 523  001e f7            	ld	(x),a
 524                     ; 97   SPIx->CR2 = (uint8_t)((uint8_t)(SPI_Data_Direction) | (uint8_t)(SPI_Slave_Management));
 526  001f 7b0b          	ld	a,(OFST+10,sp)
 527  0021 1a0c          	or	a,(OFST+11,sp)
 528  0023 1e02          	ldw	x,(OFST+1,sp)
 529  0025 e701          	ld	(1,x),a
 530                     ; 99   if (SPI_Mode == SPI_Mode_Master)
 532  0027 7b08          	ld	a,(OFST+7,sp)
 533  0029 a104          	cp	a,#4
 534  002b 260a          	jrne	L562
 535                     ; 101     SPIx->CR2 |= (uint8_t)SPI_CR2_SSI;
 537  002d 1e02          	ldw	x,(OFST+1,sp)
 538  002f e601          	ld	a,(1,x)
 539  0031 aa01          	or	a,#1
 540  0033 e701          	ld	(1,x),a
 542  0035 2008          	jra	L762
 543  0037               L562:
 544                     ; 105     SPIx->CR2 &= (uint8_t)~(SPI_CR2_SSI);
 546  0037 1e02          	ldw	x,(OFST+1,sp)
 547  0039 e601          	ld	a,(1,x)
 548  003b a4fe          	and	a,#254
 549  003d e701          	ld	(1,x),a
 550  003f               L762:
 551                     ; 109   SPIx->CR1 |= (uint8_t)(SPI_Mode);
 553  003f 1e02          	ldw	x,(OFST+1,sp)
 554  0041 f6            	ld	a,(x)
 555  0042 1a08          	or	a,(OFST+7,sp)
 556  0044 f7            	ld	(x),a
 557                     ; 112   SPIx->CRCPR = (uint8_t)CRCPolynomial;
 559  0045 7b0d          	ld	a,(OFST+12,sp)
 560  0047 1e02          	ldw	x,(OFST+1,sp)
 561  0049 e705          	ld	(5,x),a
 562                     ; 113 }
 565  004b 5b03          	addw	sp,#3
 566  004d 81            	ret
 633                     ; 122 void SPI_Cmd(SPI_TypeDef* SPIx, FunctionalState NewState)
 633                     ; 123 {
 634                     	switch	.text
 635  004e               _SPI_Cmd:
 637  004e 89            	pushw	x
 638       00000000      OFST:	set	0
 641                     ; 125   assert_param(IS_FUNCTIONAL_STATE(NewState));
 643                     ; 127   if (NewState != DISABLE)
 645  004f 0d05          	tnz	(OFST+5,sp)
 646  0051 2706          	jreq	L523
 647                     ; 129     SPIx->CR1 |= SPI_CR1_SPE; /* Enable the SPI peripheral*/
 649  0053 f6            	ld	a,(x)
 650  0054 aa40          	or	a,#64
 651  0056 f7            	ld	(x),a
 653  0057 2006          	jra	L723
 654  0059               L523:
 655                     ; 133     SPIx->CR1 &= (uint8_t)(~SPI_CR1_SPE); /* Disable the SPI peripheral*/
 657  0059 1e01          	ldw	x,(OFST+1,sp)
 658  005b f6            	ld	a,(x)
 659  005c a4bf          	and	a,#191
 660  005e f7            	ld	(x),a
 661  005f               L723:
 662                     ; 135 }
 665  005f 85            	popw	x
 666  0060 81            	ret
 787                     ; 145 void SPI_ITConfig(SPI_TypeDef* SPIx, SPI_IT_TypeDef SPI_IT, FunctionalState NewState)
 787                     ; 146 {
 788                     	switch	.text
 789  0061               _SPI_ITConfig:
 791  0061 89            	pushw	x
 792  0062 88            	push	a
 793       00000001      OFST:	set	1
 796                     ; 147   uint8_t itpos = 0;
 798                     ; 149   assert_param(IS_SPI_CONFIG_IT(SPI_IT));
 800                     ; 150   assert_param(IS_FUNCTIONAL_STATE(NewState));
 802                     ; 153   itpos = (uint8_t)((uint8_t)1 << (uint8_t)((uint8_t)SPI_IT & (uint8_t)0x0F));
 804  0063 7b06          	ld	a,(OFST+5,sp)
 805  0065 a40f          	and	a,#15
 806  0067 5f            	clrw	x
 807  0068 97            	ld	xl,a
 808  0069 a601          	ld	a,#1
 809  006b 5d            	tnzw	x
 810  006c 2704          	jreq	L41
 811  006e               L61:
 812  006e 48            	sll	a
 813  006f 5a            	decw	x
 814  0070 26fc          	jrne	L61
 815  0072               L41:
 816  0072 6b01          	ld	(OFST+0,sp),a
 817                     ; 155   if (NewState != DISABLE)
 819  0074 0d07          	tnz	(OFST+6,sp)
 820  0076 270a          	jreq	L704
 821                     ; 157     SPIx->CR3 |= itpos; /* Enable interrupt*/
 823  0078 1e02          	ldw	x,(OFST+1,sp)
 824  007a e602          	ld	a,(2,x)
 825  007c 1a01          	or	a,(OFST+0,sp)
 826  007e e702          	ld	(2,x),a
 828  0080 2009          	jra	L114
 829  0082               L704:
 830                     ; 161     SPIx->CR3 &= (uint8_t)(~itpos); /* Disable interrupt*/
 832  0082 1e02          	ldw	x,(OFST+1,sp)
 833  0084 7b01          	ld	a,(OFST+0,sp)
 834  0086 43            	cpl	a
 835  0087 e402          	and	a,(2,x)
 836  0089 e702          	ld	(2,x),a
 837  008b               L114:
 838                     ; 163 }
 841  008b 5b03          	addw	sp,#3
 842  008d 81            	ret
 888                     ; 170 void SPI_SendData(SPI_TypeDef* SPIx, uint8_t Data)
 888                     ; 171 {
 889                     	switch	.text
 890  008e               _SPI_SendData:
 892  008e 89            	pushw	x
 893       00000000      OFST:	set	0
 896                     ; 172   SPIx->DR = Data; /* Write in the DR register the data to be sent*/
 898  008f 7b05          	ld	a,(OFST+5,sp)
 899  0091 1e01          	ldw	x,(OFST+1,sp)
 900  0093 e704          	ld	(4,x),a
 901                     ; 173 }
 904  0095 85            	popw	x
 905  0096 81            	ret
 942                     ; 180 uint8_t SPI_ReceiveData(SPI_TypeDef* SPIx)
 942                     ; 181 {
 943                     	switch	.text
 944  0097               _SPI_ReceiveData:
 948                     ; 182   return ((uint8_t)SPIx->DR); /* Return the data in the DR register*/
 950  0097 e604          	ld	a,(4,x)
 953  0099 81            	ret
1001                     ; 192 void SPI_NSSInternalSoftwareCmd(SPI_TypeDef* SPIx, FunctionalState NewState)
1001                     ; 193 {
1002                     	switch	.text
1003  009a               _SPI_NSSInternalSoftwareCmd:
1005  009a 89            	pushw	x
1006       00000000      OFST:	set	0
1009                     ; 195   assert_param(IS_FUNCTIONAL_STATE(NewState));
1011                     ; 197   if (NewState != DISABLE)
1013  009b 0d05          	tnz	(OFST+5,sp)
1014  009d 2708          	jreq	L305
1015                     ; 199     SPIx->CR2 |= SPI_CR2_SSI; /* Set NSS pin internally by software*/
1017  009f e601          	ld	a,(1,x)
1018  00a1 aa01          	or	a,#1
1019  00a3 e701          	ld	(1,x),a
1021  00a5 2008          	jra	L505
1022  00a7               L305:
1023                     ; 203     SPIx->CR2 &= (uint8_t)(~SPI_CR2_SSI); /* Reset NSS pin internally by software*/
1025  00a7 1e01          	ldw	x,(OFST+1,sp)
1026  00a9 e601          	ld	a,(1,x)
1027  00ab a4fe          	and	a,#254
1028  00ad e701          	ld	(1,x),a
1029  00af               L505:
1030                     ; 205 }
1033  00af 85            	popw	x
1034  00b0 81            	ret
1071                     ; 212 void SPI_TransmitCRC(SPI_TypeDef* SPIx)
1071                     ; 213 {
1072                     	switch	.text
1073  00b1               _SPI_TransmitCRC:
1077                     ; 214   SPIx->CR2 |= SPI_CR2_CRCNEXT; /* Enable the CRC transmission*/
1079  00b1 e601          	ld	a,(1,x)
1080  00b3 aa10          	or	a,#16
1081  00b5 e701          	ld	(1,x),a
1082                     ; 215 }
1085  00b7 81            	ret
1134                     ; 224 void SPI_CalculateCRCCmd(SPI_TypeDef* SPIx, FunctionalState NewState)
1134                     ; 225 {
1135                     	switch	.text
1136  00b8               _SPI_CalculateCRCCmd:
1138  00b8 89            	pushw	x
1139       00000000      OFST:	set	0
1142                     ; 227   assert_param(IS_FUNCTIONAL_STATE(NewState));
1144                     ; 230   SPI_Cmd(SPI1, DISABLE);
1146  00b9 4b00          	push	#0
1147  00bb ae5200        	ldw	x,#20992
1148  00be ad8e          	call	_SPI_Cmd
1150  00c0 84            	pop	a
1151                     ; 232   if (NewState != DISABLE)
1153  00c1 0d05          	tnz	(OFST+5,sp)
1154  00c3 270a          	jreq	L355
1155                     ; 234     SPIx->CR2 |= SPI_CR2_CRCEN; /* Enable the CRC calculation*/
1157  00c5 1e01          	ldw	x,(OFST+1,sp)
1158  00c7 e601          	ld	a,(1,x)
1159  00c9 aa20          	or	a,#32
1160  00cb e701          	ld	(1,x),a
1162  00cd 2008          	jra	L555
1163  00cf               L355:
1164                     ; 238     SPIx->CR2 &= (uint8_t)(~SPI_CR2_CRCEN); /* Disable the CRC calculation*/
1166  00cf 1e01          	ldw	x,(OFST+1,sp)
1167  00d1 e601          	ld	a,(1,x)
1168  00d3 a4df          	and	a,#223
1169  00d5 e701          	ld	(1,x),a
1170  00d7               L555:
1171                     ; 240 }
1174  00d7 85            	popw	x
1175  00d8 81            	ret
1251                     ; 248 uint8_t SPI_GetCRC(SPI_TypeDef* SPIx, SPI_CRC_TypeDef SPI_CRC)
1251                     ; 249 {
1252                     	switch	.text
1253  00d9               _SPI_GetCRC:
1255  00d9 89            	pushw	x
1256  00da 88            	push	a
1257       00000001      OFST:	set	1
1260                     ; 250   uint8_t crcreg = 0;
1262                     ; 253   assert_param(IS_SPI_CRC(SPI_CRC));
1264                     ; 255   if (SPI_CRC != SPI_CRC_RX)
1266  00db 0d06          	tnz	(OFST+5,sp)
1267  00dd 2706          	jreq	L716
1268                     ; 257     crcreg = SPIx->TXCRCR;  /* Get the Tx CRC register*/
1270  00df e607          	ld	a,(7,x)
1271  00e1 6b01          	ld	(OFST+0,sp),a
1273  00e3 2006          	jra	L126
1274  00e5               L716:
1275                     ; 261     crcreg = SPIx->RXCRCR; /* Get the Rx CRC register*/
1277  00e5 1e02          	ldw	x,(OFST+1,sp)
1278  00e7 e606          	ld	a,(6,x)
1279  00e9 6b01          	ld	(OFST+0,sp),a
1280  00eb               L126:
1281                     ; 265   return crcreg;
1283  00eb 7b01          	ld	a,(OFST+0,sp)
1286  00ed 5b03          	addw	sp,#3
1287  00ef 81            	ret
1326                     ; 273 void SPI_ResetCRC(SPI_TypeDef* SPIx)
1326                     ; 274 {
1327                     	switch	.text
1328  00f0               _SPI_ResetCRC:
1330  00f0 89            	pushw	x
1331       00000000      OFST:	set	0
1334                     ; 277   SPI_CalculateCRCCmd(SPIx, ENABLE);
1336  00f1 4b01          	push	#1
1337  00f3 adc3          	call	_SPI_CalculateCRCCmd
1339  00f5 84            	pop	a
1340                     ; 280   SPI_Cmd(SPIx, ENABLE);
1342  00f6 4b01          	push	#1
1343  00f8 1e02          	ldw	x,(OFST+2,sp)
1344  00fa cd004e        	call	_SPI_Cmd
1346  00fd 84            	pop	a
1347                     ; 281 }
1350  00fe 85            	popw	x
1351  00ff 81            	ret
1389                     ; 288 uint8_t SPI_GetCRCPolynomial(SPI_TypeDef* SPIx)
1389                     ; 289 {
1390                     	switch	.text
1391  0100               _SPI_GetCRCPolynomial:
1395                     ; 290   return SPIx->CRCPR; /* Return the CRC polynomial register */
1397  0100 e605          	ld	a,(5,x)
1400  0102 81            	ret
1468                     ; 299 void SPI_BiDirectionalLineConfig(SPI_TypeDef* SPIx, SPI_Direction_TypeDef SPI_Direction)
1468                     ; 300 {
1469                     	switch	.text
1470  0103               _SPI_BiDirectionalLineConfig:
1472  0103 89            	pushw	x
1473       00000000      OFST:	set	0
1476                     ; 302   assert_param(IS_SPI_DIRECTION(SPI_Direction));
1478                     ; 304   if (SPI_Direction != SPI_Direction_Rx)
1480  0104 0d05          	tnz	(OFST+5,sp)
1481  0106 2708          	jreq	L717
1482                     ; 306     SPIx->CR2 |= SPI_CR2_BDOE; /* Set the Tx only mode*/
1484  0108 e601          	ld	a,(1,x)
1485  010a aa40          	or	a,#64
1486  010c e701          	ld	(1,x),a
1488  010e 2008          	jra	L127
1489  0110               L717:
1490                     ; 310     SPIx->CR2 &= (uint8_t)(~SPI_CR2_BDOE); /* Set the Rx only mode*/
1492  0110 1e01          	ldw	x,(OFST+1,sp)
1493  0112 e601          	ld	a,(1,x)
1494  0114 a4bf          	and	a,#191
1495  0116 e701          	ld	(1,x),a
1496  0118               L127:
1497                     ; 312 }
1500  0118 85            	popw	x
1501  0119 81            	ret
1578                     ; 322 void SPI_DMACmd(SPI_TypeDef* SPIx, SPI_DMAReq_TypeDef SPI_DMAReq, FunctionalState NewState)
1578                     ; 323 {
1579                     	switch	.text
1580  011a               _SPI_DMACmd:
1582  011a 89            	pushw	x
1583       00000000      OFST:	set	0
1586                     ; 325   assert_param(IS_FUNCTIONAL_STATE(NewState));
1588                     ; 326   assert_param(IS_SPI_DMAREQ(SPI_DMAReq));
1590                     ; 328   if (NewState != DISABLE)
1592  011b 0d06          	tnz	(OFST+6,sp)
1593  011d 2708          	jreq	L367
1594                     ; 331     SPIx->CR3 |= (uint8_t) SPI_DMAReq;
1596  011f e602          	ld	a,(2,x)
1597  0121 1a05          	or	a,(OFST+5,sp)
1598  0123 e702          	ld	(2,x),a
1600  0125 2009          	jra	L567
1601  0127               L367:
1602                     ; 336     SPIx->CR3 &= (uint8_t)~SPI_DMAReq;
1604  0127 1e01          	ldw	x,(OFST+1,sp)
1605  0129 7b05          	ld	a,(OFST+5,sp)
1606  012b 43            	cpl	a
1607  012c e402          	and	a,(2,x)
1608  012e e702          	ld	(2,x),a
1609  0130               L567:
1610                     ; 338 }
1613  0130 85            	popw	x
1614  0131 81            	ret
1747                     ; 348 FlagStatus SPI_GetFlagStatus(SPI_TypeDef* SPIx, SPI_FLAG_TypeDef SPI_FLAG)
1747                     ; 349 {
1748                     	switch	.text
1749  0132               _SPI_GetFlagStatus:
1751  0132 89            	pushw	x
1752  0133 88            	push	a
1753       00000001      OFST:	set	1
1756                     ; 350   FlagStatus status = RESET;
1758                     ; 352   assert_param(IS_SPI_FLAG(SPI_FLAG));
1760                     ; 355   if ((SPIx->SR & (uint8_t)SPI_FLAG) != (uint8_t)RESET)
1762  0134 e603          	ld	a,(3,x)
1763  0136 1506          	bcp	a,(OFST+5,sp)
1764  0138 2706          	jreq	L1501
1765                     ; 357     status = SET; /* SPI_FLAG is set */
1767  013a a601          	ld	a,#1
1768  013c 6b01          	ld	(OFST+0,sp),a
1770  013e 2002          	jra	L3501
1771  0140               L1501:
1772                     ; 361     status = RESET; /* SPI_FLAG is reset*/
1774  0140 0f01          	clr	(OFST+0,sp)
1775  0142               L3501:
1776                     ; 365   return status;
1778  0142 7b01          	ld	a,(OFST+0,sp)
1781  0144 5b03          	addw	sp,#3
1782  0146 81            	ret
1829                     ; 384 void SPI_ClearFlag(SPI_TypeDef* SPIx, SPI_FLAG_TypeDef SPI_FLAG)
1829                     ; 385 {
1830                     	switch	.text
1831  0147               _SPI_ClearFlag:
1833  0147 89            	pushw	x
1834       00000000      OFST:	set	0
1837                     ; 386   assert_param(IS_SPI_CLEAR_FLAG(SPI_FLAG));
1839                     ; 388   SPIx->SR = (uint8_t)(~SPI_FLAG);
1841  0148 7b05          	ld	a,(OFST+5,sp)
1842  014a 43            	cpl	a
1843  014b 1e01          	ldw	x,(OFST+1,sp)
1844  014d e703          	ld	(3,x),a
1845                     ; 389 }
1848  014f 85            	popw	x
1849  0150 81            	ret
1943                     ; 405 ITStatus SPI_GetITStatus(SPI_TypeDef* SPIx, SPI_IT_TypeDef SPI_IT)
1943                     ; 406 {
1944                     	switch	.text
1945  0151               _SPI_GetITStatus:
1947  0151 89            	pushw	x
1948  0152 5203          	subw	sp,#3
1949       00000003      OFST:	set	3
1952                     ; 407   ITStatus pendingbitstatus = RESET;
1954                     ; 408   uint8_t itpos = 0;
1956                     ; 409   uint8_t itmask1 = 0;
1958                     ; 410   uint8_t itmask2 = 0;
1960                     ; 411   __IO uint8_t enablestatus = 0;
1962  0154 0f02          	clr	(OFST-1,sp)
1963                     ; 412   assert_param(IS_SPI_GET_IT(SPI_IT));
1965                     ; 414   itpos = (uint8_t)((uint8_t)1 << ((uint8_t)SPI_IT & (uint8_t)0x0F));
1967  0156 7b08          	ld	a,(OFST+5,sp)
1968  0158 a40f          	and	a,#15
1969  015a 5f            	clrw	x
1970  015b 97            	ld	xl,a
1971  015c a601          	ld	a,#1
1972  015e 5d            	tnzw	x
1973  015f 2704          	jreq	L25
1974  0161               L45:
1975  0161 48            	sll	a
1976  0162 5a            	decw	x
1977  0163 26fc          	jrne	L45
1978  0165               L25:
1979  0165 6b01          	ld	(OFST-2,sp),a
1980                     ; 417   itmask1 = (uint8_t)((uint8_t)SPI_IT >> (uint8_t)4);
1982  0167 7b08          	ld	a,(OFST+5,sp)
1983  0169 4e            	swap	a
1984  016a a40f          	and	a,#15
1985  016c 6b03          	ld	(OFST+0,sp),a
1986                     ; 419   itmask2 = (uint8_t)((uint8_t)1 << itmask1);
1988  016e 7b03          	ld	a,(OFST+0,sp)
1989  0170 5f            	clrw	x
1990  0171 97            	ld	xl,a
1991  0172 a601          	ld	a,#1
1992  0174 5d            	tnzw	x
1993  0175 2704          	jreq	L65
1994  0177               L06:
1995  0177 48            	sll	a
1996  0178 5a            	decw	x
1997  0179 26fc          	jrne	L06
1998  017b               L65:
1999  017b 6b03          	ld	(OFST+0,sp),a
2000                     ; 421   enablestatus = (uint8_t)((uint8_t)SPIx->SR & itmask2);
2002  017d 1e04          	ldw	x,(OFST+1,sp)
2003  017f e603          	ld	a,(3,x)
2004  0181 1403          	and	a,(OFST+0,sp)
2005  0183 6b02          	ld	(OFST-1,sp),a
2006                     ; 423   if (((SPIx->CR3 & itpos) != RESET) && enablestatus)
2008  0185 1e04          	ldw	x,(OFST+1,sp)
2009  0187 e602          	ld	a,(2,x)
2010  0189 1501          	bcp	a,(OFST-2,sp)
2011  018b 270a          	jreq	L1511
2013  018d 0d02          	tnz	(OFST-1,sp)
2014  018f 2706          	jreq	L1511
2015                     ; 426     pendingbitstatus = SET;
2017  0191 a601          	ld	a,#1
2018  0193 6b03          	ld	(OFST+0,sp),a
2020  0195 2002          	jra	L3511
2021  0197               L1511:
2022                     ; 431     pendingbitstatus = RESET;
2024  0197 0f03          	clr	(OFST+0,sp)
2025  0199               L3511:
2026                     ; 434   return  pendingbitstatus;
2028  0199 7b03          	ld	a,(OFST+0,sp)
2031  019b 5b05          	addw	sp,#5
2032  019d 81            	ret
2089                     ; 452 void SPI_ClearITPendingBit(SPI_TypeDef* SPIx, SPI_IT_TypeDef SPI_IT)
2089                     ; 453 {
2090                     	switch	.text
2091  019e               _SPI_ClearITPendingBit:
2093  019e 89            	pushw	x
2094  019f 88            	push	a
2095       00000001      OFST:	set	1
2098                     ; 454   uint8_t itpos = 0;
2100                     ; 455   assert_param(IS_SPI_CLEAR_IT(SPI_IT));
2102                     ; 460   itpos = (uint8_t)((uint8_t)1 << (uint8_t)((uint8_t)(SPI_IT & (uint8_t)0xF0) >> 4));
2104  01a0 7b06          	ld	a,(OFST+5,sp)
2105  01a2 a4f0          	and	a,#240
2106  01a4 4e            	swap	a
2107  01a5 a40f          	and	a,#15
2108  01a7 5f            	clrw	x
2109  01a8 97            	ld	xl,a
2110  01a9 a601          	ld	a,#1
2111  01ab 5d            	tnzw	x
2112  01ac 2704          	jreq	L46
2113  01ae               L66:
2114  01ae 48            	sll	a
2115  01af 5a            	decw	x
2116  01b0 26fc          	jrne	L66
2117  01b2               L46:
2118  01b2 6b01          	ld	(OFST+0,sp),a
2119                     ; 462   SPIx->SR = (uint8_t)(~itpos);
2121  01b4 7b01          	ld	a,(OFST+0,sp)
2122  01b6 43            	cpl	a
2123  01b7 1e02          	ldw	x,(OFST+1,sp)
2124  01b9 e703          	ld	(3,x),a
2125                     ; 464 }
2128  01bb 5b03          	addw	sp,#3
2129  01bd 81            	ret
2142                     	xdef	_SPI_ClearITPendingBit
2143                     	xdef	_SPI_GetITStatus
2144                     	xdef	_SPI_ClearFlag
2145                     	xdef	_SPI_GetFlagStatus
2146                     	xdef	_SPI_DMACmd
2147                     	xdef	_SPI_BiDirectionalLineConfig
2148                     	xdef	_SPI_GetCRCPolynomial
2149                     	xdef	_SPI_ResetCRC
2150                     	xdef	_SPI_GetCRC
2151                     	xdef	_SPI_CalculateCRCCmd
2152                     	xdef	_SPI_TransmitCRC
2153                     	xdef	_SPI_NSSInternalSoftwareCmd
2154                     	xdef	_SPI_ReceiveData
2155                     	xdef	_SPI_SendData
2156                     	xdef	_SPI_ITConfig
2157                     	xdef	_SPI_Cmd
2158                     	xdef	_SPI_Init
2159                     	xdef	_SPI_DeInit
2178                     	end
