   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Parser V4.8.32.1 - 30 Mar 2010
   3                     ; Generator V4.3.4 - 23 Mar 2010
  43                     ; 46 void SYSCFG_RIDeInit(void)
  43                     ; 47 {
  45                     	switch	.text
  46  0000               _SYSCFG_RIDeInit:
  50                     ; 48   RI->ICR1   = RI_ICR1_RESET_VALUE;     /*!< Set RI->ICR1 to reset value */
  52  0000 725f5431      	clr	21553
  53                     ; 49   RI->ICR2   = RI_ICR2_RESET_VALUE;     /*!< Set RI->ICR2 to reset value */
  55  0004 725f5432      	clr	21554
  56                     ; 50   RI->IOSR1  = RI_IOSR1_RESET_VALUE;    /*!< Set RI->IOSR1 to reset value */
  58  0008 725f5439      	clr	21561
  59                     ; 51   RI->IOSR2  = RI_IOSR2_RESET_VALUE;    /*!< Set RI->IOSR2 to reset value */
  61  000c 725f543a      	clr	21562
  62                     ; 52   RI->IOSR3  = RI_IOSR3_RESET_VALUE;    /*!< Set RI->IOSR3 to reset value */
  64  0010 725f543b      	clr	21563
  65                     ; 53   RI->ASCR1  = RI_ASCR1_RESET_VALUE;    /*!< Set RI->ASCR1 to reset value */
  67  0014 725f543d      	clr	21565
  68                     ; 54   RI->ASCR2  = RI_ASCR2_RESET_VALUE;    /*!< Set RI->ASCR2 to reset value */
  70  0018 725f543e      	clr	21566
  71                     ; 55   RI->RCR    = RI_RCR_RESET_VALUE;      /*!< Set RI->RCR to reset value */
  73  001c 725f543f      	clr	21567
  74                     ; 56 }
  77  0020 81            	ret
 336                     ; 68 void SYSCFG_RITIMInputCaptureConfig(RI_InputCapture_TypeDef RI_InputCapture,
 336                     ; 69                                     RI_InputCaptureRouting_TypeDef RI_InputCaptureRouting)
 336                     ; 70 {
 337                     	switch	.text
 338  0021               _SYSCFG_RITIMInputCaptureConfig:
 340  0021 89            	pushw	x
 341       00000000      OFST:	set	0
 344                     ; 72   assert_param(IS_RI_INPUTCAPTURE(RI_InputCapture));
 346                     ; 73   assert_param(IS_RI_INPUTCAPTUREROUTING(RI_InputCaptureRouting));
 348                     ; 76   if (RI_InputCapture == RI_InputCapture_IC2)
 350  0022 9e            	ld	a,xh
 351  0023 a102          	cp	a,#2
 352  0025 2606          	jrne	L531
 353                     ; 79     RI->ICR1 = (uint8_t) RI_InputCaptureRouting;
 355  0027 9f            	ld	a,xl
 356  0028 c75431        	ld	21553,a
 358  002b 2005          	jra	L731
 359  002d               L531:
 360                     ; 85     RI->ICR2 = (uint8_t) RI_InputCaptureRouting;
 362  002d 7b02          	ld	a,(OFST+2,sp)
 363  002f c75432        	ld	21554,a
 364  0032               L731:
 365                     ; 87 }
 368  0032 85            	popw	x
 369  0033 81            	ret
 551                     ; 96 void SYSCFG_RIAnalogSwitchConfig(RI_AnalogSwitch_TypeDef RI_AnalogSwitch,
 551                     ; 97                                  FunctionalState NewState)
 551                     ; 98 {
 552                     	switch	.text
 553  0034               _SYSCFG_RIAnalogSwitchConfig:
 555  0034 89            	pushw	x
 556  0035 89            	pushw	x
 557       00000002      OFST:	set	2
 560                     ; 99   uint8_t AnalogSwitchRegister, AnalogSwitchIndex = 0;
 562                     ; 102   assert_param(IS_RI_ANALOGSWITCH(RI_AnalogSwitch));
 564                     ; 103   assert_param(IS_FUNCTIONAL_STATE(NewState));
 566                     ; 106   AnalogSwitchRegister = (uint8_t) (RI_AnalogSwitch & (uint8_t) 0xF0);
 568  0036 9e            	ld	a,xh
 569  0037 a4f0          	and	a,#240
 570  0039 6b01          	ld	(OFST-1,sp),a
 571                     ; 109   AnalogSwitchIndex = (uint8_t) (RI_AnalogSwitch & (uint8_t) 0x0F);
 573  003b 7b03          	ld	a,(OFST+1,sp)
 574  003d a40f          	and	a,#15
 575  003f 6b02          	ld	(OFST+0,sp),a
 576                     ; 111   if (NewState != DISABLE)
 578  0041 0d04          	tnz	(OFST+2,sp)
 579  0043 2730          	jreq	L142
 580                     ; 113     if (AnalogSwitchRegister == (uint8_t) 0x10)
 582  0045 7b01          	ld	a,(OFST-1,sp)
 583  0047 a110          	cp	a,#16
 584  0049 2615          	jrne	L342
 585                     ; 116       RI->ASCR1 |= (uint8_t) ((uint8_t)1 << (uint8_t) AnalogSwitchIndex);
 587  004b 7b02          	ld	a,(OFST+0,sp)
 588  004d 5f            	clrw	x
 589  004e 97            	ld	xl,a
 590  004f a601          	ld	a,#1
 591  0051 5d            	tnzw	x
 592  0052 2704          	jreq	L21
 593  0054               L41:
 594  0054 48            	sll	a
 595  0055 5a            	decw	x
 596  0056 26fc          	jrne	L41
 597  0058               L21:
 598  0058 ca543d        	or	a,21565
 599  005b c7543d        	ld	21565,a
 601  005e 2045          	jra	L742
 602  0060               L342:
 603                     ; 121       RI->ASCR2 |= (uint8_t) ((uint8_t)1 << (uint8_t) AnalogSwitchIndex);
 605  0060 7b02          	ld	a,(OFST+0,sp)
 606  0062 5f            	clrw	x
 607  0063 97            	ld	xl,a
 608  0064 a601          	ld	a,#1
 609  0066 5d            	tnzw	x
 610  0067 2704          	jreq	L61
 611  0069               L02:
 612  0069 48            	sll	a
 613  006a 5a            	decw	x
 614  006b 26fc          	jrne	L02
 615  006d               L61:
 616  006d ca543e        	or	a,21566
 617  0070 c7543e        	ld	21566,a
 618  0073 2030          	jra	L742
 619  0075               L142:
 620                     ; 126     if (AnalogSwitchRegister == (uint8_t) 0x10)
 622  0075 7b01          	ld	a,(OFST-1,sp)
 623  0077 a110          	cp	a,#16
 624  0079 2616          	jrne	L152
 625                     ; 129       RI->ASCR1 &= (uint8_t) (~(uint8_t)((uint8_t)1 <<  AnalogSwitchIndex));
 627  007b 7b02          	ld	a,(OFST+0,sp)
 628  007d 5f            	clrw	x
 629  007e 97            	ld	xl,a
 630  007f a601          	ld	a,#1
 631  0081 5d            	tnzw	x
 632  0082 2704          	jreq	L22
 633  0084               L42:
 634  0084 48            	sll	a
 635  0085 5a            	decw	x
 636  0086 26fc          	jrne	L42
 637  0088               L22:
 638  0088 43            	cpl	a
 639  0089 c4543d        	and	a,21565
 640  008c c7543d        	ld	21565,a
 642  008f 2014          	jra	L742
 643  0091               L152:
 644                     ; 134       RI->ASCR2 &= (uint8_t) (~ (uint8_t)((uint8_t)1 << AnalogSwitchIndex));
 646  0091 7b02          	ld	a,(OFST+0,sp)
 647  0093 5f            	clrw	x
 648  0094 97            	ld	xl,a
 649  0095 a601          	ld	a,#1
 650  0097 5d            	tnzw	x
 651  0098 2704          	jreq	L62
 652  009a               L03:
 653  009a 48            	sll	a
 654  009b 5a            	decw	x
 655  009c 26fc          	jrne	L03
 656  009e               L62:
 657  009e 43            	cpl	a
 658  009f c4543e        	and	a,21566
 659  00a2 c7543e        	ld	21566,a
 660  00a5               L742:
 661                     ; 137 }
 664  00a5 5b04          	addw	sp,#4
 665  00a7 81            	ret
 903                     ; 146 void SYSCFG_RIIOSwitchConfig(RI_IOSwitch_TypeDef RI_IOSwitch,
 903                     ; 147                              FunctionalState NewState)
 903                     ; 148 {
 904                     	switch	.text
 905  00a8               _SYSCFG_RIIOSwitchConfig:
 907  00a8 89            	pushw	x
 908  00a9 89            	pushw	x
 909       00000002      OFST:	set	2
 912                     ; 149   uint8_t IOSwitchRegsiter, IOSwitchIndex = 0;
 914                     ; 152   assert_param(IS_RI_IOSWITCH(RI_IOSwitch));
 916                     ; 153   assert_param(IS_FUNCTIONAL_STATE(NewState));
 918                     ; 156   IOSwitchIndex = (uint8_t) (RI_IOSwitch & (uint8_t) 0x0F);
 920  00aa 9e            	ld	a,xh
 921  00ab a40f          	and	a,#15
 922  00ad 6b02          	ld	(OFST+0,sp),a
 923                     ; 159   IOSwitchRegsiter = (uint8_t) (RI_IOSwitch & (uint8_t) 0xF0);
 925  00af 7b03          	ld	a,(OFST+1,sp)
 926  00b1 a4f0          	and	a,#240
 927  00b3 6b01          	ld	(OFST-1,sp),a
 928                     ; 162   if (IOSwitchRegsiter == (uint8_t) 0x10)
 930  00b5 7b01          	ld	a,(OFST-1,sp)
 931  00b7 a110          	cp	a,#16
 932  00b9 262f          	jrne	L373
 933                     ; 164     if (NewState != DISABLE)
 935  00bb 0d04          	tnz	(OFST+2,sp)
 936  00bd 2715          	jreq	L573
 937                     ; 167       RI->IOSR1 |= (uint8_t) ((uint8_t)1 << IOSwitchIndex);
 939  00bf 7b02          	ld	a,(OFST+0,sp)
 940  00c1 5f            	clrw	x
 941  00c2 97            	ld	xl,a
 942  00c3 a601          	ld	a,#1
 943  00c5 5d            	tnzw	x
 944  00c6 2704          	jreq	L43
 945  00c8               L63:
 946  00c8 48            	sll	a
 947  00c9 5a            	decw	x
 948  00ca 26fc          	jrne	L63
 949  00cc               L43:
 950  00cc ca5439        	or	a,21561
 951  00cf c75439        	ld	21561,a
 953  00d2 2078          	jra	L104
 954  00d4               L573:
 955                     ; 172       RI->IOSR1 &= (uint8_t) (~ (uint8_t)((uint8_t)1 << IOSwitchIndex));
 957  00d4 7b02          	ld	a,(OFST+0,sp)
 958  00d6 5f            	clrw	x
 959  00d7 97            	ld	xl,a
 960  00d8 a601          	ld	a,#1
 961  00da 5d            	tnzw	x
 962  00db 2704          	jreq	L04
 963  00dd               L24:
 964  00dd 48            	sll	a
 965  00de 5a            	decw	x
 966  00df 26fc          	jrne	L24
 967  00e1               L04:
 968  00e1 43            	cpl	a
 969  00e2 c45439        	and	a,21561
 970  00e5 c75439        	ld	21561,a
 971  00e8 2062          	jra	L104
 972  00ea               L373:
 973                     ; 177   else if (IOSwitchRegsiter == (uint8_t) 0x20)
 975  00ea 7b01          	ld	a,(OFST-1,sp)
 976  00ec a120          	cp	a,#32
 977  00ee 262f          	jrne	L304
 978                     ; 179     if (NewState != DISABLE)
 980  00f0 0d04          	tnz	(OFST+2,sp)
 981  00f2 2715          	jreq	L504
 982                     ; 182       RI->IOSR2 |= (uint8_t) ((uint8_t)1 << IOSwitchIndex);
 984  00f4 7b02          	ld	a,(OFST+0,sp)
 985  00f6 5f            	clrw	x
 986  00f7 97            	ld	xl,a
 987  00f8 a601          	ld	a,#1
 988  00fa 5d            	tnzw	x
 989  00fb 2704          	jreq	L44
 990  00fd               L64:
 991  00fd 48            	sll	a
 992  00fe 5a            	decw	x
 993  00ff 26fc          	jrne	L64
 994  0101               L44:
 995  0101 ca543a        	or	a,21562
 996  0104 c7543a        	ld	21562,a
 998  0107 2043          	jra	L104
 999  0109               L504:
1000                     ; 187       RI->IOSR2 &= (uint8_t) (~(uint8_t)((uint8_t)1 <<  IOSwitchIndex));
1002  0109 7b02          	ld	a,(OFST+0,sp)
1003  010b 5f            	clrw	x
1004  010c 97            	ld	xl,a
1005  010d a601          	ld	a,#1
1006  010f 5d            	tnzw	x
1007  0110 2704          	jreq	L05
1008  0112               L25:
1009  0112 48            	sll	a
1010  0113 5a            	decw	x
1011  0114 26fc          	jrne	L25
1012  0116               L05:
1013  0116 43            	cpl	a
1014  0117 c4543a        	and	a,21562
1015  011a c7543a        	ld	21562,a
1016  011d 202d          	jra	L104
1017  011f               L304:
1018                     ; 194     if (NewState != DISABLE)
1020  011f 0d04          	tnz	(OFST+2,sp)
1021  0121 2715          	jreq	L314
1022                     ; 197       RI->IOSR3 |= (uint8_t) ((uint8_t)1 << IOSwitchIndex);
1024  0123 7b02          	ld	a,(OFST+0,sp)
1025  0125 5f            	clrw	x
1026  0126 97            	ld	xl,a
1027  0127 a601          	ld	a,#1
1028  0129 5d            	tnzw	x
1029  012a 2704          	jreq	L45
1030  012c               L65:
1031  012c 48            	sll	a
1032  012d 5a            	decw	x
1033  012e 26fc          	jrne	L65
1034  0130               L45:
1035  0130 ca543b        	or	a,21563
1036  0133 c7543b        	ld	21563,a
1038  0136 2014          	jra	L104
1039  0138               L314:
1040                     ; 202       RI->IOSR3 &= (uint8_t) (~ (uint8_t) ((uint8_t) 1 << IOSwitchIndex));
1042  0138 7b02          	ld	a,(OFST+0,sp)
1043  013a 5f            	clrw	x
1044  013b 97            	ld	xl,a
1045  013c a601          	ld	a,#1
1046  013e 5d            	tnzw	x
1047  013f 2704          	jreq	L06
1048  0141               L26:
1049  0141 48            	sll	a
1050  0142 5a            	decw	x
1051  0143 26fc          	jrne	L26
1052  0145               L06:
1053  0145 43            	cpl	a
1054  0146 c4543b        	and	a,21563
1055  0149 c7543b        	ld	21563,a
1056  014c               L104:
1057                     ; 205 }
1060  014c 5b04          	addw	sp,#4
1061  014e 81            	ret
1141                     ; 213 void SYSCFG_RIResistorConfig(RI_Resistor_TypeDef RI_Resistor, FunctionalState NewState)
1141                     ; 214 {
1142                     	switch	.text
1143  014f               _SYSCFG_RIResistorConfig:
1145  014f 89            	pushw	x
1146       00000000      OFST:	set	0
1149                     ; 216   assert_param(IS_RI_RESISTOR(RI_Resistor));
1151                     ; 217   assert_param(IS_FUNCTIONAL_STATE(NewState));
1153                     ; 219   if (NewState != DISABLE)
1155  0150 9f            	ld	a,xl
1156  0151 4d            	tnz	a
1157  0152 2709          	jreq	L554
1158                     ; 222     RI->RCR |= (uint8_t) RI_Resistor;
1160  0154 9e            	ld	a,xh
1161  0155 ca543f        	or	a,21567
1162  0158 c7543f        	ld	21567,a
1164  015b 2009          	jra	L754
1165  015d               L554:
1166                     ; 227     RI->RCR &= (uint8_t) (~RI_Resistor);
1168  015d 7b01          	ld	a,(OFST+1,sp)
1169  015f 43            	cpl	a
1170  0160 c4543f        	and	a,21567
1171  0163 c7543f        	ld	21567,a
1172  0166               L754:
1173                     ; 229 }
1176  0166 85            	popw	x
1177  0167 81            	ret
1200                     ; 236 void SYSCFG_REMAPDeInit(void)
1200                     ; 237 {
1201                     	switch	.text
1202  0168               _SYSCFG_REMAPDeInit:
1206                     ; 239   SYSCFG->RMPCR1 = SYSCFG_RMPCR1_RESET_VALUE;
1208  0168 350c509e      	mov	20638,#12
1209                     ; 242   SYSCFG->RMPCR2 = SYSCFG_RMPCR2_RESET_VALUE;
1211  016c 725f509f      	clr	20639
1212                     ; 245   SYSCFG->RMPCR3 = SYSCFG_RMPCR3_RESET_VALUE;
1214  0170 725f509d      	clr	20637
1215                     ; 246 }
1218  0174 81            	ret
1420                     ; 255 void SYSCFG_REMAPPinConfig(REMAP_Pin_TypeDef REMAP_Pin, FunctionalState NewState)
1420                     ; 256 {
1421                     	switch	.text
1422  0175               _SYSCFG_REMAPPinConfig:
1424  0175 89            	pushw	x
1425  0176 88            	push	a
1426       00000001      OFST:	set	1
1429                     ; 257   uint8_t regindex = 0;
1431                     ; 259   assert_param(IS_REMAP_PIN(REMAP_Pin));
1433                     ; 260   assert_param(IS_FUNCTIONAL_STATE(NewState));
1435                     ; 263   regindex = (uint8_t) ((uint16_t) REMAP_Pin >> 8);
1437  0177 9e            	ld	a,xh
1438  0178 6b01          	ld	(OFST+0,sp),a
1439                     ; 266   if (regindex == 0x01)
1441  017a 7b01          	ld	a,(OFST+0,sp)
1442  017c a101          	cp	a,#1
1443  017e 261e          	jrne	L765
1444                     ; 268     SYSCFG->RMPCR1 &= (uint8_t)((uint8_t)((uint8_t)REMAP_Pin << 4) | (uint8_t)0x0F);
1446  0180 9f            	ld	a,xl
1447  0181 97            	ld	xl,a
1448  0182 a610          	ld	a,#16
1449  0184 42            	mul	x,a
1450  0185 9f            	ld	a,xl
1451  0186 aa0f          	or	a,#15
1452  0188 c4509e        	and	a,20638
1453  018b c7509e        	ld	20638,a
1454                     ; 269     if (NewState != DISABLE)
1456  018e 0d06          	tnz	(OFST+5,sp)
1457  0190 2742          	jreq	L375
1458                     ; 271       SYSCFG->RMPCR1 |= (uint8_t)((uint16_t)REMAP_Pin & (uint16_t)0x00F0);
1460  0192 7b03          	ld	a,(OFST+2,sp)
1461  0194 a4f0          	and	a,#240
1462  0196 ca509e        	or	a,20638
1463  0199 c7509e        	ld	20638,a
1464  019c 2036          	jra	L375
1465  019e               L765:
1466                     ; 275   else if (regindex == 0x02)
1468  019e 7b01          	ld	a,(OFST+0,sp)
1469  01a0 a102          	cp	a,#2
1470  01a2 2619          	jrne	L575
1471                     ; 277     if (NewState != DISABLE)
1473  01a4 0d06          	tnz	(OFST+5,sp)
1474  01a6 270a          	jreq	L775
1475                     ; 279       SYSCFG->RMPCR2 |= (uint8_t) REMAP_Pin;
1477  01a8 c6509f        	ld	a,20639
1478  01ab 1a03          	or	a,(OFST+2,sp)
1479  01ad c7509f        	ld	20639,a
1481  01b0 2022          	jra	L375
1482  01b2               L775:
1483                     ; 283       SYSCFG->RMPCR2 &= (uint8_t)((uint16_t)(~(uint16_t)REMAP_Pin));
1485  01b2 7b03          	ld	a,(OFST+2,sp)
1486  01b4 43            	cpl	a
1487  01b5 c4509f        	and	a,20639
1488  01b8 c7509f        	ld	20639,a
1489  01bb 2017          	jra	L375
1490  01bd               L575:
1491                     ; 289     if (NewState != DISABLE)
1493  01bd 0d06          	tnz	(OFST+5,sp)
1494  01bf 270a          	jreq	L506
1495                     ; 291       SYSCFG->RMPCR3 |= (uint8_t) REMAP_Pin;
1497  01c1 c6509d        	ld	a,20637
1498  01c4 1a03          	or	a,(OFST+2,sp)
1499  01c6 c7509d        	ld	20637,a
1501  01c9 2009          	jra	L375
1502  01cb               L506:
1503                     ; 295       SYSCFG->RMPCR3 &= (uint8_t)((uint16_t)(~(uint16_t)REMAP_Pin));
1505  01cb 7b03          	ld	a,(OFST+2,sp)
1506  01cd 43            	cpl	a
1507  01ce c4509d        	and	a,20637
1508  01d1 c7509d        	ld	20637,a
1509  01d4               L375:
1510                     ; 298 }
1513  01d4 5b03          	addw	sp,#3
1514  01d6 81            	ret
1620                     ; 306 void SYSCFG_REMAPDMAChannelConfig(REMAP_DMAChannel_TypeDef REMAP_DMAChannel)
1620                     ; 307 {
1621                     	switch	.text
1622  01d7               _SYSCFG_REMAPDMAChannelConfig:
1624  01d7 88            	push	a
1625       00000000      OFST:	set	0
1628                     ; 309   assert_param(IS_REMAP_DMACHANNEL(REMAP_DMAChannel));
1630                     ; 312   if ((REMAP_DMAChannel & 0xF0) != RESET)
1632  01d8 a5f0          	bcp	a,#240
1633  01da 270a          	jreq	L356
1634                     ; 315     SYSCFG->RMPCR1 &= (uint8_t) (~SYSCFG_RMPCR1_TIM4DMA_REMAP);
1636  01dc c6509e        	ld	a,20638
1637  01df a4f3          	and	a,#243
1638  01e1 c7509e        	ld	20638,a
1640  01e4 2008          	jra	L556
1641  01e6               L356:
1642                     ; 321     SYSCFG->RMPCR1 &= (uint8_t) (~SYSCFG_RMPCR1_ADC1DMA_REMAP);
1644  01e6 c6509e        	ld	a,20638
1645  01e9 a4fc          	and	a,#252
1646  01eb c7509e        	ld	20638,a
1647  01ee               L556:
1648                     ; 324   SYSCFG->RMPCR1 |= (uint8_t) ((uint8_t)0x0F & REMAP_DMAChannel);
1650  01ee 7b01          	ld	a,(OFST+1,sp)
1651  01f0 a40f          	and	a,#15
1652  01f2 ca509e        	or	a,20638
1653  01f5 c7509e        	ld	20638,a
1654                     ; 325 }
1657  01f8 84            	pop	a
1658  01f9 81            	ret
1671                     	xdef	_SYSCFG_REMAPDMAChannelConfig
1672                     	xdef	_SYSCFG_REMAPPinConfig
1673                     	xdef	_SYSCFG_REMAPDeInit
1674                     	xdef	_SYSCFG_RIResistorConfig
1675                     	xdef	_SYSCFG_RIIOSwitchConfig
1676                     	xdef	_SYSCFG_RIAnalogSwitchConfig
1677                     	xdef	_SYSCFG_RITIMInputCaptureConfig
1678                     	xdef	_SYSCFG_RIDeInit
1697                     	end
