   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Parser V4.8.32.1 - 30 Mar 2010
   3                     ; Generator V4.3.4 - 23 Mar 2010
 163                     ; 47 void USART_DeInit(USART_TypeDef* USARTx)
 163                     ; 48 {
 165                     	switch	.text
 166  0000               _USART_DeInit:
 170                     ; 52   (void) USARTx->SR;
 172  0000 f6            	ld	a,(x)
 173                     ; 53   (void) USARTx->DR;
 175  0001 e601          	ld	a,(1,x)
 176                     ; 55   USARTx->BRR2 = USART_BRR2_RESET_VALUE;  /* Set USART_BRR2 to reset value 0x00 */
 178  0003 6f03          	clr	(3,x)
 179                     ; 56   USARTx->BRR1 = USART_BRR1_RESET_VALUE;  /* Set USART_BRR1 to reset value 0x00 */
 181  0005 6f02          	clr	(2,x)
 182                     ; 58   USARTx->CR1 = USART_CR1_RESET_VALUE;  /* Set USART_CR1 to reset value 0x00 */
 184  0007 6f04          	clr	(4,x)
 185                     ; 59   USARTx->CR2 = USART_CR2_RESET_VALUE;  /* Set USART_CR2 to reset value 0x00 */
 187  0009 6f05          	clr	(5,x)
 188                     ; 60   USARTx->CR3 = USART_CR3_RESET_VALUE;  /* Set USART_CR3 to reset value 0x00 */
 190  000b 6f06          	clr	(6,x)
 191                     ; 61   USARTx->CR4 = USART_CR4_RESET_VALUE;  /* Set USART_CR4 to reset value 0x00 */
 193  000d 6f07          	clr	(7,x)
 194                     ; 62 }
 197  000f 81            	ret
 389                     ; 80 void USART_Init(USART_TypeDef* USARTx, uint32_t BaudRate, USART_WordLength_TypeDef
 389                     ; 81                 USART_WordLength, USART_StopBits_TypeDef USART_StopBits,
 389                     ; 82                 USART_Parity_TypeDef USART_Parity,  USART_Mode_TypeDef USART_Mode)
 389                     ; 83 {
 390                     	switch	.text
 391  0010               _USART_Init:
 393  0010 89            	pushw	x
 394  0011 5204          	subw	sp,#4
 395       00000004      OFST:	set	4
 398                     ; 84   uint32_t BaudRate_Mantissa = 0;
 400                     ; 87   assert_param(IS_USART_BAUDRATE(BaudRate));
 402                     ; 89   assert_param(IS_USART_WORDLENGTH(USART_WordLength));
 404                     ; 91   assert_param(IS_USART_STOPBITS(USART_StopBits));
 406                     ; 93   assert_param(IS_USART_PARITY(USART_Parity));
 408                     ; 95   assert_param(IS_USART_MODE(USART_Mode));
 410                     ; 98   USARTx->CR1 &= (uint8_t)(~(USART_CR1_PCEN | USART_CR1_PS | USART_CR1_M));
 412  0013 e604          	ld	a,(4,x)
 413  0015 a4e9          	and	a,#233
 414  0017 e704          	ld	(4,x),a
 415                     ; 101   USARTx->CR1 |= (uint8_t)((uint8_t)USART_WordLength | (uint8_t)USART_Parity);
 417  0019 7b0d          	ld	a,(OFST+9,sp)
 418  001b 1a0f          	or	a,(OFST+11,sp)
 419  001d ea04          	or	a,(4,x)
 420  001f e704          	ld	(4,x),a
 421                     ; 104   USARTx->CR3 &= (uint8_t)(~USART_CR3_STOP);
 423  0021 e606          	ld	a,(6,x)
 424  0023 a4cf          	and	a,#207
 425  0025 e706          	ld	(6,x),a
 426                     ; 106   USARTx->CR3 |= (uint8_t)USART_StopBits;
 428  0027 e606          	ld	a,(6,x)
 429  0029 1a0e          	or	a,(OFST+10,sp)
 430  002b e706          	ld	(6,x),a
 431                     ; 109   USARTx->BRR1 &= (uint8_t)(~USART_BRR1_DIVM);
 433  002d 6f02          	clr	(2,x)
 434                     ; 111   USARTx->BRR2 &= (uint8_t)(~USART_BRR2_DIVM);
 436  002f e603          	ld	a,(3,x)
 437  0031 a40f          	and	a,#15
 438  0033 e703          	ld	(3,x),a
 439                     ; 113   USARTx->BRR2 &= (uint8_t)(~USART_BRR2_DIVF);
 441  0035 e603          	ld	a,(3,x)
 442  0037 a4f0          	and	a,#240
 443  0039 e703          	ld	(3,x),a
 444                     ; 115   BaudRate_Mantissa  = (uint32_t)(CLK_GetClockFreq() / BaudRate );
 446  003b cd0000        	call	_CLK_GetClockFreq
 448  003e 96            	ldw	x,sp
 449  003f 1c0009        	addw	x,#OFST+5
 450  0042 cd0000        	call	c_ludv
 452  0045 96            	ldw	x,sp
 453  0046 1c0001        	addw	x,#OFST-3
 454  0049 cd0000        	call	c_rtol
 456                     ; 117   USARTx->BRR2 = (uint8_t)((BaudRate_Mantissa >> (uint8_t)8) & (uint8_t)0xF0);
 458  004c 7b03          	ld	a,(OFST-1,sp)
 459  004e a4f0          	and	a,#240
 460  0050 1e05          	ldw	x,(OFST+1,sp)
 461  0052 e703          	ld	(3,x),a
 462                     ; 119   USARTx->BRR2 |= (uint8_t)(BaudRate_Mantissa & (uint8_t)0x0F);
 464  0054 1e05          	ldw	x,(OFST+1,sp)
 465  0056 7b04          	ld	a,(OFST+0,sp)
 466  0058 a40f          	and	a,#15
 467  005a ea03          	or	a,(3,x)
 468  005c e703          	ld	(3,x),a
 469                     ; 121   USARTx->BRR1 = (uint8_t)(BaudRate_Mantissa >> (uint8_t)4);
 471  005e 96            	ldw	x,sp
 472  005f 1c0001        	addw	x,#OFST-3
 473  0062 cd0000        	call	c_ltor
 475  0065 a604          	ld	a,#4
 476  0067 cd0000        	call	c_lursh
 478  006a b603          	ld	a,c_lreg+3
 479  006c 1e05          	ldw	x,(OFST+1,sp)
 480  006e e702          	ld	(2,x),a
 481                     ; 124   USARTx->CR2 &= (uint8_t)~(USART_CR2_TEN | USART_CR2_REN);
 483  0070 1e05          	ldw	x,(OFST+1,sp)
 484  0072 e605          	ld	a,(5,x)
 485  0074 a4f3          	and	a,#243
 486  0076 e705          	ld	(5,x),a
 487                     ; 126   USARTx->CR2 |= (uint8_t)USART_Mode;
 489  0078 1e05          	ldw	x,(OFST+1,sp)
 490  007a e605          	ld	a,(5,x)
 491  007c 1a10          	or	a,(OFST+12,sp)
 492  007e e705          	ld	(5,x),a
 493                     ; 127 }
 496  0080 5b06          	addw	sp,#6
 497  0082 81            	ret
 657                     ; 143 void USART_ClockInit(USART_TypeDef* USARTx, USART_Clock_TypeDef USART_Clock,
 657                     ; 144                      USART_CPOL_TypeDef USART_CPOL, USART_CPHA_TypeDef USART_CPHA,
 657                     ; 145                      USART_LastBit_TypeDef USART_LastBit)
 657                     ; 146 {
 658                     	switch	.text
 659  0083               _USART_ClockInit:
 661  0083 89            	pushw	x
 662       00000000      OFST:	set	0
 665                     ; 148   assert_param(IS_USART_CLOCK(USART_Clock));
 667                     ; 149   assert_param(IS_USART_CPOL(USART_CPOL));
 669                     ; 150   assert_param(IS_USART_CPHA(USART_CPHA));
 671                     ; 151   assert_param(IS_USART_LASTBIT(USART_LastBit));
 673                     ; 154   USARTx->CR3 &= (uint8_t)~(USART_CR3_CPOL | USART_CR3_CPHA | USART_CR3_LBCL);
 675  0084 e606          	ld	a,(6,x)
 676  0086 a4f8          	and	a,#248
 677  0088 e706          	ld	(6,x),a
 678                     ; 156   USARTx->CR3 |= (uint8_t)((uint8_t)((uint8_t)(USART_CPOL | (uint8_t)USART_CPHA ) | USART_LastBit));
 680  008a 7b06          	ld	a,(OFST+6,sp)
 681  008c 1a07          	or	a,(OFST+7,sp)
 682  008e 1a08          	or	a,(OFST+8,sp)
 683  0090 ea06          	or	a,(6,x)
 684  0092 e706          	ld	(6,x),a
 685                     ; 158   if (USART_Clock != USART_Clock_Disable)
 687  0094 0d05          	tnz	(OFST+5,sp)
 688  0096 2708          	jreq	L523
 689                     ; 160     USARTx->CR3 |= (uint8_t)(USART_CR3_CLKEN); /* Set the Clock Enable bit */
 691  0098 e606          	ld	a,(6,x)
 692  009a aa08          	or	a,#8
 693  009c e706          	ld	(6,x),a
 695  009e 2008          	jra	L723
 696  00a0               L523:
 697                     ; 164     USARTx->CR3 &= (uint8_t)(~USART_CR3_CLKEN); /* Clear the Clock Enable bit */
 699  00a0 1e01          	ldw	x,(OFST+1,sp)
 700  00a2 e606          	ld	a,(6,x)
 701  00a4 a4f7          	and	a,#247
 702  00a6 e706          	ld	(6,x),a
 703  00a8               L723:
 704                     ; 166 }
 707  00a8 85            	popw	x
 708  00a9 81            	ret
 775                     ; 175 void USART_Cmd(USART_TypeDef* USARTx, FunctionalState NewState)
 775                     ; 176 {
 776                     	switch	.text
 777  00aa               _USART_Cmd:
 779  00aa 89            	pushw	x
 780       00000000      OFST:	set	0
 783                     ; 177   if (NewState != DISABLE)
 785  00ab 0d05          	tnz	(OFST+5,sp)
 786  00ad 2708          	jreq	L563
 787                     ; 179     USARTx->CR1 &= (uint8_t)(~USART_CR1_USARTD); /**< USART Enable */
 789  00af e604          	ld	a,(4,x)
 790  00b1 a4df          	and	a,#223
 791  00b3 e704          	ld	(4,x),a
 793  00b5 2008          	jra	L763
 794  00b7               L563:
 795                     ; 183     USARTx->CR1 |= USART_CR1_USARTD;  /**< USART Disable (for low power consumption) */
 797  00b7 1e01          	ldw	x,(OFST+1,sp)
 798  00b9 e604          	ld	a,(4,x)
 799  00bb aa20          	or	a,#32
 800  00bd e704          	ld	(4,x),a
 801  00bf               L763:
 802                     ; 185 }
 805  00bf 85            	popw	x
 806  00c0 81            	ret
 950                     ; 202 void USART_ITConfig(USART_TypeDef* USARTx, USART_IT_TypeDef USART_IT, FunctionalState NewState)
 950                     ; 203 {
 951                     	switch	.text
 952  00c1               _USART_ITConfig:
 954  00c1 89            	pushw	x
 955  00c2 89            	pushw	x
 956       00000002      OFST:	set	2
 959                     ; 204   uint8_t usartreg, itpos = 0x00;
 961                     ; 205   assert_param(IS_USART_CONFIG_IT(USART_IT));
 963                     ; 206   assert_param(IS_FUNCTIONAL_STATE(NewState));
 965                     ; 209   usartreg = (uint8_t)((uint16_t)USART_IT >> 0x08);
 967  00c3 7b07          	ld	a,(OFST+5,sp)
 968  00c5 6b01          	ld	(OFST-1,sp),a
 969                     ; 211   itpos = (uint8_t)((uint8_t)1 << (uint8_t)((uint8_t)USART_IT & (uint8_t)0x0F));
 971  00c7 7b08          	ld	a,(OFST+6,sp)
 972  00c9 a40f          	and	a,#15
 973  00cb 5f            	clrw	x
 974  00cc 97            	ld	xl,a
 975  00cd a601          	ld	a,#1
 976  00cf 5d            	tnzw	x
 977  00d0 2704          	jreq	L61
 978  00d2               L02:
 979  00d2 48            	sll	a
 980  00d3 5a            	decw	x
 981  00d4 26fc          	jrne	L02
 982  00d6               L61:
 983  00d6 6b02          	ld	(OFST+0,sp),a
 984                     ; 213   if (NewState != DISABLE)
 986  00d8 0d09          	tnz	(OFST+7,sp)
 987  00da 272a          	jreq	L754
 988                     ; 216     if (usartreg == 0x01)
 990  00dc 7b01          	ld	a,(OFST-1,sp)
 991  00de a101          	cp	a,#1
 992  00e0 260a          	jrne	L164
 993                     ; 218       USARTx->CR1 |= itpos;
 995  00e2 1e03          	ldw	x,(OFST+1,sp)
 996  00e4 e604          	ld	a,(4,x)
 997  00e6 1a02          	or	a,(OFST+0,sp)
 998  00e8 e704          	ld	(4,x),a
1000  00ea 2045          	jra	L174
1001  00ec               L164:
1002                     ; 220     else if (usartreg == 0x05)
1004  00ec 7b01          	ld	a,(OFST-1,sp)
1005  00ee a105          	cp	a,#5
1006  00f0 260a          	jrne	L564
1007                     ; 222       USARTx->CR5 |= itpos;
1009  00f2 1e03          	ldw	x,(OFST+1,sp)
1010  00f4 e608          	ld	a,(8,x)
1011  00f6 1a02          	or	a,(OFST+0,sp)
1012  00f8 e708          	ld	(8,x),a
1014  00fa 2035          	jra	L174
1015  00fc               L564:
1016                     ; 227       USARTx->CR2 |= itpos;
1018  00fc 1e03          	ldw	x,(OFST+1,sp)
1019  00fe e605          	ld	a,(5,x)
1020  0100 1a02          	or	a,(OFST+0,sp)
1021  0102 e705          	ld	(5,x),a
1022  0104 202b          	jra	L174
1023  0106               L754:
1024                     ; 233     if (usartreg == 0x01)
1026  0106 7b01          	ld	a,(OFST-1,sp)
1027  0108 a101          	cp	a,#1
1028  010a 260b          	jrne	L374
1029                     ; 235       USARTx->CR1 &= (uint8_t)(~itpos);
1031  010c 1e03          	ldw	x,(OFST+1,sp)
1032  010e 7b02          	ld	a,(OFST+0,sp)
1033  0110 43            	cpl	a
1034  0111 e404          	and	a,(4,x)
1035  0113 e704          	ld	(4,x),a
1037  0115 201a          	jra	L174
1038  0117               L374:
1039                     ; 237     else if (usartreg == 0x05)
1041  0117 7b01          	ld	a,(OFST-1,sp)
1042  0119 a105          	cp	a,#5
1043  011b 260b          	jrne	L774
1044                     ; 239       USARTx->CR5 &= (uint8_t)(~itpos);
1046  011d 1e03          	ldw	x,(OFST+1,sp)
1047  011f 7b02          	ld	a,(OFST+0,sp)
1048  0121 43            	cpl	a
1049  0122 e408          	and	a,(8,x)
1050  0124 e708          	ld	(8,x),a
1052  0126 2009          	jra	L174
1053  0128               L774:
1054                     ; 244       USARTx->CR2 &= (uint8_t)(~itpos);
1056  0128 1e03          	ldw	x,(OFST+1,sp)
1057  012a 7b02          	ld	a,(OFST+0,sp)
1058  012c 43            	cpl	a
1059  012d e405          	and	a,(5,x)
1060  012f e705          	ld	(5,x),a
1061  0131               L174:
1062                     ; 248 }
1065  0131 5b04          	addw	sp,#4
1066  0133 81            	ret
1114                     ; 256 void USART_HalfDuplexCmd(USART_TypeDef* USARTx, FunctionalState NewState)
1114                     ; 257 {
1115                     	switch	.text
1116  0134               _USART_HalfDuplexCmd:
1118  0134 89            	pushw	x
1119       00000000      OFST:	set	0
1122                     ; 258   assert_param(IS_FUNCTIONAL_STATE(NewState));
1124                     ; 260   if (NewState != DISABLE)
1126  0135 0d05          	tnz	(OFST+5,sp)
1127  0137 2708          	jreq	L725
1128                     ; 262     USARTx->CR5 |= USART_CR5_HDSEL;  /**< USART Half Duplex Enable  */
1130  0139 e608          	ld	a,(8,x)
1131  013b aa08          	or	a,#8
1132  013d e708          	ld	(8,x),a
1134  013f 2008          	jra	L135
1135  0141               L725:
1136                     ; 266     USARTx->CR5 &= (uint8_t)~USART_CR5_HDSEL; /**< USART Half Duplex Disable */
1138  0141 1e01          	ldw	x,(OFST+1,sp)
1139  0143 e608          	ld	a,(8,x)
1140  0145 a4f7          	and	a,#247
1141  0147 e708          	ld	(8,x),a
1142  0149               L135:
1143                     ; 268 }
1146  0149 85            	popw	x
1147  014a 81            	ret
1216                     ; 277 void USART_IrDAConfig(USART_TypeDef* USARTx, USART_IrDAMode_TypeDef USART_IrDAMode)
1216                     ; 278 {
1217                     	switch	.text
1218  014b               _USART_IrDAConfig:
1220  014b 89            	pushw	x
1221       00000000      OFST:	set	0
1224                     ; 279   assert_param(IS_USART_IRDAMODE(USART_IrDAMode));
1226                     ; 281   if (USART_IrDAMode != USART_IrDAMode_Normal)
1228  014c 0d05          	tnz	(OFST+5,sp)
1229  014e 2708          	jreq	L765
1230                     ; 283     USARTx->CR5 |= USART_CR5_IRLP;
1232  0150 e608          	ld	a,(8,x)
1233  0152 aa04          	or	a,#4
1234  0154 e708          	ld	(8,x),a
1236  0156 2008          	jra	L175
1237  0158               L765:
1238                     ; 287     USARTx->CR5 &= ((uint8_t)~USART_CR5_IRLP);
1240  0158 1e01          	ldw	x,(OFST+1,sp)
1241  015a e608          	ld	a,(8,x)
1242  015c a4fb          	and	a,#251
1243  015e e708          	ld	(8,x),a
1244  0160               L175:
1245                     ; 289 }
1248  0160 85            	popw	x
1249  0161 81            	ret
1296                     ; 298 void USART_IrDACmd(USART_TypeDef* USARTx, FunctionalState NewState)
1296                     ; 299 {
1297                     	switch	.text
1298  0162               _USART_IrDACmd:
1300  0162 89            	pushw	x
1301       00000000      OFST:	set	0
1304                     ; 302   assert_param(IS_FUNCTIONAL_STATE(NewState));
1306                     ; 304   if (NewState != DISABLE)
1308  0163 0d05          	tnz	(OFST+5,sp)
1309  0165 2708          	jreq	L716
1310                     ; 307     USARTx->CR5 |= USART_CR5_IREN;
1312  0167 e608          	ld	a,(8,x)
1313  0169 aa02          	or	a,#2
1314  016b e708          	ld	(8,x),a
1316  016d 2008          	jra	L126
1317  016f               L716:
1318                     ; 312     USARTx->CR5 &= ((uint8_t)~USART_CR5_IREN);
1320  016f 1e01          	ldw	x,(OFST+1,sp)
1321  0171 e608          	ld	a,(8,x)
1322  0173 a4fd          	and	a,#253
1323  0175 e708          	ld	(8,x),a
1324  0177               L126:
1325                     ; 314 }
1328  0177 85            	popw	x
1329  0178 81            	ret
1376                     ; 322 void USART_SmartCardCmd(USART_TypeDef* USARTx, FunctionalState NewState)
1376                     ; 323 {
1377                     	switch	.text
1378  0179               _USART_SmartCardCmd:
1380  0179 89            	pushw	x
1381       00000000      OFST:	set	0
1384                     ; 324   assert_param(IS_FUNCTIONAL_STATE(NewState));
1386                     ; 326   if (NewState != DISABLE)
1388  017a 0d05          	tnz	(OFST+5,sp)
1389  017c 2708          	jreq	L746
1390                     ; 329     USARTx->CR5 |= USART_CR5_SCEN;
1392  017e e608          	ld	a,(8,x)
1393  0180 aa20          	or	a,#32
1394  0182 e708          	ld	(8,x),a
1396  0184 2008          	jra	L156
1397  0186               L746:
1398                     ; 334     USARTx->CR5 &= ((uint8_t)(~USART_CR5_SCEN));
1400  0186 1e01          	ldw	x,(OFST+1,sp)
1401  0188 e608          	ld	a,(8,x)
1402  018a a4df          	and	a,#223
1403  018c e708          	ld	(8,x),a
1404  018e               L156:
1405                     ; 336 }
1408  018e 85            	popw	x
1409  018f 81            	ret
1457                     ; 345 void USART_SmartCardNACKCmd(USART_TypeDef* USARTx, FunctionalState NewState)
1457                     ; 346 {
1458                     	switch	.text
1459  0190               _USART_SmartCardNACKCmd:
1461  0190 89            	pushw	x
1462       00000000      OFST:	set	0
1465                     ; 347   assert_param(IS_FUNCTIONAL_STATE(NewState));
1467                     ; 349   if (NewState != DISABLE)
1469  0191 0d05          	tnz	(OFST+5,sp)
1470  0193 2708          	jreq	L776
1471                     ; 352     USARTx->CR5 |= USART_CR5_NACK;
1473  0195 e608          	ld	a,(8,x)
1474  0197 aa10          	or	a,#16
1475  0199 e708          	ld	(8,x),a
1477  019b 2008          	jra	L107
1478  019d               L776:
1479                     ; 357     USARTx->CR5 &= ((uint8_t)~(USART_CR5_NACK));
1481  019d 1e01          	ldw	x,(OFST+1,sp)
1482  019f e608          	ld	a,(8,x)
1483  01a1 a4ef          	and	a,#239
1484  01a3 e708          	ld	(8,x),a
1485  01a5               L107:
1486                     ; 359 }
1489  01a5 85            	popw	x
1490  01a6 81            	ret
1536                     ; 367 void USART_SetGuardTime(USART_TypeDef* USARTx, uint8_t USART_GuardTime)
1536                     ; 368 {
1537                     	switch	.text
1538  01a7               _USART_SetGuardTime:
1540  01a7 89            	pushw	x
1541       00000000      OFST:	set	0
1544                     ; 370   USARTx->GTR = USART_GuardTime;
1546  01a8 7b05          	ld	a,(OFST+5,sp)
1547  01aa 1e01          	ldw	x,(OFST+1,sp)
1548  01ac e709          	ld	(9,x),a
1549                     ; 371 }
1552  01ae 85            	popw	x
1553  01af 81            	ret
1599                     ; 396 void USART_SetPrescaler(USART_TypeDef* USARTx, uint8_t USART_Prescaler)
1599                     ; 397 {
1600                     	switch	.text
1601  01b0               _USART_SetPrescaler:
1603  01b0 89            	pushw	x
1604       00000000      OFST:	set	0
1607                     ; 399   USARTx->PSCR = USART_Prescaler;
1609  01b1 7b05          	ld	a,(OFST+5,sp)
1610  01b3 1e01          	ldw	x,(OFST+1,sp)
1611  01b5 e70a          	ld	(10,x),a
1612                     ; 400 }
1615  01b7 85            	popw	x
1616  01b8 81            	ret
1653                     ; 407 uint8_t USART_ReceiveData8(USART_TypeDef* USARTx)
1653                     ; 408 {
1654                     	switch	.text
1655  01b9               _USART_ReceiveData8:
1659                     ; 409   return USARTx->DR;
1661  01b9 e601          	ld	a,(1,x)
1664  01bb 81            	ret
1710                     ; 418 uint16_t USART_ReceiveData9(USART_TypeDef* USARTx)
1710                     ; 419 {
1711                     	switch	.text
1712  01bc               _USART_ReceiveData9:
1714  01bc 89            	pushw	x
1715  01bd 89            	pushw	x
1716       00000002      OFST:	set	2
1719                     ; 420   uint16_t temp = 0;
1721                     ; 422   temp = ((uint16_t)(((uint16_t)((uint16_t)USARTx->CR1 & (uint16_t)USART_CR1_R8)) << 1));
1723  01be e604          	ld	a,(4,x)
1724  01c0 5f            	clrw	x
1725  01c1 a480          	and	a,#128
1726  01c3 5f            	clrw	x
1727  01c4 02            	rlwa	x,a
1728  01c5 58            	sllw	x
1729  01c6 1f01          	ldw	(OFST-1,sp),x
1730                     ; 423   return (uint16_t)( ((uint16_t)((uint16_t)USARTx->DR) | temp) & ((uint16_t)0x01FF));
1732  01c8 1e03          	ldw	x,(OFST+1,sp)
1733  01ca e601          	ld	a,(1,x)
1734  01cc 5f            	clrw	x
1735  01cd 97            	ld	xl,a
1736  01ce 01            	rrwa	x,a
1737  01cf 1a02          	or	a,(OFST+0,sp)
1738  01d1 01            	rrwa	x,a
1739  01d2 1a01          	or	a,(OFST-1,sp)
1740  01d4 01            	rrwa	x,a
1741  01d5 01            	rrwa	x,a
1742  01d6 a4ff          	and	a,#255
1743  01d8 01            	rrwa	x,a
1744  01d9 a401          	and	a,#1
1745  01db 01            	rrwa	x,a
1748  01dc 5b04          	addw	sp,#4
1749  01de 81            	ret
1797                     ; 433 void USART_ReceiverWakeUpCmd(USART_TypeDef* USARTx, FunctionalState NewState)
1797                     ; 434 {
1798                     	switch	.text
1799  01df               _USART_ReceiverWakeUpCmd:
1801  01df 89            	pushw	x
1802       00000000      OFST:	set	0
1805                     ; 435   assert_param(IS_FUNCTIONAL_STATE(NewState));
1807                     ; 437   if (NewState != DISABLE)
1809  01e0 0d05          	tnz	(OFST+5,sp)
1810  01e2 2708          	jreq	L3401
1811                     ; 440     USARTx->CR2 |= USART_CR2_RWU;
1813  01e4 e605          	ld	a,(5,x)
1814  01e6 aa02          	or	a,#2
1815  01e8 e705          	ld	(5,x),a
1817  01ea 2008          	jra	L5401
1818  01ec               L3401:
1819                     ; 445     USARTx->CR2 &= ((uint8_t)~USART_CR2_RWU);
1821  01ec 1e01          	ldw	x,(OFST+1,sp)
1822  01ee e605          	ld	a,(5,x)
1823  01f0 a4fd          	and	a,#253
1824  01f2 e705          	ld	(5,x),a
1825  01f4               L5401:
1826                     ; 447 }
1829  01f4 85            	popw	x
1830  01f5 81            	ret
1867                     ; 454 void USART_SendBreak(USART_TypeDef* USARTx)
1867                     ; 455 {
1868                     	switch	.text
1869  01f6               _USART_SendBreak:
1873                     ; 456   USARTx->CR2 |= USART_CR2_SBK;
1875  01f6 e605          	ld	a,(5,x)
1876  01f8 aa01          	or	a,#1
1877  01fa e705          	ld	(5,x),a
1878                     ; 457 }
1881  01fc 81            	ret
1927                     ; 464 void USART_SendData8(USART_TypeDef* USARTx, uint8_t Data)
1927                     ; 465 {
1928                     	switch	.text
1929  01fd               _USART_SendData8:
1931  01fd 89            	pushw	x
1932       00000000      OFST:	set	0
1935                     ; 467   USARTx->DR = Data;
1937  01fe 7b05          	ld	a,(OFST+5,sp)
1938  0200 1e01          	ldw	x,(OFST+1,sp)
1939  0202 e701          	ld	(1,x),a
1940                     ; 468 }
1943  0204 85            	popw	x
1944  0205 81            	ret
1990                     ; 477 void USART_SendData9(USART_TypeDef* USARTx, uint16_t Data)
1990                     ; 478 {
1991                     	switch	.text
1992  0206               _USART_SendData9:
1994  0206 89            	pushw	x
1995       00000000      OFST:	set	0
1998                     ; 479   assert_param(IS_USART_DATA_9BITS(Data));
2000                     ; 482   USARTx->CR1 &= ((uint8_t)~USART_CR1_T8);
2002  0207 e604          	ld	a,(4,x)
2003  0209 a4bf          	and	a,#191
2004  020b e704          	ld	(4,x),a
2005                     ; 485   USARTx->CR1 |= (uint8_t)(((uint8_t)(Data >> 2)) & USART_CR1_T8);
2007  020d 1605          	ldw	y,(OFST+5,sp)
2008  020f 9054          	srlw	y
2009  0211 9054          	srlw	y
2010  0213 909f          	ld	a,yl
2011  0215 a440          	and	a,#64
2012  0217 ea04          	or	a,(4,x)
2013  0219 e704          	ld	(4,x),a
2014                     ; 488   USARTx->DR   = (uint8_t)(Data);
2016  021b 7b06          	ld	a,(OFST+6,sp)
2017  021d 1e01          	ldw	x,(OFST+1,sp)
2018  021f e701          	ld	(1,x),a
2019                     ; 489 }
2022  0221 85            	popw	x
2023  0222 81            	ret
2069                     ; 498 void USART_SetAddress(USART_TypeDef* USARTx, uint8_t USART_Address)
2069                     ; 499 {
2070                     	switch	.text
2071  0223               _USART_SetAddress:
2073  0223 89            	pushw	x
2074       00000000      OFST:	set	0
2077                     ; 501   assert_param(IS_USART_ADDRESS(USART_Address));
2079                     ; 504   USARTx->CR4 &= ((uint8_t)~USART_CR4_ADD);
2081  0224 e607          	ld	a,(7,x)
2082  0226 a4f0          	and	a,#240
2083  0228 e707          	ld	(7,x),a
2084                     ; 506   USARTx->CR4 |= USART_Address;
2086  022a e607          	ld	a,(7,x)
2087  022c 1a05          	or	a,(OFST+5,sp)
2088  022e e707          	ld	(7,x),a
2089                     ; 507 }
2092  0230 85            	popw	x
2093  0231 81            	ret
2162                     ; 515 void USART_WakeUpConfig(USART_TypeDef* USARTx, USART_WakeUp_TypeDef USART_WakeUp)
2162                     ; 516 {
2163                     	switch	.text
2164  0232               _USART_WakeUpConfig:
2166  0232 89            	pushw	x
2167       00000000      OFST:	set	0
2170                     ; 517   assert_param(IS_USART_WAKEUP(USART_WakeUp));
2172                     ; 519   USARTx->CR1 &= ((uint8_t)~USART_CR1_WAKE);
2174  0233 e604          	ld	a,(4,x)
2175  0235 a4f7          	and	a,#247
2176  0237 e704          	ld	(4,x),a
2177                     ; 520   USARTx->CR1 |= (uint8_t)USART_WakeUp;
2179  0239 e604          	ld	a,(4,x)
2180  023b 1a05          	or	a,(OFST+5,sp)
2181  023d e704          	ld	(4,x),a
2182                     ; 521 }
2185  023f 85            	popw	x
2186  0240 81            	ret
2263                     ; 532 void USART_DMACmd(USART_TypeDef* USARTx, USART_DMAReq_TypeDef USART_DMAReq,
2263                     ; 533                   FunctionalState NewState)
2263                     ; 534 {
2264                     	switch	.text
2265  0241               _USART_DMACmd:
2267  0241 89            	pushw	x
2268       00000000      OFST:	set	0
2271                     ; 536   assert_param(IS_USART_DMAREQ(USART_DMAReq));
2273                     ; 537   assert_param(IS_FUNCTIONAL_STATE(NewState));
2275                     ; 539   if (NewState != DISABLE)
2277  0242 0d06          	tnz	(OFST+6,sp)
2278  0244 2708          	jreq	L7521
2279                     ; 543     USARTx->CR5 |= (uint8_t) USART_DMAReq;
2281  0246 e608          	ld	a,(8,x)
2282  0248 1a05          	or	a,(OFST+5,sp)
2283  024a e708          	ld	(8,x),a
2285  024c 2009          	jra	L1621
2286  024e               L7521:
2287                     ; 549     USARTx->CR5 &= (uint8_t)~USART_DMAReq;
2289  024e 1e01          	ldw	x,(OFST+1,sp)
2290  0250 7b05          	ld	a,(OFST+5,sp)
2291  0252 43            	cpl	a
2292  0253 e408          	and	a,(8,x)
2293  0255 e708          	ld	(8,x),a
2294  0257               L1621:
2295                     ; 551 }
2298  0257 85            	popw	x
2299  0258 81            	ret
2447                     ; 560 FlagStatus USART_GetFlagStatus(USART_TypeDef* USARTx, USART_FLAG_TypeDef USART_FLAG)
2447                     ; 561 {
2448                     	switch	.text
2449  0259               _USART_GetFlagStatus:
2451  0259 89            	pushw	x
2452  025a 88            	push	a
2453       00000001      OFST:	set	1
2456                     ; 562   FlagStatus status = RESET;
2458                     ; 565   assert_param(IS_USART_FLAG(USART_FLAG));
2460                     ; 567   if (USART_FLAG == USART_FLAG_SBK)
2462  025b 1e06          	ldw	x,(OFST+5,sp)
2463  025d a30101        	cpw	x,#257
2464  0260 2612          	jrne	L1531
2465                     ; 569     if ((USARTx->CR2 & (uint8_t)USART_FLAG) != (uint8_t)0x00)
2467  0262 1e02          	ldw	x,(OFST+1,sp)
2468  0264 e605          	ld	a,(5,x)
2469  0266 1507          	bcp	a,(OFST+6,sp)
2470  0268 2706          	jreq	L3531
2471                     ; 572       status = SET;
2473  026a a601          	ld	a,#1
2474  026c 6b01          	ld	(OFST+0,sp),a
2476  026e 2013          	jra	L7531
2477  0270               L3531:
2478                     ; 577       status = RESET;
2480  0270 0f01          	clr	(OFST+0,sp)
2481  0272 200f          	jra	L7531
2482  0274               L1531:
2483                     ; 582     if ((USARTx->SR & (uint8_t)USART_FLAG) != (uint8_t)0x00)
2485  0274 1e02          	ldw	x,(OFST+1,sp)
2486  0276 f6            	ld	a,(x)
2487  0277 1507          	bcp	a,(OFST+6,sp)
2488  0279 2706          	jreq	L1631
2489                     ; 585       status = SET;
2491  027b a601          	ld	a,#1
2492  027d 6b01          	ld	(OFST+0,sp),a
2494  027f 2002          	jra	L7531
2495  0281               L1631:
2496                     ; 590       status = RESET;
2498  0281 0f01          	clr	(OFST+0,sp)
2499  0283               L7531:
2500                     ; 594   return status;
2502  0283 7b01          	ld	a,(OFST+0,sp)
2505  0285 5b03          	addw	sp,#3
2506  0287 81            	ret
2553                     ; 625 void USART_ClearFlag(USART_TypeDef* USARTx, USART_FLAG_TypeDef USART_FLAG)
2553                     ; 626 {
2554                     	switch	.text
2555  0288               _USART_ClearFlag:
2557  0288 89            	pushw	x
2558       00000000      OFST:	set	0
2561                     ; 628   assert_param(IS_USART_CLEAR_FLAG(USART_FLAG));
2563                     ; 630   USARTx->SR = (uint8_t)((uint16_t)~((uint16_t)USART_FLAG));
2565  0289 7b06          	ld	a,(OFST+6,sp)
2566  028b 43            	cpl	a
2567  028c 1e01          	ldw	x,(OFST+1,sp)
2568  028e f7            	ld	(x),a
2569                     ; 631 }
2572  028f 85            	popw	x
2573  0290 81            	ret
2676                     ; 648 ITStatus USART_GetITStatus(USART_TypeDef* USARTx, USART_IT_TypeDef USART_IT)
2676                     ; 649 {
2677                     	switch	.text
2678  0291               _USART_GetITStatus:
2680  0291 89            	pushw	x
2681  0292 5203          	subw	sp,#3
2682       00000003      OFST:	set	3
2685                     ; 650   ITStatus pendingbitstatus = RESET;
2687                     ; 651   uint8_t temp = 0;
2689                     ; 652   uint8_t itpos = 0;
2691                     ; 653   uint8_t itmask1 = 0;
2693                     ; 654   uint8_t itmask2 = 0;
2695                     ; 655   uint8_t enablestatus = 0;
2697                     ; 658   assert_param(IS_USART_GET_IT(USART_IT));
2699                     ; 661   itpos = (uint8_t)((uint8_t)1 << (uint8_t)((uint8_t)USART_IT & (uint8_t)0x0F));
2701  0294 7b09          	ld	a,(OFST+6,sp)
2702  0296 a40f          	and	a,#15
2703  0298 5f            	clrw	x
2704  0299 97            	ld	xl,a
2705  029a a601          	ld	a,#1
2706  029c 5d            	tnzw	x
2707  029d 2704          	jreq	L07
2708  029f               L27:
2709  029f 48            	sll	a
2710  02a0 5a            	decw	x
2711  02a1 26fc          	jrne	L27
2712  02a3               L07:
2713  02a3 6b02          	ld	(OFST-1,sp),a
2714                     ; 663   itmask1 = (uint8_t)((uint8_t)USART_IT >> (uint8_t)4);
2716  02a5 7b09          	ld	a,(OFST+6,sp)
2717  02a7 4e            	swap	a
2718  02a8 a40f          	and	a,#15
2719  02aa 6b03          	ld	(OFST+0,sp),a
2720                     ; 665   itmask2 = (uint8_t)((uint8_t)1 << itmask1);
2722  02ac 7b03          	ld	a,(OFST+0,sp)
2723  02ae 5f            	clrw	x
2724  02af 97            	ld	xl,a
2725  02b0 a601          	ld	a,#1
2726  02b2 5d            	tnzw	x
2727  02b3 2704          	jreq	L47
2728  02b5               L67:
2729  02b5 48            	sll	a
2730  02b6 5a            	decw	x
2731  02b7 26fc          	jrne	L67
2732  02b9               L47:
2733  02b9 6b03          	ld	(OFST+0,sp),a
2734                     ; 668   if (USART_IT == USART_IT_PE)
2736  02bb 1e08          	ldw	x,(OFST+5,sp)
2737  02bd a30100        	cpw	x,#256
2738  02c0 261d          	jrne	L5641
2739                     ; 671     enablestatus = (uint8_t)((uint8_t)USARTx->CR1 & itmask2);
2741  02c2 1e04          	ldw	x,(OFST+1,sp)
2742  02c4 e604          	ld	a,(4,x)
2743  02c6 1403          	and	a,(OFST+0,sp)
2744  02c8 6b03          	ld	(OFST+0,sp),a
2745                     ; 674     if (((USARTx->SR & itpos) != (uint8_t)0x00) && enablestatus)
2747  02ca 1e04          	ldw	x,(OFST+1,sp)
2748  02cc f6            	ld	a,(x)
2749  02cd 1502          	bcp	a,(OFST-1,sp)
2750  02cf 270a          	jreq	L7641
2752  02d1 0d03          	tnz	(OFST+0,sp)
2753  02d3 2706          	jreq	L7641
2754                     ; 677       pendingbitstatus = SET;
2756  02d5 a601          	ld	a,#1
2757  02d7 6b03          	ld	(OFST+0,sp),a
2759  02d9 204f          	jra	L3741
2760  02db               L7641:
2761                     ; 682       pendingbitstatus = RESET;
2763  02db 0f03          	clr	(OFST+0,sp)
2764  02dd 204b          	jra	L3741
2765  02df               L5641:
2766                     ; 686   else if (USART_IT == USART_IT_OR)
2768  02df 1e08          	ldw	x,(OFST+5,sp)
2769  02e1 a30235        	cpw	x,#565
2770  02e4 2629          	jrne	L5741
2771                     ; 689     enablestatus = (uint8_t)((uint8_t)USARTx->CR2 & itmask2);
2773  02e6 1e04          	ldw	x,(OFST+1,sp)
2774  02e8 e605          	ld	a,(5,x)
2775  02ea 1403          	and	a,(OFST+0,sp)
2776  02ec 6b03          	ld	(OFST+0,sp),a
2777                     ; 692     temp = (uint8_t)(USARTx->CR5 & USART_CR5_EIE);
2779  02ee 1e04          	ldw	x,(OFST+1,sp)
2780  02f0 e608          	ld	a,(8,x)
2781  02f2 a401          	and	a,#1
2782  02f4 6b01          	ld	(OFST-2,sp),a
2783                     ; 694     if (( (USARTx->SR & itpos) != 0x00) && ((enablestatus || temp)))
2785  02f6 1e04          	ldw	x,(OFST+1,sp)
2786  02f8 f6            	ld	a,(x)
2787  02f9 1502          	bcp	a,(OFST-1,sp)
2788  02fb 270e          	jreq	L7741
2790  02fd 0d03          	tnz	(OFST+0,sp)
2791  02ff 2604          	jrne	L1051
2793  0301 0d01          	tnz	(OFST-2,sp)
2794  0303 2706          	jreq	L7741
2795  0305               L1051:
2796                     ; 697       pendingbitstatus = SET;
2798  0305 a601          	ld	a,#1
2799  0307 6b03          	ld	(OFST+0,sp),a
2801  0309 201f          	jra	L3741
2802  030b               L7741:
2803                     ; 702       pendingbitstatus = RESET;
2805  030b 0f03          	clr	(OFST+0,sp)
2806  030d 201b          	jra	L3741
2807  030f               L5741:
2808                     ; 709     enablestatus = (uint8_t)((uint8_t)USARTx->CR2 & itmask2);
2810  030f 1e04          	ldw	x,(OFST+1,sp)
2811  0311 e605          	ld	a,(5,x)
2812  0313 1403          	and	a,(OFST+0,sp)
2813  0315 6b03          	ld	(OFST+0,sp),a
2814                     ; 711     if (((USARTx->SR & itpos) != (uint8_t)0x00) && enablestatus)
2816  0317 1e04          	ldw	x,(OFST+1,sp)
2817  0319 f6            	ld	a,(x)
2818  031a 1502          	bcp	a,(OFST-1,sp)
2819  031c 270a          	jreq	L7051
2821  031e 0d03          	tnz	(OFST+0,sp)
2822  0320 2706          	jreq	L7051
2823                     ; 714       pendingbitstatus = SET;
2825  0322 a601          	ld	a,#1
2826  0324 6b03          	ld	(OFST+0,sp),a
2828  0326 2002          	jra	L3741
2829  0328               L7051:
2830                     ; 719       pendingbitstatus = RESET;
2832  0328 0f03          	clr	(OFST+0,sp)
2833  032a               L3741:
2834                     ; 724   return  pendingbitstatus;
2836  032a 7b03          	ld	a,(OFST+0,sp)
2839  032c 5b05          	addw	sp,#5
2840  032e 81            	ret
2906                     ; 755 void USART_ClearITPendingBit(USART_TypeDef* USARTx, USART_IT_TypeDef USART_IT)
2906                     ; 756 {
2907                     	switch	.text
2908  032f               _USART_ClearITPendingBit:
2910  032f 89            	pushw	x
2911  0330 88            	push	a
2912       00000001      OFST:	set	1
2915                     ; 757   uint8_t bitpos = 0x00, itmask = 0x00;
2919                     ; 758   assert_param(IS_USART_CLEAR_IT(USART_IT));
2921                     ; 759   bitpos = (uint8_t)( (uint8_t)((uint8_t)USART_IT & (uint8_t)0xF0) >> 0x04);
2923  0331 7b07          	ld	a,(OFST+6,sp)
2924  0333 a4f0          	and	a,#240
2925  0335 4e            	swap	a
2926  0336 a40f          	and	a,#15
2927  0338 6b01          	ld	(OFST+0,sp),a
2928                     ; 760   itmask = (uint8_t)( (uint8_t)0x01 << bitpos);
2930  033a 7b01          	ld	a,(OFST+0,sp)
2931  033c 5f            	clrw	x
2932  033d 97            	ld	xl,a
2933  033e a601          	ld	a,#1
2934  0340 5d            	tnzw	x
2935  0341 2704          	jreq	L201
2936  0343               L401:
2937  0343 48            	sll	a
2938  0344 5a            	decw	x
2939  0345 26fc          	jrne	L401
2940  0347               L201:
2941  0347 6b01          	ld	(OFST+0,sp),a
2942                     ; 762   USARTx->SR = (uint8_t)~itmask;
2944  0349 7b01          	ld	a,(OFST+0,sp)
2945  034b 43            	cpl	a
2946  034c 1e02          	ldw	x,(OFST+1,sp)
2947  034e f7            	ld	(x),a
2948                     ; 763 }
2951  034f 5b03          	addw	sp,#3
2952  0351 81            	ret
2965                     	xref	_CLK_GetClockFreq
2966                     	xdef	_USART_ClearITPendingBit
2967                     	xdef	_USART_GetITStatus
2968                     	xdef	_USART_ClearFlag
2969                     	xdef	_USART_GetFlagStatus
2970                     	xdef	_USART_DMACmd
2971                     	xdef	_USART_WakeUpConfig
2972                     	xdef	_USART_SetAddress
2973                     	xdef	_USART_SendData9
2974                     	xdef	_USART_SendData8
2975                     	xdef	_USART_SendBreak
2976                     	xdef	_USART_ReceiverWakeUpCmd
2977                     	xdef	_USART_ReceiveData9
2978                     	xdef	_USART_ReceiveData8
2979                     	xdef	_USART_SetPrescaler
2980                     	xdef	_USART_SetGuardTime
2981                     	xdef	_USART_SmartCardNACKCmd
2982                     	xdef	_USART_SmartCardCmd
2983                     	xdef	_USART_IrDACmd
2984                     	xdef	_USART_IrDAConfig
2985                     	xdef	_USART_HalfDuplexCmd
2986                     	xdef	_USART_ITConfig
2987                     	xdef	_USART_Cmd
2988                     	xdef	_USART_ClockInit
2989                     	xdef	_USART_Init
2990                     	xdef	_USART_DeInit
2991                     	xref.b	c_lreg
2992                     	xref.b	c_x
3011                     	xref	c_lursh
3012                     	xref	c_ltor
3013                     	xref	c_rtol
3014                     	xref	c_ludv
3015                     	end
