   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Parser V4.8.32.1 - 30 Mar 2010
   3                     ; Generator V4.3.4 - 23 Mar 2010
 174                     ; 45 void ADC_DeInit(ADC_TypeDef* ADCx)
 174                     ; 46 {
 176                     	switch	.text
 177  0000               _ADC_DeInit:
 181                     ; 48   ADCx->CR1 =  ADC_CR1_RESET_VALUE;
 183  0000 7f            	clr	(x)
 184                     ; 49   ADCx->CR2 =  ADC_CR2_RESET_VALUE;
 186  0001 6f01          	clr	(1,x)
 187                     ; 50   ADCx->CR3 =  ADC_CR3_RESET_VALUE;
 189  0003 a61f          	ld	a,#31
 190  0005 e702          	ld	(2,x),a
 191                     ; 53   ADCx->SR =  (uint8_t)~ADC_SR_RESET_VALUE;
 193  0007 a6ff          	ld	a,#255
 194  0009 e703          	ld	(3,x),a
 195                     ; 56   ADCx->HTRH =  ADC_HTRH_RESET_VALUE;
 197  000b a60f          	ld	a,#15
 198  000d e706          	ld	(6,x),a
 199                     ; 57   ADCx->HTRL =  ADC_HTRL_RESET_VALUE;
 201  000f a6ff          	ld	a,#255
 202  0011 e707          	ld	(7,x),a
 203                     ; 60   ADCx->LTRH =  ADC_LTRH_RESET_VALUE;
 205  0013 6f08          	clr	(8,x)
 206                     ; 61   ADCx->LTRL =  ADC_LTRL_RESET_VALUE;
 208  0015 6f09          	clr	(9,x)
 209                     ; 64   ADCx->SQR[0] =  ADC_SQR1_RESET_VALUE;
 211  0017 6f0a          	clr	(10,x)
 212                     ; 65   ADCx->SQR[1] =  ADC_SQR2_RESET_VALUE;
 214  0019 6f0b          	clr	(11,x)
 215                     ; 66   ADCx->SQR[2] =  ADC_SQR3_RESET_VALUE;
 217  001b 6f0c          	clr	(12,x)
 218                     ; 67   ADCx->SQR[3] =  ADC_SQR4_RESET_VALUE;
 220  001d 6f0d          	clr	(13,x)
 221                     ; 70   ADCx->TRIGR[0] =  ADC_TRIGR1_RESET_VALUE;
 223  001f 6f0e          	clr	(14,x)
 224                     ; 71   ADCx->TRIGR[1] =  ADC_TRIGR2_RESET_VALUE;
 226  0021 6f0f          	clr	(15,x)
 227                     ; 72   ADCx->TRIGR[2] =  ADC_TRIGR3_RESET_VALUE;
 229  0023 6f10          	clr	(16,x)
 230                     ; 73   ADCx->TRIGR[3] =  ADC_TRIGR4_RESET_VALUE;
 232  0025 6f11          	clr	(17,x)
 233                     ; 74 }
 236  0027 81            	ret
 383                     ; 87 void ADC_Init(ADC_TypeDef* ADCx,
 383                     ; 88               ADC_ConversionMode_TypeDef ADC_ConversionMode,
 383                     ; 89               ADC_Resolution_TypeDef ADC_Resolution,
 383                     ; 90               ADC_Prescaler_TypeDef ADC_Prescaler)
 383                     ; 91 {
 384                     	switch	.text
 385  0028               _ADC_Init:
 387  0028 89            	pushw	x
 388       00000000      OFST:	set	0
 391                     ; 93   assert_param(IS_ADC_CONVERSION_MODE(ADC_ConversionMode));
 393                     ; 94   assert_param(IS_ADC_RESOLUTION(ADC_Resolution));
 395                     ; 95   assert_param(IS_ADC_PRESCALER(ADC_Prescaler));
 397                     ; 98   ADCx->CR1 &= (uint8_t)~(ADC_CR1_CONT | ADC_CR1_RES);
 399  0029 f6            	ld	a,(x)
 400  002a a49b          	and	a,#155
 401  002c f7            	ld	(x),a
 402                     ; 101   ADCx->CR1 |= (uint8_t)((uint8_t)ADC_ConversionMode | (uint8_t)ADC_Resolution);
 404  002d 7b05          	ld	a,(OFST+5,sp)
 405  002f 1a06          	or	a,(OFST+6,sp)
 406  0031 fa            	or	a,(x)
 407  0032 f7            	ld	(x),a
 408                     ; 104   ADCx->CR2 &= (uint8_t)~(ADC_CR2_PRESC );
 410  0033 e601          	ld	a,(1,x)
 411  0035 a47f          	and	a,#127
 412  0037 e701          	ld	(1,x),a
 413                     ; 107   ADCx->CR2 |= (uint8_t) ADC_Prescaler;
 415  0039 e601          	ld	a,(1,x)
 416  003b 1a07          	or	a,(OFST+7,sp)
 417  003d e701          	ld	(1,x),a
 418                     ; 108 }
 421  003f 85            	popw	x
 422  0040 81            	ret
 754                     ; 124 void ADC_ChannelCmd(ADC_TypeDef* ADCx,
 754                     ; 125                     ADC_Channel_TypeDef ADC_Channels,
 754                     ; 126                     FunctionalState NewState)
 754                     ; 127 {
 755                     	switch	.text
 756  0041               _ADC_ChannelCmd:
 758  0041 89            	pushw	x
 759  0042 88            	push	a
 760       00000001      OFST:	set	1
 763                     ; 128   uint8_t regindex = 0;
 765                     ; 130   assert_param(IS_FUNCTIONAL_STATE(NewState));
 767                     ; 132   regindex = (uint8_t)((uint16_t)ADC_Channels >> 8);
 769  0043 7b06          	ld	a,(OFST+5,sp)
 770  0045 6b01          	ld	(OFST+0,sp),a
 771                     ; 134   if (NewState != DISABLE)
 773  0047 0d08          	tnz	(OFST+7,sp)
 774  0049 270f          	jreq	L163
 775                     ; 137     ADCx->SQR[regindex] |= (uint8_t)(ADC_Channels);
 777  004b 01            	rrwa	x,a
 778  004c 1b01          	add	a,(OFST+0,sp)
 779  004e 2401          	jrnc	L21
 780  0050 5c            	incw	x
 781  0051               L21:
 782  0051 02            	rlwa	x,a
 783  0052 e60a          	ld	a,(10,x)
 784  0054 1a07          	or	a,(OFST+6,sp)
 785  0056 e70a          	ld	(10,x),a
 787  0058 2012          	jra	L363
 788  005a               L163:
 789                     ; 142     ADCx->SQR[regindex] &= (uint8_t)(~(uint8_t)(ADC_Channels));
 791  005a 7b02          	ld	a,(OFST+1,sp)
 792  005c 97            	ld	xl,a
 793  005d 7b03          	ld	a,(OFST+2,sp)
 794  005f 1b01          	add	a,(OFST+0,sp)
 795  0061 2401          	jrnc	L41
 796  0063 5c            	incw	x
 797  0064               L41:
 798  0064 02            	rlwa	x,a
 799  0065 7b07          	ld	a,(OFST+6,sp)
 800  0067 43            	cpl	a
 801  0068 e40a          	and	a,(10,x)
 802  006a e70a          	ld	(10,x),a
 803  006c               L363:
 804                     ; 144 }
 807  006c 5b03          	addw	sp,#3
 808  006e 81            	ret
 855                     ; 153 void ADC_Cmd(ADC_TypeDef* ADCx,
 855                     ; 154              FunctionalState NewState)
 855                     ; 155 {
 856                     	switch	.text
 857  006f               _ADC_Cmd:
 859  006f 89            	pushw	x
 860       00000000      OFST:	set	0
 863                     ; 157   assert_param(IS_FUNCTIONAL_STATE(NewState));
 865                     ; 159   if (NewState != DISABLE)
 867  0070 0d05          	tnz	(OFST+5,sp)
 868  0072 2706          	jreq	L114
 869                     ; 162     ADCx->CR1 |= ADC_CR1_ADON;
 871  0074 f6            	ld	a,(x)
 872  0075 aa01          	or	a,#1
 873  0077 f7            	ld	(x),a
 875  0078 2006          	jra	L314
 876  007a               L114:
 877                     ; 167     ADCx->CR1 &= (uint8_t)~ADC_CR1_ADON;
 879  007a 1e01          	ldw	x,(OFST+1,sp)
 880  007c f6            	ld	a,(x)
 881  007d a4fe          	and	a,#254
 882  007f f7            	ld	(x),a
 883  0080               L314:
 884                     ; 169 }
 887  0080 85            	popw	x
 888  0081 81            	ret
 972                     ; 180 void ADC_ITConfig(ADC_TypeDef* ADCx,
 972                     ; 181                   ADC_IT_TypeDef ADC_IT,
 972                     ; 182                   FunctionalState NewState)
 972                     ; 183 {
 973                     	switch	.text
 974  0082               _ADC_ITConfig:
 976  0082 89            	pushw	x
 977       00000000      OFST:	set	0
 980                     ; 185   assert_param(IS_FUNCTIONAL_STATE(NewState));
 982                     ; 186   assert_param(IS_ADC_IT(ADC_IT));
 984                     ; 188   if (NewState != DISABLE)
 986  0083 0d06          	tnz	(OFST+6,sp)
 987  0085 2706          	jreq	L754
 988                     ; 191     ADCx->CR1 |= (uint8_t) ADC_IT;
 990  0087 f6            	ld	a,(x)
 991  0088 1a05          	or	a,(OFST+5,sp)
 992  008a f7            	ld	(x),a
 994  008b 2007          	jra	L164
 995  008d               L754:
 996                     ; 196     ADCx->CR1 &= (uint8_t)(~ADC_IT);
 998  008d 1e01          	ldw	x,(OFST+1,sp)
 999  008f 7b05          	ld	a,(OFST+5,sp)
1000  0091 43            	cpl	a
1001  0092 f4            	and	a,(x)
1002  0093 f7            	ld	(x),a
1003  0094               L164:
1004                     ; 198 }
1007  0094 85            	popw	x
1008  0095 81            	ret
1055                     ; 207 void ADC_DMACmd(ADC_TypeDef* ADCx,
1055                     ; 208                 FunctionalState NewState)
1055                     ; 209 {
1056                     	switch	.text
1057  0096               _ADC_DMACmd:
1059  0096 89            	pushw	x
1060       00000000      OFST:	set	0
1063                     ; 211   assert_param(IS_FUNCTIONAL_STATE(NewState));
1065                     ; 213   if (NewState != DISABLE)
1067  0097 0d05          	tnz	(OFST+5,sp)
1068  0099 2708          	jreq	L705
1069                     ; 216     ADCx->SQR[0] &= (uint8_t)~ADC_SQR1_DMAOFF;
1071  009b e60a          	ld	a,(10,x)
1072  009d a47f          	and	a,#127
1073  009f e70a          	ld	(10,x),a
1075  00a1 2008          	jra	L115
1076  00a3               L705:
1077                     ; 221     ADCx->SQR[0] |= ADC_SQR1_DMAOFF;
1079  00a3 1e01          	ldw	x,(OFST+1,sp)
1080  00a5 e60a          	ld	a,(10,x)
1081  00a7 aa80          	or	a,#128
1082  00a9 e70a          	ld	(10,x),a
1083  00ab               L115:
1084                     ; 223 }
1087  00ab 85            	popw	x
1088  00ac 81            	ret
1123                     ; 231 void ADC_TempSensorCmd(FunctionalState NewState)
1123                     ; 232 {
1124                     	switch	.text
1125  00ad               _ADC_TempSensorCmd:
1129                     ; 234   assert_param(IS_FUNCTIONAL_STATE(NewState));
1131                     ; 236   if (NewState != DISABLE)
1133  00ad 4d            	tnz	a
1134  00ae 2706          	jreq	L135
1135                     ; 239     ADC1->TRIGR[0] |= (uint8_t)(ADC_TRIGR1_TSON);
1137  00b0 721a534e      	bset	21326,#5
1139  00b4 2004          	jra	L335
1140  00b6               L135:
1141                     ; 244     ADC1->TRIGR[0] &= (uint8_t)(~ADC_TRIGR1_TSON);
1143  00b6 721b534e      	bres	21326,#5
1144  00ba               L335:
1145                     ; 246 }
1148  00ba 81            	ret
1183                     ; 254 void ADC_VrefintCmd(FunctionalState NewState)
1183                     ; 255 {
1184                     	switch	.text
1185  00bb               _ADC_VrefintCmd:
1189                     ; 257   assert_param(IS_FUNCTIONAL_STATE(NewState));
1191                     ; 259   if (NewState != DISABLE)
1193  00bb 4d            	tnz	a
1194  00bc 2706          	jreq	L355
1195                     ; 262     ADC1->TRIGR[0] |= (uint8_t)(ADC_TRIGR1_VREFINTON);
1197  00be 7218534e      	bset	21326,#4
1199  00c2 2004          	jra	L555
1200  00c4               L355:
1201                     ; 267     ADC1->TRIGR[0] &= (uint8_t)(~ADC_TRIGR1_VREFINTON);
1203  00c4 7219534e      	bres	21326,#4
1204  00c8               L555:
1205                     ; 269 }
1208  00c8 81            	ret
1246                     ; 276 void ADC_SoftwareStartConv(ADC_TypeDef* ADCx)
1246                     ; 277 {
1247                     	switch	.text
1248  00c9               _ADC_SoftwareStartConv:
1252                     ; 279   ADCx->CR1 |= ADC_CR1_START;
1254  00c9 f6            	ld	a,(x)
1255  00ca aa02          	or	a,#2
1256  00cc f7            	ld	(x),a
1257                     ; 280 }
1260  00cd 81            	ret
1410                     ; 291 void ADC_SamplingTimeConfig(ADC_TypeDef* ADCx,
1410                     ; 292                             ADC_Group_TypeDef ADC_GroupChannels,
1410                     ; 293                             ADC_SamplingTime_TypeDef ADC_SamplingTime)
1410                     ; 294 {
1411                     	switch	.text
1412  00ce               _ADC_SamplingTimeConfig:
1414  00ce 89            	pushw	x
1415       00000000      OFST:	set	0
1418                     ; 296   assert_param(IS_ADC_GROUP(ADC_GroupChannels));
1420                     ; 297   assert_param(IS_ADC_SAMPLING_TIME_CYCLES(ADC_SamplingTime));
1422                     ; 299   if ( ADC_GroupChannels != ADC_Group_SlowChannels)
1424  00cf 0d05          	tnz	(OFST+5,sp)
1425  00d1 2712          	jreq	L366
1426                     ; 302     ADCx->CR3 &= (uint8_t)~ADC_CR3_SMPT2;
1428  00d3 e602          	ld	a,(2,x)
1429  00d5 a41f          	and	a,#31
1430  00d7 e702          	ld	(2,x),a
1431                     ; 303     ADCx->CR3 |= (uint8_t)(ADC_SamplingTime << 5);
1433  00d9 7b06          	ld	a,(OFST+6,sp)
1434  00db 4e            	swap	a
1435  00dc 48            	sll	a
1436  00dd a4e0          	and	a,#224
1437  00df ea02          	or	a,(2,x)
1438  00e1 e702          	ld	(2,x),a
1440  00e3 2010          	jra	L566
1441  00e5               L366:
1442                     ; 308     ADCx->CR2 &= (uint8_t)~ADC_CR2_SMPT1;
1444  00e5 1e01          	ldw	x,(OFST+1,sp)
1445  00e7 e601          	ld	a,(1,x)
1446  00e9 a4f8          	and	a,#248
1447  00eb e701          	ld	(1,x),a
1448                     ; 309     ADCx->CR2 |= (uint8_t)ADC_SamplingTime;
1450  00ed 1e01          	ldw	x,(OFST+1,sp)
1451  00ef e601          	ld	a,(1,x)
1452  00f1 1a06          	or	a,(OFST+6,sp)
1453  00f3 e701          	ld	(1,x),a
1454  00f5               L566:
1455                     ; 311 }
1458  00f5 85            	popw	x
1459  00f6 81            	ret
1526                     ; 322 void ADC_SchmittTriggerConfig(ADC_TypeDef* ADCx,
1526                     ; 323                               ADC_Channel_TypeDef ADC_Channels,
1526                     ; 324                               FunctionalState NewState)
1526                     ; 325 {
1527                     	switch	.text
1528  00f7               _ADC_SchmittTriggerConfig:
1530  00f7 89            	pushw	x
1531  00f8 88            	push	a
1532       00000001      OFST:	set	1
1535                     ; 326   uint8_t regindex = 0;
1537                     ; 328   assert_param(IS_FUNCTIONAL_STATE(NewState));
1539                     ; 330   regindex = (uint8_t)((uint16_t)ADC_Channels >> 8);
1541  00f9 7b06          	ld	a,(OFST+5,sp)
1542  00fb 6b01          	ld	(OFST+0,sp),a
1543                     ; 332   if (NewState != DISABLE)
1545  00fd 0d08          	tnz	(OFST+7,sp)
1546  00ff 2710          	jreq	L327
1547                     ; 335     ADCx->TRIGR[regindex] &= (uint8_t)(~(uint8_t)ADC_Channels);
1549  0101 01            	rrwa	x,a
1550  0102 1b01          	add	a,(OFST+0,sp)
1551  0104 2401          	jrnc	L63
1552  0106 5c            	incw	x
1553  0107               L63:
1554  0107 02            	rlwa	x,a
1555  0108 7b07          	ld	a,(OFST+6,sp)
1556  010a 43            	cpl	a
1557  010b e40e          	and	a,(14,x)
1558  010d e70e          	ld	(14,x),a
1560  010f 2011          	jra	L527
1561  0111               L327:
1562                     ; 340     ADCx->TRIGR[regindex] |= (uint8_t)(ADC_Channels);
1564  0111 7b02          	ld	a,(OFST+1,sp)
1565  0113 97            	ld	xl,a
1566  0114 7b03          	ld	a,(OFST+2,sp)
1567  0116 1b01          	add	a,(OFST+0,sp)
1568  0118 2401          	jrnc	L04
1569  011a 5c            	incw	x
1570  011b               L04:
1571  011b 02            	rlwa	x,a
1572  011c e60e          	ld	a,(14,x)
1573  011e 1a07          	or	a,(OFST+6,sp)
1574  0120 e70e          	ld	(14,x),a
1575  0122               L527:
1576                     ; 342 }
1579  0122 5b03          	addw	sp,#3
1580  0124 81            	ret
1708                     ; 353 void ADC_ExternalTrigConfig(ADC_TypeDef* ADCx,
1708                     ; 354                             ADC_ExtEventSelection_TypeDef ADC_ExtEventSelection,
1708                     ; 355                             ADC_ExtTRGSensitivity_TypeDef ADC_ExtTRGSensitivity)
1708                     ; 356 {
1709                     	switch	.text
1710  0125               _ADC_ExternalTrigConfig:
1712  0125 89            	pushw	x
1713       00000000      OFST:	set	0
1716                     ; 358   assert_param(IS_ADC_EXT_EVENT_SELECTION(ADC_ExtEventSelection));
1718                     ; 359   assert_param(IS_ADC_EXT_TRG_SENSITIVITY(ADC_ExtTRGSensitivity));
1720                     ; 362   ADCx->CR2 &= (uint8_t)~(ADC_CR2_TRIGEDGE | ADC_CR2_EXTSEL);
1722  0126 e601          	ld	a,(1,x)
1723  0128 a487          	and	a,#135
1724  012a e701          	ld	(1,x),a
1725                     ; 365   ADCx->CR2 |= (uint8_t)( (uint8_t)ADC_ExtTRGSensitivity | (uint8_t)ADC_ExtEventSelection);
1727  012c 7b06          	ld	a,(OFST+6,sp)
1728  012e 1a05          	or	a,(OFST+5,sp)
1729  0130 ea01          	or	a,(1,x)
1730  0132 e701          	ld	(1,x),a
1731                     ; 366 }
1734  0134 85            	popw	x
1735  0135 81            	ret
1782                     ; 374 uint16_t ADC_GetConversionValue(ADC_TypeDef* ADCx)
1782                     ; 375 {
1783                     	switch	.text
1784  0136               _ADC_GetConversionValue:
1786  0136 89            	pushw	x
1787  0137 89            	pushw	x
1788       00000002      OFST:	set	2
1791                     ; 376   uint16_t tmpreg = 0;
1793                     ; 379   tmpreg = (uint16_t)(ADCx->DRH);
1795  0138 e604          	ld	a,(4,x)
1796  013a 5f            	clrw	x
1797  013b 97            	ld	xl,a
1798  013c 1f01          	ldw	(OFST-1,sp),x
1799                     ; 380   tmpreg = (uint16_t)((uint16_t)((uint16_t)tmpreg << 8) | ADCx->DRL);
1801  013e 1e01          	ldw	x,(OFST-1,sp)
1802  0140 1603          	ldw	y,(OFST+1,sp)
1803  0142 90e605        	ld	a,(5,y)
1804  0145 02            	rlwa	x,a
1805  0146 1f01          	ldw	(OFST-1,sp),x
1806                     ; 383   return (uint16_t)(tmpreg) ;
1808  0148 1e01          	ldw	x,(OFST-1,sp)
1811  014a 5b04          	addw	sp,#4
1812  014c 81            	ret
2126                     ; 395 void ADC_AnalogWatchdogChannelSelect(ADC_TypeDef* ADCx,
2126                     ; 396                                      ADC_AnalogWatchdogSelection_TypeDef ADC_AnalogWatchdogSelection)
2126                     ; 397 {
2127                     	switch	.text
2128  014d               _ADC_AnalogWatchdogChannelSelect:
2130  014d 89            	pushw	x
2131       00000000      OFST:	set	0
2134                     ; 399   assert_param(IS_ADC_ANALOGWATCHDOG_SELECTION(ADC_AnalogWatchdogSelection));
2136                     ; 402   ADCx->CR3 &= ((uint8_t)~ADC_CR3_CHSEL);
2138  014e e602          	ld	a,(2,x)
2139  0150 a4e0          	and	a,#224
2140  0152 e702          	ld	(2,x),a
2141                     ; 405   ADCx->CR3 |= (uint8_t)ADC_AnalogWatchdogSelection;
2143  0154 e602          	ld	a,(2,x)
2144  0156 1a05          	or	a,(OFST+5,sp)
2145  0158 e702          	ld	(2,x),a
2146                     ; 406 }
2149  015a 85            	popw	x
2150  015b 81            	ret
2206                     ; 417 void ADC_AnalogWatchdogThresholdsConfig(ADC_TypeDef* ADCx,
2206                     ; 418                                         uint16_t HighThreshold,
2206                     ; 419                                         uint16_t LowThreshold)
2206                     ; 420 {
2207                     	switch	.text
2208  015c               _ADC_AnalogWatchdogThresholdsConfig:
2210  015c 89            	pushw	x
2211       00000000      OFST:	set	0
2214                     ; 422   assert_param(IS_ADC_THRESHOLD(HighThreshold));
2216                     ; 423   assert_param(IS_ADC_THRESHOLD(LowThreshold));
2218                     ; 426   ADCx->HTRH = (uint8_t)(HighThreshold >> 8);
2220  015d 7b05          	ld	a,(OFST+5,sp)
2221  015f 1e01          	ldw	x,(OFST+1,sp)
2222  0161 e706          	ld	(6,x),a
2223                     ; 427   ADCx->HTRL = (uint8_t)(HighThreshold);
2225  0163 7b06          	ld	a,(OFST+6,sp)
2226  0165 1e01          	ldw	x,(OFST+1,sp)
2227  0167 e707          	ld	(7,x),a
2228                     ; 430   ADCx->LTRH = (uint8_t)(LowThreshold >> 8);
2230  0169 7b07          	ld	a,(OFST+7,sp)
2231  016b 1e01          	ldw	x,(OFST+1,sp)
2232  016d e708          	ld	(8,x),a
2233                     ; 431   ADCx->LTRL = (uint8_t)(LowThreshold);
2235  016f 7b08          	ld	a,(OFST+8,sp)
2236  0171 1e01          	ldw	x,(OFST+1,sp)
2237  0173 e709          	ld	(9,x),a
2238                     ; 432 }
2241  0175 85            	popw	x
2242  0176 81            	ret
2309                     ; 446 void ADC_AnalogWatchdogConfig(ADC_TypeDef* ADCx,
2309                     ; 447                               ADC_AnalogWatchdogSelection_TypeDef ADC_AnalogWatchdogSelection,
2309                     ; 448                               uint16_t HighThreshold,
2309                     ; 449                               uint16_t LowThreshold)
2309                     ; 450 {
2310                     	switch	.text
2311  0177               _ADC_AnalogWatchdogConfig:
2313  0177 89            	pushw	x
2314       00000000      OFST:	set	0
2317                     ; 452   assert_param(IS_ADC_ANALOGWATCHDOG_SELECTION(ADC_AnalogWatchdogSelection));
2319                     ; 453   assert_param(IS_ADC_THRESHOLD(HighThreshold));
2321                     ; 454   assert_param(IS_ADC_THRESHOLD(LowThreshold));
2323                     ; 457   ADCx->CR3 &= ((uint8_t)~ADC_CR3_CHSEL);
2325  0178 e602          	ld	a,(2,x)
2326  017a a4e0          	and	a,#224
2327  017c e702          	ld	(2,x),a
2328                     ; 460   ADCx->CR3 |= (uint8_t)ADC_AnalogWatchdogSelection;
2330  017e e602          	ld	a,(2,x)
2331  0180 1a05          	or	a,(OFST+5,sp)
2332  0182 e702          	ld	(2,x),a
2333                     ; 463   ADCx->HTRH = (uint8_t)(HighThreshold >> 8);
2335  0184 7b06          	ld	a,(OFST+6,sp)
2336  0186 1e01          	ldw	x,(OFST+1,sp)
2337  0188 e706          	ld	(6,x),a
2338                     ; 464   ADCx->HTRL = (uint8_t)(HighThreshold);
2340  018a 7b07          	ld	a,(OFST+7,sp)
2341  018c 1e01          	ldw	x,(OFST+1,sp)
2342  018e e707          	ld	(7,x),a
2343                     ; 467   ADCx->LTRH = (uint8_t)(LowThreshold >> 8);
2345  0190 7b08          	ld	a,(OFST+8,sp)
2346  0192 1e01          	ldw	x,(OFST+1,sp)
2347  0194 e708          	ld	(8,x),a
2348                     ; 468   ADCx->LTRL = (uint8_t)LowThreshold;
2350  0196 7b09          	ld	a,(OFST+9,sp)
2351  0198 1e01          	ldw	x,(OFST+1,sp)
2352  019a e709          	ld	(9,x),a
2353                     ; 469 }
2356  019c 85            	popw	x
2357  019d 81            	ret
2462                     ; 478 FlagStatus ADC_GetFlagStatus(ADC_TypeDef* ADCx, ADC_FLAG_TypeDef ADC_FLAG)
2462                     ; 479 {
2463                     	switch	.text
2464  019e               _ADC_GetFlagStatus:
2466  019e 89            	pushw	x
2467  019f 88            	push	a
2468       00000001      OFST:	set	1
2471                     ; 480   FlagStatus flagstatus = RESET;
2473                     ; 483   assert_param(IS_ADC_GET_FLAG(ADC_FLAG));
2475                     ; 486   if ((ADCx->SR & ADC_FLAG) != (uint8_t)RESET)
2477  01a0 e603          	ld	a,(3,x)
2478  01a2 1506          	bcp	a,(OFST+5,sp)
2479  01a4 2706          	jreq	L3131
2480                     ; 489     flagstatus = SET;
2482  01a6 a601          	ld	a,#1
2483  01a8 6b01          	ld	(OFST+0,sp),a
2485  01aa 2002          	jra	L5131
2486  01ac               L3131:
2487                     ; 494     flagstatus = RESET;
2489  01ac 0f01          	clr	(OFST+0,sp)
2490  01ae               L5131:
2491                     ; 498   return  flagstatus;
2493  01ae 7b01          	ld	a,(OFST+0,sp)
2496  01b0 5b03          	addw	sp,#3
2497  01b2 81            	ret
2544                     ; 508 void ADC_ClearFlag(ADC_TypeDef* ADCx,
2544                     ; 509                    ADC_FLAG_TypeDef ADC_FLAG)
2544                     ; 510 {
2545                     	switch	.text
2546  01b3               _ADC_ClearFlag:
2548  01b3 89            	pushw	x
2549       00000000      OFST:	set	0
2552                     ; 512   assert_param(IS_ADC_CLEAR_FLAG(ADC_FLAG));
2554                     ; 515   ADCx->SR = (uint8_t)~ADC_FLAG;
2556  01b4 7b05          	ld	a,(OFST+5,sp)
2557  01b6 43            	cpl	a
2558  01b7 1e01          	ldw	x,(OFST+1,sp)
2559  01b9 e703          	ld	(3,x),a
2560                     ; 516 }
2563  01bb 85            	popw	x
2564  01bc 81            	ret
2640                     ; 526 ITStatus ADC_GetITStatus(ADC_TypeDef* ADCx,
2640                     ; 527                          ADC_IT_TypeDef ADC_IT)
2640                     ; 528 {
2641                     	switch	.text
2642  01bd               _ADC_GetITStatus:
2644  01bd 89            	pushw	x
2645  01be 5203          	subw	sp,#3
2646       00000003      OFST:	set	3
2649                     ; 529   ITStatus itstatus = RESET;
2651                     ; 530   uint8_t itmask = 0, enablestatus = 0;
2655                     ; 533   assert_param(IS_ADC_GET_IT(ADC_IT));
2657                     ; 536   itmask = (uint8_t)(ADC_IT >> 3);
2659  01c0 7b08          	ld	a,(OFST+5,sp)
2660  01c2 44            	srl	a
2661  01c3 44            	srl	a
2662  01c4 44            	srl	a
2663  01c5 6b03          	ld	(OFST+0,sp),a
2664                     ; 537   itmask =  (uint8_t)((uint8_t)((uint8_t)(itmask & (uint8_t)0x10) >> 2) | (uint8_t)(itmask & (uint8_t)0x03));
2666  01c7 7b03          	ld	a,(OFST+0,sp)
2667  01c9 a403          	and	a,#3
2668  01cb 6b01          	ld	(OFST-2,sp),a
2669  01cd 7b03          	ld	a,(OFST+0,sp)
2670  01cf a410          	and	a,#16
2671  01d1 44            	srl	a
2672  01d2 44            	srl	a
2673  01d3 1a01          	or	a,(OFST-2,sp)
2674  01d5 6b03          	ld	(OFST+0,sp),a
2675                     ; 540   enablestatus = (uint8_t)(ADCx->CR1 & (uint8_t)ADC_IT) ;
2677  01d7 f6            	ld	a,(x)
2678  01d8 1408          	and	a,(OFST+5,sp)
2679  01da 6b02          	ld	(OFST-1,sp),a
2680                     ; 543   if (((ADCx->SR & itmask) != (uint8_t)RESET) && enablestatus)
2682  01dc e603          	ld	a,(3,x)
2683  01de 1503          	bcp	a,(OFST+0,sp)
2684  01e0 270a          	jreq	L3041
2686  01e2 0d02          	tnz	(OFST-1,sp)
2687  01e4 2706          	jreq	L3041
2688                     ; 546     itstatus = SET;
2690  01e6 a601          	ld	a,#1
2691  01e8 6b03          	ld	(OFST+0,sp),a
2693  01ea 2002          	jra	L5041
2694  01ec               L3041:
2695                     ; 551     itstatus = RESET;
2697  01ec 0f03          	clr	(OFST+0,sp)
2698  01ee               L5041:
2699                     ; 555   return  itstatus;
2701  01ee 7b03          	ld	a,(OFST+0,sp)
2704  01f0 5b05          	addw	sp,#5
2705  01f2 81            	ret
2762                     ; 565 void ADC_ClearITPendingBit(ADC_TypeDef* ADCx,
2762                     ; 566                            ADC_IT_TypeDef ADC_IT)
2762                     ; 567 {
2763                     	switch	.text
2764  01f3               _ADC_ClearITPendingBit:
2766  01f3 89            	pushw	x
2767  01f4 89            	pushw	x
2768       00000002      OFST:	set	2
2771                     ; 568   uint8_t itmask = 0;
2773                     ; 571   assert_param(IS_ADC_IT(ADC_IT));
2775                     ; 574   itmask = (uint8_t)(ADC_IT >> 3);
2777  01f5 7b07          	ld	a,(OFST+5,sp)
2778  01f7 44            	srl	a
2779  01f8 44            	srl	a
2780  01f9 44            	srl	a
2781  01fa 6b02          	ld	(OFST+0,sp),a
2782                     ; 575   itmask =  (uint8_t)((uint8_t)(((uint8_t)(itmask & (uint8_t)0x10)) >> 2) | (uint8_t)(itmask & (uint8_t)0x03));
2784  01fc 7b02          	ld	a,(OFST+0,sp)
2785  01fe a403          	and	a,#3
2786  0200 6b01          	ld	(OFST-1,sp),a
2787  0202 7b02          	ld	a,(OFST+0,sp)
2788  0204 a410          	and	a,#16
2789  0206 44            	srl	a
2790  0207 44            	srl	a
2791  0208 1a01          	or	a,(OFST-1,sp)
2792  020a 6b02          	ld	(OFST+0,sp),a
2793                     ; 578   ADCx->SR = (uint8_t)~itmask;
2795  020c 7b02          	ld	a,(OFST+0,sp)
2796  020e 43            	cpl	a
2797  020f 1e03          	ldw	x,(OFST+1,sp)
2798  0211 e703          	ld	(3,x),a
2799                     ; 579 }
2802  0213 5b04          	addw	sp,#4
2803  0215 81            	ret
2816                     	xdef	_ADC_ClearITPendingBit
2817                     	xdef	_ADC_GetITStatus
2818                     	xdef	_ADC_ClearFlag
2819                     	xdef	_ADC_GetFlagStatus
2820                     	xdef	_ADC_AnalogWatchdogConfig
2821                     	xdef	_ADC_AnalogWatchdogThresholdsConfig
2822                     	xdef	_ADC_AnalogWatchdogChannelSelect
2823                     	xdef	_ADC_GetConversionValue
2824                     	xdef	_ADC_ExternalTrigConfig
2825                     	xdef	_ADC_SchmittTriggerConfig
2826                     	xdef	_ADC_SamplingTimeConfig
2827                     	xdef	_ADC_SoftwareStartConv
2828                     	xdef	_ADC_VrefintCmd
2829                     	xdef	_ADC_TempSensorCmd
2830                     	xdef	_ADC_DMACmd
2831                     	xdef	_ADC_ITConfig
2832                     	xdef	_ADC_Cmd
2833                     	xdef	_ADC_ChannelCmd
2834                     	xdef	_ADC_Init
2835                     	xdef	_ADC_DeInit
2854                     	end
