   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Parser V4.8.32.1 - 30 Mar 2010
   3                     ; Generator V4.3.4 - 23 Mar 2010
 199                     ; 101 void I2C_DeInit(I2C_TypeDef* I2Cx)
 199                     ; 102 {
 201                     	switch	.text
 202  0000               _I2C_DeInit:
 206                     ; 103   I2Cx->CR1 = I2C_CR1_RESET_VALUE;
 208  0000 7f            	clr	(x)
 209                     ; 104   I2Cx->CR2 = I2C_CR2_RESET_VALUE;
 211  0001 6f01          	clr	(1,x)
 212                     ; 105   I2Cx->FREQR = I2C_FREQR_RESET_VALUE;
 214  0003 6f02          	clr	(2,x)
 215                     ; 106   I2Cx->OARL = I2C_OARL_RESET_VALUE;
 217  0005 6f03          	clr	(3,x)
 218                     ; 107   I2Cx->OARH = I2C_OARH_RESET_VALUE;
 220  0007 6f04          	clr	(4,x)
 221                     ; 108   I2Cx->OAR2 = I2C_OAR2_RESET_VALUE;
 223  0009 6f05          	clr	(5,x)
 224                     ; 109   I2Cx->ITR = I2C_ITR_RESET_VALUE;
 226  000b 6f0a          	clr	(10,x)
 227                     ; 110   I2Cx->CCRL = I2C_CCRL_RESET_VALUE;
 229  000d 6f0b          	clr	(11,x)
 230                     ; 111   I2Cx->CCRH = I2C_CCRH_RESET_VALUE;
 232  000f 6f0c          	clr	(12,x)
 233                     ; 112   I2Cx->TRISER = I2C_TRISER_RESET_VALUE;
 235  0011 a602          	ld	a,#2
 236  0013 e70d          	ld	(13,x),a
 237                     ; 113 }
 240  0015 81            	ret
 464                     .const:	section	.text
 465  0000               L01:
 466  0000 000f4240      	dc.l	1000000
 467  0004               L21:
 468  0004 000186a1      	dc.l	100001
 469  0008               L41:
 470  0008 00000004      	dc.l	4
 471                     ; 133 void I2C_Init(I2C_TypeDef* I2Cx, uint32_t OutputClockFrequency, uint16_t OwnAddress,
 471                     ; 134               I2C_Mode_TypeDef I2C_Mode, I2C_DutyCycle_TypeDef I2C_DutyCycle,
 471                     ; 135               I2C_Ack_TypeDef I2C_Ack, I2C_AcknowledgedAddress_TypeDef I2C_AcknowledgedAddress)
 471                     ; 136 {
 472                     	switch	.text
 473  0016               _I2C_Init:
 475  0016 89            	pushw	x
 476  0017 520c          	subw	sp,#12
 477       0000000c      OFST:	set	12
 480                     ; 137   uint32_t result = 0x0004;
 482                     ; 138   uint16_t tmpval = 0;
 484                     ; 139   uint8_t tmpccrh = 0;
 486  0019 0f07          	clr	(OFST-5,sp)
 487                     ; 140   uint8_t input_clock = 0;
 489                     ; 143   assert_param(IS_I2C_MODE(I2C_Mode));
 491                     ; 144   assert_param(IS_I2C_ACK_STATE(I2C_Ack));
 493                     ; 145   assert_param(IS_I2C_ACKNOWLEDGE_ADDRESS(I2C_AcknowledgedAddress));
 495                     ; 146   assert_param(IS_I2C_DUTY_CYCLE(I2C_DutyCycle));
 497                     ; 147   assert_param(IS_I2C_OWN_ADDRESS(OwnAddress));
 499                     ; 148   assert_param(IS_I2C_OUTPUT_CLOCK_FREQ(OutputClockFrequency));
 501                     ; 152   input_clock = (uint8_t) (CLK_GetClockFreq() / 1000000);
 503  001b cd0000        	call	_CLK_GetClockFreq
 505  001e ae0000        	ldw	x,#L01
 506  0021 cd0000        	call	c_ludv
 508  0024 b603          	ld	a,c_lreg+3
 509  0026 6b08          	ld	(OFST-4,sp),a
 510                     ; 156   I2Cx->FREQR &= (uint8_t)(~I2C_FREQR_FREQ);
 512  0028 1e0d          	ldw	x,(OFST+1,sp)
 513  002a e602          	ld	a,(2,x)
 514  002c a4c0          	and	a,#192
 515  002e e702          	ld	(2,x),a
 516                     ; 158   I2Cx->FREQR |= input_clock;
 518  0030 1e0d          	ldw	x,(OFST+1,sp)
 519  0032 e602          	ld	a,(2,x)
 520  0034 1a08          	or	a,(OFST-4,sp)
 521  0036 e702          	ld	(2,x),a
 522                     ; 162   I2Cx->CR1 &= (uint8_t)(~I2C_CR1_PE);
 524  0038 1e0d          	ldw	x,(OFST+1,sp)
 525  003a f6            	ld	a,(x)
 526  003b a4fe          	and	a,#254
 527  003d f7            	ld	(x),a
 528                     ; 165   I2Cx->CCRH &= (uint8_t)(~(I2C_CCRH_FS | I2C_CCRH_DUTY | I2C_CCRH_CCR));
 530  003e 1e0d          	ldw	x,(OFST+1,sp)
 531  0040 e60c          	ld	a,(12,x)
 532  0042 a430          	and	a,#48
 533  0044 e70c          	ld	(12,x),a
 534                     ; 166   I2Cx->CCRL &= (uint8_t)(~I2C_CCRL_CCR);
 536  0046 1e0d          	ldw	x,(OFST+1,sp)
 537  0048 6f0b          	clr	(11,x)
 538                     ; 169   if (OutputClockFrequency > I2C_MAX_STANDARD_FREQ) /* FAST MODE */
 540  004a 96            	ldw	x,sp
 541  004b 1c0011        	addw	x,#OFST+5
 542  004e cd0000        	call	c_ltor
 544  0051 ae0004        	ldw	x,#L21
 545  0054 cd0000        	call	c_lcmp
 547  0057 2403          	jruge	L61
 548  0059 cc00f7        	jp	L362
 549  005c               L61:
 550                     ; 172     tmpccrh = I2C_CCRH_FS;
 552  005c a680          	ld	a,#128
 553  005e 6b07          	ld	(OFST-5,sp),a
 554                     ; 174     if (I2C_DutyCycle == I2C_DutyCycle_2)
 556  0060 0d18          	tnz	(OFST+12,sp)
 557  0062 2633          	jrne	L562
 558                     ; 177       result = (uint32_t) ((input_clock * 1000000) / (OutputClockFrequency * 3));
 560  0064 96            	ldw	x,sp
 561  0065 1c0011        	addw	x,#OFST+5
 562  0068 cd0000        	call	c_ltor
 564  006b a603          	ld	a,#3
 565  006d cd0000        	call	c_smul
 567  0070 96            	ldw	x,sp
 568  0071 1c0001        	addw	x,#OFST-11
 569  0074 cd0000        	call	c_rtol
 571  0077 7b08          	ld	a,(OFST-4,sp)
 572  0079 b703          	ld	c_lreg+3,a
 573  007b 3f02          	clr	c_lreg+2
 574  007d 3f01          	clr	c_lreg+1
 575  007f 3f00          	clr	c_lreg
 576  0081 ae0000        	ldw	x,#L01
 577  0084 cd0000        	call	c_lmul
 579  0087 96            	ldw	x,sp
 580  0088 1c0001        	addw	x,#OFST-11
 581  008b cd0000        	call	c_ludv
 583  008e 96            	ldw	x,sp
 584  008f 1c0009        	addw	x,#OFST-3
 585  0092 cd0000        	call	c_rtol
 588  0095 2037          	jra	L762
 589  0097               L562:
 590                     ; 182       result = (uint32_t) ((input_clock * 1000000) / (OutputClockFrequency * 25));
 592  0097 96            	ldw	x,sp
 593  0098 1c0011        	addw	x,#OFST+5
 594  009b cd0000        	call	c_ltor
 596  009e a619          	ld	a,#25
 597  00a0 cd0000        	call	c_smul
 599  00a3 96            	ldw	x,sp
 600  00a4 1c0001        	addw	x,#OFST-11
 601  00a7 cd0000        	call	c_rtol
 603  00aa 7b08          	ld	a,(OFST-4,sp)
 604  00ac b703          	ld	c_lreg+3,a
 605  00ae 3f02          	clr	c_lreg+2
 606  00b0 3f01          	clr	c_lreg+1
 607  00b2 3f00          	clr	c_lreg
 608  00b4 ae0000        	ldw	x,#L01
 609  00b7 cd0000        	call	c_lmul
 611  00ba 96            	ldw	x,sp
 612  00bb 1c0001        	addw	x,#OFST-11
 613  00be cd0000        	call	c_ludv
 615  00c1 96            	ldw	x,sp
 616  00c2 1c0009        	addw	x,#OFST-3
 617  00c5 cd0000        	call	c_rtol
 619                     ; 184       tmpccrh |= I2C_CCRH_DUTY;
 621  00c8 7b07          	ld	a,(OFST-5,sp)
 622  00ca aa40          	or	a,#64
 623  00cc 6b07          	ld	(OFST-5,sp),a
 624  00ce               L762:
 625                     ; 188     if (result < (uint16_t)0x01)
 627  00ce 96            	ldw	x,sp
 628  00cf 1c0009        	addw	x,#OFST-3
 629  00d2 cd0000        	call	c_lzmp
 631  00d5 260a          	jrne	L172
 632                     ; 191       result = (uint16_t)0x0001;
 634  00d7 ae0001        	ldw	x,#1
 635  00da 1f0b          	ldw	(OFST-1,sp),x
 636  00dc ae0000        	ldw	x,#0
 637  00df 1f09          	ldw	(OFST-3,sp),x
 638  00e1               L172:
 639                     ; 197     tmpval = ((input_clock * 3) / 10) + 1;
 641  00e1 7b08          	ld	a,(OFST-4,sp)
 642  00e3 97            	ld	xl,a
 643  00e4 a603          	ld	a,#3
 644  00e6 42            	mul	x,a
 645  00e7 a60a          	ld	a,#10
 646  00e9 cd0000        	call	c_sdivx
 648  00ec 5c            	incw	x
 649  00ed 1f05          	ldw	(OFST-7,sp),x
 650                     ; 198     I2Cx->TRISER = (uint8_t)tmpval;
 652  00ef 7b06          	ld	a,(OFST-6,sp)
 653  00f1 1e0d          	ldw	x,(OFST+1,sp)
 654  00f3 e70d          	ld	(13,x),a
 656  00f5 205c          	jra	L372
 657  00f7               L362:
 658                     ; 205     result = (uint16_t)((input_clock * 1000000) / (OutputClockFrequency << (uint8_t)1));
 660  00f7 96            	ldw	x,sp
 661  00f8 1c0011        	addw	x,#OFST+5
 662  00fb cd0000        	call	c_ltor
 664  00fe 3803          	sll	c_lreg+3
 665  0100 3902          	rlc	c_lreg+2
 666  0102 3901          	rlc	c_lreg+1
 667  0104 3900          	rlc	c_lreg
 668  0106 96            	ldw	x,sp
 669  0107 1c0001        	addw	x,#OFST-11
 670  010a cd0000        	call	c_rtol
 672  010d 7b08          	ld	a,(OFST-4,sp)
 673  010f b703          	ld	c_lreg+3,a
 674  0111 3f02          	clr	c_lreg+2
 675  0113 3f01          	clr	c_lreg+1
 676  0115 3f00          	clr	c_lreg
 677  0117 ae0000        	ldw	x,#L01
 678  011a cd0000        	call	c_lmul
 680  011d 96            	ldw	x,sp
 681  011e 1c0001        	addw	x,#OFST-11
 682  0121 cd0000        	call	c_ludv
 684  0124 b602          	ld	a,c_lreg+2
 685  0126 97            	ld	xl,a
 686  0127 b603          	ld	a,c_lreg+3
 687  0129 cd0000        	call	c_uitol
 689  012c 96            	ldw	x,sp
 690  012d 1c0009        	addw	x,#OFST-3
 691  0130 cd0000        	call	c_rtol
 693                     ; 208     if (result < (uint16_t)0x0004)
 695  0133 96            	ldw	x,sp
 696  0134 1c0009        	addw	x,#OFST-3
 697  0137 cd0000        	call	c_ltor
 699  013a ae0008        	ldw	x,#L41
 700  013d cd0000        	call	c_lcmp
 702  0140 240a          	jruge	L572
 703                     ; 211       result = (uint16_t)0x0004;
 705  0142 ae0004        	ldw	x,#4
 706  0145 1f0b          	ldw	(OFST-1,sp),x
 707  0147 ae0000        	ldw	x,#0
 708  014a 1f09          	ldw	(OFST-3,sp),x
 709  014c               L572:
 710                     ; 217     I2Cx->TRISER = (uint8_t)((uint8_t)input_clock + (uint8_t)1);
 712  014c 7b08          	ld	a,(OFST-4,sp)
 713  014e 4c            	inc	a
 714  014f 1e0d          	ldw	x,(OFST+1,sp)
 715  0151 e70d          	ld	(13,x),a
 716  0153               L372:
 717                     ; 222   I2Cx->CCRL = (uint8_t)result;
 719  0153 7b0c          	ld	a,(OFST+0,sp)
 720  0155 1e0d          	ldw	x,(OFST+1,sp)
 721  0157 e70b          	ld	(11,x),a
 722                     ; 223   I2Cx->CCRH = (uint8_t)((uint8_t)((uint8_t)((uint8_t)result >> 8) & I2C_CCRH_CCR) | tmpccrh);
 724  0159 7b07          	ld	a,(OFST-5,sp)
 725  015b 1e0d          	ldw	x,(OFST+1,sp)
 726  015d e70c          	ld	(12,x),a
 727                     ; 226   I2Cx->CR1 |= (uint8_t)(I2C_CR1_PE | I2C_Mode);
 729  015f 1e0d          	ldw	x,(OFST+1,sp)
 730  0161 7b17          	ld	a,(OFST+11,sp)
 731  0163 aa01          	or	a,#1
 732  0165 fa            	or	a,(x)
 733  0166 f7            	ld	(x),a
 734                     ; 229   I2Cx->CR2 |= (uint8_t)I2C_Ack;
 736  0167 1e0d          	ldw	x,(OFST+1,sp)
 737  0169 e601          	ld	a,(1,x)
 738  016b 1a19          	or	a,(OFST+13,sp)
 739  016d e701          	ld	(1,x),a
 740                     ; 232   I2Cx->OARL = (uint8_t)(OwnAddress);
 742  016f 7b16          	ld	a,(OFST+10,sp)
 743  0171 1e0d          	ldw	x,(OFST+1,sp)
 744  0173 e703          	ld	(3,x),a
 745                     ; 233   I2Cx->OARH = (uint8_t)((uint8_t)(I2C_AcknowledgedAddress | I2C_OARH_ADDCONF ) | \
 745                     ; 234                          (uint8_t)((uint16_t)( (uint16_t)OwnAddress &  (uint16_t)0x0300) >> 7));
 747  0175 7b15          	ld	a,(OFST+9,sp)
 748  0177 97            	ld	xl,a
 749  0178 7b16          	ld	a,(OFST+10,sp)
 750  017a 9f            	ld	a,xl
 751  017b a403          	and	a,#3
 752  017d 97            	ld	xl,a
 753  017e 4f            	clr	a
 754  017f 02            	rlwa	x,a
 755  0180 4f            	clr	a
 756  0181 01            	rrwa	x,a
 757  0182 48            	sll	a
 758  0183 59            	rlcw	x
 759  0184 9f            	ld	a,xl
 760  0185 6b04          	ld	(OFST-8,sp),a
 761  0187 7b1a          	ld	a,(OFST+14,sp)
 762  0189 aa40          	or	a,#64
 763  018b 1a04          	or	a,(OFST-8,sp)
 764  018d 1e0d          	ldw	x,(OFST+1,sp)
 765  018f e704          	ld	(4,x),a
 766                     ; 235 }
 769  0191 5b0e          	addw	sp,#14
 770  0193 81            	ret
 837                     ; 244 void I2C_Cmd(I2C_TypeDef* I2Cx, FunctionalState NewState)
 837                     ; 245 {
 838                     	switch	.text
 839  0194               _I2C_Cmd:
 841  0194 89            	pushw	x
 842       00000000      OFST:	set	0
 845                     ; 248   assert_param(IS_FUNCTIONAL_STATE(NewState));
 847                     ; 250   if (NewState != DISABLE)
 849  0195 0d05          	tnz	(OFST+5,sp)
 850  0197 2706          	jreq	L333
 851                     ; 253     I2Cx->CR1 |= I2C_CR1_PE;
 853  0199 f6            	ld	a,(x)
 854  019a aa01          	or	a,#1
 855  019c f7            	ld	(x),a
 857  019d 2006          	jra	L533
 858  019f               L333:
 859                     ; 258     I2Cx->CR1 &= (uint8_t)(~I2C_CR1_PE);
 861  019f 1e01          	ldw	x,(OFST+1,sp)
 862  01a1 f6            	ld	a,(x)
 863  01a2 a4fe          	and	a,#254
 864  01a4 f7            	ld	(x),a
 865  01a5               L533:
 866                     ; 260 }
 869  01a5 85            	popw	x
 870  01a6 81            	ret
1059                     ; 270 void I2C_ITConfig(I2C_TypeDef* I2Cx, I2C_IT_TypeDef I2C_IT, FunctionalState NewState)
1059                     ; 271 {
1060                     	switch	.text
1061  01a7               _I2C_ITConfig:
1063  01a7 89            	pushw	x
1064       00000000      OFST:	set	0
1067                     ; 273   assert_param(IS_I2C_CONFIG_IT(I2C_IT));
1069                     ; 274   assert_param(IS_FUNCTIONAL_STATE(NewState));
1071                     ; 276   if (NewState != DISABLE)
1073  01a8 0d07          	tnz	(OFST+7,sp)
1074  01aa 2708          	jreq	L734
1075                     ; 279     I2Cx->ITR |= (uint8_t)I2C_IT;
1077  01ac e60a          	ld	a,(10,x)
1078  01ae 1a06          	or	a,(OFST+6,sp)
1079  01b0 e70a          	ld	(10,x),a
1081  01b2 2009          	jra	L144
1082  01b4               L734:
1083                     ; 284     I2Cx->ITR &= (uint8_t)(~(uint8_t)I2C_IT);
1085  01b4 1e01          	ldw	x,(OFST+1,sp)
1086  01b6 7b06          	ld	a,(OFST+6,sp)
1087  01b8 43            	cpl	a
1088  01b9 e40a          	and	a,(10,x)
1089  01bb e70a          	ld	(10,x),a
1090  01bd               L144:
1091                     ; 286 }
1094  01bd 85            	popw	x
1095  01be 81            	ret
1142                     ; 294 void I2C_DMACmd(I2C_TypeDef* I2Cx, FunctionalState NewState)
1142                     ; 295 {
1143                     	switch	.text
1144  01bf               _I2C_DMACmd:
1146  01bf 89            	pushw	x
1147       00000000      OFST:	set	0
1150                     ; 297   assert_param(IS_FUNCTIONAL_STATE(NewState));
1152                     ; 299   if (NewState != DISABLE)
1154  01c0 0d05          	tnz	(OFST+5,sp)
1155  01c2 2708          	jreq	L764
1156                     ; 302     I2Cx->ITR |= I2C_ITR_DMAEN;
1158  01c4 e60a          	ld	a,(10,x)
1159  01c6 aa08          	or	a,#8
1160  01c8 e70a          	ld	(10,x),a
1162  01ca 2008          	jra	L174
1163  01cc               L764:
1164                     ; 307     I2Cx->ITR &= (uint8_t)(~I2C_ITR_DMAEN);
1166  01cc 1e01          	ldw	x,(OFST+1,sp)
1167  01ce e60a          	ld	a,(10,x)
1168  01d0 a4f7          	and	a,#247
1169  01d2 e70a          	ld	(10,x),a
1170  01d4               L174:
1171                     ; 309 }
1174  01d4 85            	popw	x
1175  01d5 81            	ret
1223                     ; 318 void I2C_DMALastTransferCmd(I2C_TypeDef* I2Cx, FunctionalState NewState)
1223                     ; 319 {
1224                     	switch	.text
1225  01d6               _I2C_DMALastTransferCmd:
1227  01d6 89            	pushw	x
1228       00000000      OFST:	set	0
1231                     ; 321   assert_param(IS_FUNCTIONAL_STATE(NewState));
1233                     ; 323   if (NewState != DISABLE)
1235  01d7 0d05          	tnz	(OFST+5,sp)
1236  01d9 2708          	jreq	L715
1237                     ; 326     I2Cx->ITR |= I2C_ITR_LAST;
1239  01db e60a          	ld	a,(10,x)
1240  01dd aa10          	or	a,#16
1241  01df e70a          	ld	(10,x),a
1243  01e1 2008          	jra	L125
1244  01e3               L715:
1245                     ; 331     I2Cx->ITR &= (uint8_t)(~I2C_ITR_LAST);
1247  01e3 1e01          	ldw	x,(OFST+1,sp)
1248  01e5 e60a          	ld	a,(10,x)
1249  01e7 a4ef          	and	a,#239
1250  01e9 e70a          	ld	(10,x),a
1251  01eb               L125:
1252                     ; 333 }
1255  01eb 85            	popw	x
1256  01ec 81            	ret
1303                     ; 342 void I2C_GeneralCallCmd(I2C_TypeDef* I2Cx, FunctionalState NewState)
1303                     ; 343 {
1304                     	switch	.text
1305  01ed               _I2C_GeneralCallCmd:
1307  01ed 89            	pushw	x
1308       00000000      OFST:	set	0
1311                     ; 346   assert_param(IS_FUNCTIONAL_STATE(NewState));
1313                     ; 348   if (NewState != DISABLE)
1315  01ee 0d05          	tnz	(OFST+5,sp)
1316  01f0 2706          	jreq	L745
1317                     ; 351     I2Cx->CR1 |= I2C_CR1_ENGC;
1319  01f2 f6            	ld	a,(x)
1320  01f3 aa40          	or	a,#64
1321  01f5 f7            	ld	(x),a
1323  01f6 2006          	jra	L155
1324  01f8               L745:
1325                     ; 356     I2Cx->CR1 &= (uint8_t)(~I2C_CR1_ENGC);
1327  01f8 1e01          	ldw	x,(OFST+1,sp)
1328  01fa f6            	ld	a,(x)
1329  01fb a4bf          	and	a,#191
1330  01fd f7            	ld	(x),a
1331  01fe               L155:
1332                     ; 358 }
1335  01fe 85            	popw	x
1336  01ff 81            	ret
1383                     ; 369 void I2C_GenerateSTART(I2C_TypeDef* I2Cx, FunctionalState NewState)
1383                     ; 370 {
1384                     	switch	.text
1385  0200               _I2C_GenerateSTART:
1387  0200 89            	pushw	x
1388       00000000      OFST:	set	0
1391                     ; 373   assert_param(IS_FUNCTIONAL_STATE(NewState));
1393                     ; 375   if (NewState != DISABLE)
1395  0201 0d05          	tnz	(OFST+5,sp)
1396  0203 2708          	jreq	L775
1397                     ; 378     I2Cx->CR2 |= I2C_CR2_START;
1399  0205 e601          	ld	a,(1,x)
1400  0207 aa01          	or	a,#1
1401  0209 e701          	ld	(1,x),a
1403  020b 2008          	jra	L106
1404  020d               L775:
1405                     ; 383     I2Cx->CR2 &= (uint8_t)(~I2C_CR2_START);
1407  020d 1e01          	ldw	x,(OFST+1,sp)
1408  020f e601          	ld	a,(1,x)
1409  0211 a4fe          	and	a,#254
1410  0213 e701          	ld	(1,x),a
1411  0215               L106:
1412                     ; 385 }
1415  0215 85            	popw	x
1416  0216 81            	ret
1463                     ; 394 void I2C_GenerateSTOP(I2C_TypeDef* I2Cx, FunctionalState NewState)
1463                     ; 395 {
1464                     	switch	.text
1465  0217               _I2C_GenerateSTOP:
1467  0217 89            	pushw	x
1468       00000000      OFST:	set	0
1471                     ; 398   assert_param(IS_FUNCTIONAL_STATE(NewState));
1473                     ; 400   if (NewState != DISABLE)
1475  0218 0d05          	tnz	(OFST+5,sp)
1476  021a 2708          	jreq	L726
1477                     ; 403     I2Cx->CR2 |= I2C_CR2_STOP;
1479  021c e601          	ld	a,(1,x)
1480  021e aa02          	or	a,#2
1481  0220 e701          	ld	(1,x),a
1483  0222 2008          	jra	L136
1484  0224               L726:
1485                     ; 408     I2Cx->CR2 &= (uint8_t)(~I2C_CR2_STOP);
1487  0224 1e01          	ldw	x,(OFST+1,sp)
1488  0226 e601          	ld	a,(1,x)
1489  0228 a4fd          	and	a,#253
1490  022a e701          	ld	(1,x),a
1491  022c               L136:
1492                     ; 410 }
1495  022c 85            	popw	x
1496  022d 81            	ret
1544                     ; 419 void I2C_SoftwareResetCmd(I2C_TypeDef* I2Cx, FunctionalState NewState)
1544                     ; 420 {
1545                     	switch	.text
1546  022e               _I2C_SoftwareResetCmd:
1548  022e 89            	pushw	x
1549       00000000      OFST:	set	0
1552                     ; 422   assert_param(IS_FUNCTIONAL_STATE(NewState));
1554                     ; 424   if (NewState != DISABLE)
1556  022f 0d05          	tnz	(OFST+5,sp)
1557  0231 2708          	jreq	L756
1558                     ; 427     I2Cx->CR2 |= I2C_CR2_SWRST;
1560  0233 e601          	ld	a,(1,x)
1561  0235 aa80          	or	a,#128
1562  0237 e701          	ld	(1,x),a
1564  0239 2008          	jra	L166
1565  023b               L756:
1566                     ; 432     I2Cx->CR2 &= (uint8_t)(~I2C_CR2_SWRST);
1568  023b 1e01          	ldw	x,(OFST+1,sp)
1569  023d e601          	ld	a,(1,x)
1570  023f a47f          	and	a,#127
1571  0241 e701          	ld	(1,x),a
1572  0243               L166:
1573                     ; 434 }
1576  0243 85            	popw	x
1577  0244 81            	ret
1625                     ; 443 void I2C_StretchClockCmd(I2C_TypeDef* I2Cx, FunctionalState NewState)
1625                     ; 444 {
1626                     	switch	.text
1627  0245               _I2C_StretchClockCmd:
1629  0245 89            	pushw	x
1630       00000000      OFST:	set	0
1633                     ; 446   assert_param(IS_FUNCTIONAL_STATE(NewState));
1635                     ; 448   if (NewState != DISABLE)
1637  0246 0d05          	tnz	(OFST+5,sp)
1638  0248 2706          	jreq	L707
1639                     ; 451     I2Cx->CR1 &= (uint8_t)(~I2C_CR1_NOSTRETCH);
1641  024a f6            	ld	a,(x)
1642  024b a47f          	and	a,#127
1643  024d f7            	ld	(x),a
1645  024e 2006          	jra	L117
1646  0250               L707:
1647                     ; 457     I2Cx->CR1 |= I2C_CR1_NOSTRETCH;
1649  0250 1e01          	ldw	x,(OFST+1,sp)
1650  0252 f6            	ld	a,(x)
1651  0253 aa80          	or	a,#128
1652  0255 f7            	ld	(x),a
1653  0256               L117:
1654                     ; 459 }
1657  0256 85            	popw	x
1658  0257 81            	ret
1705                     ; 468 void I2C_ARPCmd(I2C_TypeDef* I2Cx, FunctionalState NewState)
1705                     ; 469 {
1706                     	switch	.text
1707  0258               _I2C_ARPCmd:
1709  0258 89            	pushw	x
1710       00000000      OFST:	set	0
1713                     ; 471   assert_param(IS_FUNCTIONAL_STATE(NewState));
1715                     ; 473   if (NewState != DISABLE)
1717  0259 0d05          	tnz	(OFST+5,sp)
1718  025b 2706          	jreq	L737
1719                     ; 476     I2Cx->CR1 |= I2C_CR1_ARP;
1721  025d f6            	ld	a,(x)
1722  025e aa10          	or	a,#16
1723  0260 f7            	ld	(x),a
1725  0261 2006          	jra	L147
1726  0263               L737:
1727                     ; 482     I2Cx->CR1 &= (uint8_t)(~I2C_CR1_ARP);
1729  0263 1e01          	ldw	x,(OFST+1,sp)
1730  0265 f6            	ld	a,(x)
1731  0266 a4ef          	and	a,#239
1732  0268 f7            	ld	(x),a
1733  0269               L147:
1734                     ; 484 }
1737  0269 85            	popw	x
1738  026a 81            	ret
1786                     ; 493 void I2C_AcknowledgeConfig(I2C_TypeDef* I2Cx, FunctionalState NewState)
1786                     ; 494 {
1787                     	switch	.text
1788  026b               _I2C_AcknowledgeConfig:
1790  026b 89            	pushw	x
1791       00000000      OFST:	set	0
1794                     ; 496   assert_param(IS_FUNCTIONAL_STATE(NewState));
1796                     ; 498   if (NewState != DISABLE)
1798  026c 0d05          	tnz	(OFST+5,sp)
1799  026e 2708          	jreq	L767
1800                     ; 501     I2Cx->CR2 |= I2C_CR2_ACK;
1802  0270 e601          	ld	a,(1,x)
1803  0272 aa04          	or	a,#4
1804  0274 e701          	ld	(1,x),a
1806  0276 2008          	jra	L177
1807  0278               L767:
1808                     ; 506     I2Cx->CR2 &= (uint8_t)(~I2C_CR2_ACK);
1810  0278 1e01          	ldw	x,(OFST+1,sp)
1811  027a e601          	ld	a,(1,x)
1812  027c a4fb          	and	a,#251
1813  027e e701          	ld	(1,x),a
1814  0280               L177:
1815                     ; 508 }
1818  0280 85            	popw	x
1819  0281 81            	ret
1875                     ; 516 void I2C_OwnAddress2Config(I2C_TypeDef* I2Cx, uint8_t Address)
1875                     ; 517 {
1876                     	switch	.text
1877  0282               _I2C_OwnAddress2Config:
1879  0282 89            	pushw	x
1880  0283 88            	push	a
1881       00000001      OFST:	set	1
1884                     ; 518   uint8_t tmpreg = 0;
1886                     ; 521   tmpreg = I2Cx->OAR2;
1888  0284 e605          	ld	a,(5,x)
1889  0286 6b01          	ld	(OFST+0,sp),a
1890                     ; 524   tmpreg &= (uint8_t)(~I2C_OAR2_ADD2);
1892  0288 7b01          	ld	a,(OFST+0,sp)
1893  028a a401          	and	a,#1
1894  028c 6b01          	ld	(OFST+0,sp),a
1895                     ; 527   tmpreg |= (uint8_t) ((uint8_t)Address & (uint8_t)0xFE);
1897  028e 7b06          	ld	a,(OFST+5,sp)
1898  0290 a4fe          	and	a,#254
1899  0292 1a01          	or	a,(OFST+0,sp)
1900  0294 6b01          	ld	(OFST+0,sp),a
1901                     ; 530   I2Cx->OAR2 = tmpreg;
1903  0296 7b01          	ld	a,(OFST+0,sp)
1904  0298 1e02          	ldw	x,(OFST+1,sp)
1905  029a e705          	ld	(5,x),a
1906                     ; 531 }
1909  029c 5b03          	addw	sp,#3
1910  029e 81            	ret
1957                     ; 540 void I2C_DualAddressCmd(I2C_TypeDef* I2Cx, FunctionalState NewState)
1957                     ; 541 {
1958                     	switch	.text
1959  029f               _I2C_DualAddressCmd:
1961  029f 89            	pushw	x
1962       00000000      OFST:	set	0
1965                     ; 543   assert_param(IS_FUNCTIONAL_STATE(NewState));
1967                     ; 545   if (NewState != DISABLE)
1969  02a0 0d05          	tnz	(OFST+5,sp)
1970  02a2 2708          	jreq	L7401
1971                     ; 548     I2Cx->OAR2 |= I2C_OAR2_ENDUAL;
1973  02a4 e605          	ld	a,(5,x)
1974  02a6 aa01          	or	a,#1
1975  02a8 e705          	ld	(5,x),a
1977  02aa 2008          	jra	L1501
1978  02ac               L7401:
1979                     ; 553     I2Cx->OAR2 &= (uint8_t)(~I2C_OAR2_ENDUAL);
1981  02ac 1e01          	ldw	x,(OFST+1,sp)
1982  02ae e605          	ld	a,(5,x)
1983  02b0 a4fe          	and	a,#254
1984  02b2 e705          	ld	(5,x),a
1985  02b4               L1501:
1986                     ; 555 }
1989  02b4 85            	popw	x
1990  02b5 81            	ret
2060                     ; 565 void I2C_AckPositionConfig(I2C_TypeDef* I2Cx, I2C_AckPosition_TypeDef I2C_AckPosition)
2060                     ; 566 {
2061                     	switch	.text
2062  02b6               _I2C_AckPositionConfig:
2064  02b6 89            	pushw	x
2065       00000000      OFST:	set	0
2068                     ; 568   assert_param(IS_I2C_ACK_POSITION(I2C_AckPosition));
2070                     ; 571   I2Cx->CR2 &= (uint8_t)(~I2C_CR2_POS);
2072  02b7 e601          	ld	a,(1,x)
2073  02b9 a4f7          	and	a,#247
2074  02bb e701          	ld	(1,x),a
2075                     ; 573   I2Cx->CR2 |= (uint8_t)I2C_AckPosition;
2077  02bd e601          	ld	a,(1,x)
2078  02bf 1a05          	or	a,(OFST+5,sp)
2079  02c1 e701          	ld	(1,x),a
2080                     ; 574 }
2083  02c3 85            	popw	x
2084  02c4 81            	ret
2154                     ; 584 void I2C_PECPositionConfig(I2C_TypeDef* I2Cx, I2C_PECPosition_TypeDef I2C_PECPosition)
2154                     ; 585 {
2155                     	switch	.text
2156  02c5               _I2C_PECPositionConfig:
2158  02c5 89            	pushw	x
2159       00000000      OFST:	set	0
2162                     ; 587   assert_param(IS_I2C_PEC_POSITION(I2C_PECPosition));
2164                     ; 590   I2Cx->CR2 &= (uint8_t)(~I2C_CR2_POS);
2166  02c6 e601          	ld	a,(1,x)
2167  02c8 a4f7          	and	a,#247
2168  02ca e701          	ld	(1,x),a
2169                     ; 592   I2Cx->CR2 |= (uint8_t)I2C_PECPosition;
2171  02cc e601          	ld	a,(1,x)
2172  02ce 1a05          	or	a,(OFST+5,sp)
2173  02d0 e701          	ld	(1,x),a
2174                     ; 593 }
2177  02d2 85            	popw	x
2178  02d3 81            	ret
2247                     ; 602 void I2C_SMBusAlertConfig(I2C_TypeDef* I2Cx, I2C_SMBusAlert_TypeDef I2C_SMBusAlert)
2247                     ; 603 {
2248                     	switch	.text
2249  02d4               _I2C_SMBusAlertConfig:
2251  02d4 89            	pushw	x
2252       00000000      OFST:	set	0
2255                     ; 606   assert_param(IS_I2C_SMBUS_ALERT(I2C_SMBusAlert));
2257                     ; 608   if (I2C_SMBusAlert != I2C_SMBusAlert_High)
2259  02d5 0d05          	tnz	(OFST+5,sp)
2260  02d7 2708          	jreq	L7711
2261                     ; 611     I2Cx->CR2 |= (uint8_t)I2C_CR2_ALERT;
2263  02d9 e601          	ld	a,(1,x)
2264  02db aa20          	or	a,#32
2265  02dd e701          	ld	(1,x),a
2267  02df 2008          	jra	L1021
2268  02e1               L7711:
2269                     ; 616     I2Cx->CR2 &= (uint8_t)(~I2C_CR2_ALERT);
2271  02e1 1e01          	ldw	x,(OFST+1,sp)
2272  02e3 e601          	ld	a,(1,x)
2273  02e5 a4df          	and	a,#223
2274  02e7 e701          	ld	(1,x),a
2275  02e9               L1021:
2276                     ; 618 }
2279  02e9 85            	popw	x
2280  02ea 81            	ret
2327                     ; 627 void I2C_TransmitPEC(I2C_TypeDef* I2Cx, FunctionalState NewState)
2327                     ; 628 {
2328                     	switch	.text
2329  02eb               _I2C_TransmitPEC:
2331  02eb 89            	pushw	x
2332       00000000      OFST:	set	0
2335                     ; 630   assert_param(IS_FUNCTIONAL_STATE(NewState));
2337                     ; 632   if (NewState != DISABLE)
2339  02ec 0d05          	tnz	(OFST+5,sp)
2340  02ee 2708          	jreq	L7221
2341                     ; 635     I2Cx->CR2 |= I2C_CR2_PEC;
2343  02f0 e601          	ld	a,(1,x)
2344  02f2 aa10          	or	a,#16
2345  02f4 e701          	ld	(1,x),a
2347  02f6 2008          	jra	L1321
2348  02f8               L7221:
2349                     ; 640     I2Cx->CR2 &= (uint8_t)(~I2C_CR2_PEC);
2351  02f8 1e01          	ldw	x,(OFST+1,sp)
2352  02fa e601          	ld	a,(1,x)
2353  02fc a4ef          	and	a,#239
2354  02fe e701          	ld	(1,x),a
2355  0300               L1321:
2356                     ; 642 }
2359  0300 85            	popw	x
2360  0301 81            	ret
2407                     ; 651 void I2C_CalculatePEC(I2C_TypeDef* I2Cx, FunctionalState NewState)
2407                     ; 652 {
2408                     	switch	.text
2409  0302               _I2C_CalculatePEC:
2411  0302 89            	pushw	x
2412       00000000      OFST:	set	0
2415                     ; 654   assert_param(IS_FUNCTIONAL_STATE(NewState));
2417                     ; 656   if (NewState != DISABLE)
2419  0303 0d05          	tnz	(OFST+5,sp)
2420  0305 2706          	jreq	L7521
2421                     ; 659     I2Cx->CR1 |= I2C_CR1_ENPEC;
2423  0307 f6            	ld	a,(x)
2424  0308 aa20          	or	a,#32
2425  030a f7            	ld	(x),a
2427  030b 2006          	jra	L1621
2428  030d               L7521:
2429                     ; 664     I2Cx->CR1 &= (uint8_t)(~I2C_CR1_ENPEC);
2431  030d 1e01          	ldw	x,(OFST+1,sp)
2432  030f f6            	ld	a,(x)
2433  0310 a4df          	and	a,#223
2434  0312 f7            	ld	(x),a
2435  0313               L1621:
2436                     ; 666 }
2439  0313 85            	popw	x
2440  0314 81            	ret
2488                     ; 676 void I2C_FastModeDutyCycleConfig(I2C_TypeDef* I2Cx, I2C_DutyCycle_TypeDef I2C_DutyCycle)
2488                     ; 677 {
2489                     	switch	.text
2490  0315               _I2C_FastModeDutyCycleConfig:
2492  0315 89            	pushw	x
2493       00000000      OFST:	set	0
2496                     ; 680   assert_param(IS_I2C_DUTY_CYCLE(I2C_DutyCycle));
2498                     ; 682   if (I2C_DutyCycle == I2C_DutyCycle_16_9)
2500  0316 7b05          	ld	a,(OFST+5,sp)
2501  0318 a140          	cp	a,#64
2502  031a 2608          	jrne	L7031
2503                     ; 685     I2Cx->CCRH |= I2C_CCRH_DUTY;
2505  031c e60c          	ld	a,(12,x)
2506  031e aa40          	or	a,#64
2507  0320 e70c          	ld	(12,x),a
2509  0322 2008          	jra	L1131
2510  0324               L7031:
2511                     ; 690     I2Cx->CCRH &= (uint8_t)(~I2C_CCRH_DUTY);
2513  0324 1e01          	ldw	x,(OFST+1,sp)
2514  0326 e60c          	ld	a,(12,x)
2515  0328 a4bf          	and	a,#191
2516  032a e70c          	ld	(12,x),a
2517  032c               L1131:
2518                     ; 692 }
2521  032c 85            	popw	x
2522  032d 81            	ret
2559                     ; 700 uint8_t I2C_ReceiveData(I2C_TypeDef* I2Cx)
2559                     ; 701 {
2560                     	switch	.text
2561  032e               _I2C_ReceiveData:
2565                     ; 703   return ((uint8_t)I2Cx->DR);
2567  032e e606          	ld	a,(6,x)
2570  0330 81            	ret
2649                     ; 715 void I2C_Send7bitAddress(I2C_TypeDef* I2Cx, uint8_t Address, I2C_Direction_TypeDef I2C_Direction)
2649                     ; 716 {
2650                     	switch	.text
2651  0331               _I2C_Send7bitAddress:
2653  0331 89            	pushw	x
2654       00000000      OFST:	set	0
2657                     ; 718   assert_param(IS_I2C_ADDRESS(Address));
2659                     ; 719   assert_param(IS_I2C_DIRECTION(I2C_Direction));
2661                     ; 722   if (I2C_Direction != I2C_Direction_Transmitter)
2663  0332 0d06          	tnz	(OFST+6,sp)
2664  0334 2708          	jreq	L3731
2665                     ; 725     Address |= OAR1_ADD0_Set;
2667  0336 7b05          	ld	a,(OFST+5,sp)
2668  0338 aa01          	or	a,#1
2669  033a 6b05          	ld	(OFST+5,sp),a
2671  033c 2006          	jra	L5731
2672  033e               L3731:
2673                     ; 730     Address &= OAR1_ADD0_Reset;
2675  033e 7b05          	ld	a,(OFST+5,sp)
2676  0340 a4fe          	and	a,#254
2677  0342 6b05          	ld	(OFST+5,sp),a
2678  0344               L5731:
2679                     ; 733   I2Cx->DR = Address;
2681  0344 7b05          	ld	a,(OFST+5,sp)
2682  0346 1e01          	ldw	x,(OFST+1,sp)
2683  0348 e706          	ld	(6,x),a
2684                     ; 734 }
2687  034a 85            	popw	x
2688  034b 81            	ret
2734                     ; 742 void I2C_SendData(I2C_TypeDef* I2Cx, uint8_t Data)
2734                     ; 743 {
2735                     	switch	.text
2736  034c               _I2C_SendData:
2738  034c 89            	pushw	x
2739       00000000      OFST:	set	0
2742                     ; 745   I2Cx->DR = Data;
2744  034d 7b05          	ld	a,(OFST+5,sp)
2745  034f 1e01          	ldw	x,(OFST+1,sp)
2746  0351 e706          	ld	(6,x),a
2747                     ; 746 }
2750  0353 85            	popw	x
2751  0354 81            	ret
2788                     ; 754 uint8_t I2C_GetPEC(I2C_TypeDef* I2Cx)
2788                     ; 755 {
2789                     	switch	.text
2790  0355               _I2C_GetPEC:
2794                     ; 757   return (I2Cx->PECR);
2796  0355 e60e          	ld	a,(14,x)
2799  0357 81            	ret
2960                     ; 768 uint8_t I2C_ReadRegister(I2C_TypeDef* I2Cx, I2C_Register_TypeDef I2C_Register)
2960                     ; 769 {
2961                     	switch	.text
2962  0358               _I2C_ReadRegister:
2964  0358 89            	pushw	x
2965  0359 5204          	subw	sp,#4
2966       00000004      OFST:	set	4
2969                     ; 770   __IO uint16_t tmp = 0;
2971  035b 5f            	clrw	x
2972  035c 1f03          	ldw	(OFST-1,sp),x
2973                     ; 772   assert_param(IS_I2C_REGISTER(I2C_Register));
2975                     ; 774   tmp = (uint16_t) I2Cx;
2977  035e 1e05          	ldw	x,(OFST+1,sp)
2978  0360 1f03          	ldw	(OFST-1,sp),x
2979                     ; 775   tmp += I2C_Register;
2981  0362 7b09          	ld	a,(OFST+5,sp)
2982  0364 5f            	clrw	x
2983  0365 97            	ld	xl,a
2984  0366 1f01          	ldw	(OFST-3,sp),x
2985  0368 1e03          	ldw	x,(OFST-1,sp)
2986  036a 72fb01        	addw	x,(OFST-3,sp)
2987  036d 1f03          	ldw	(OFST-1,sp),x
2988                     ; 778   return (*(__IO uint8_t *) tmp);
2990  036f 1e03          	ldw	x,(OFST-1,sp)
2991  0371 f6            	ld	a,(x)
2994  0372 5b06          	addw	sp,#6
2995  0374 81            	ret
3249                     ; 896 ErrorStatus I2C_CheckEvent(I2C_TypeDef* I2Cx, I2C_Event_TypeDef I2C_Event)
3249                     ; 897 {
3250                     	switch	.text
3251  0375               _I2C_CheckEvent:
3253  0375 89            	pushw	x
3254  0376 5206          	subw	sp,#6
3255       00000006      OFST:	set	6
3258                     ; 898   __IO uint16_t lastevent = 0x00;
3260  0378 5f            	clrw	x
3261  0379 1f04          	ldw	(OFST-2,sp),x
3262                     ; 899   uint8_t flag1 = 0x00 ;
3264                     ; 900   uint8_t flag2 = 0x00;
3266                     ; 901   ErrorStatus status = ERROR;
3268                     ; 904   assert_param(IS_I2C_EVENT(I2C_Event));
3270                     ; 906   if (I2C_Event == I2C_EVENT_SLAVE_ACK_FAILURE)
3272  037b 1e0b          	ldw	x,(OFST+5,sp)
3273  037d a30004        	cpw	x,#4
3274  0380 260c          	jrne	L5561
3275                     ; 908     lastevent = I2Cx->SR2 & I2C_SR2_AF;
3277  0382 1e07          	ldw	x,(OFST+1,sp)
3278  0384 e608          	ld	a,(8,x)
3279  0386 a404          	and	a,#4
3280  0388 5f            	clrw	x
3281  0389 97            	ld	xl,a
3282  038a 1f04          	ldw	(OFST-2,sp),x
3284  038c 2021          	jra	L7561
3285  038e               L5561:
3286                     ; 912     flag1 = I2Cx->SR1;
3288  038e 1e07          	ldw	x,(OFST+1,sp)
3289  0390 e607          	ld	a,(7,x)
3290  0392 6b03          	ld	(OFST-3,sp),a
3291                     ; 913     flag2 = I2Cx->SR3;
3293  0394 1e07          	ldw	x,(OFST+1,sp)
3294  0396 e609          	ld	a,(9,x)
3295  0398 6b06          	ld	(OFST+0,sp),a
3296                     ; 914     lastevent = ((uint16_t)((uint16_t)flag2 << (uint16_t)8) | (uint16_t)flag1);
3298  039a 7b03          	ld	a,(OFST-3,sp)
3299  039c 5f            	clrw	x
3300  039d 97            	ld	xl,a
3301  039e 1f01          	ldw	(OFST-5,sp),x
3302  03a0 7b06          	ld	a,(OFST+0,sp)
3303  03a2 5f            	clrw	x
3304  03a3 97            	ld	xl,a
3305  03a4 4f            	clr	a
3306  03a5 02            	rlwa	x,a
3307  03a6 01            	rrwa	x,a
3308  03a7 1a02          	or	a,(OFST-4,sp)
3309  03a9 01            	rrwa	x,a
3310  03aa 1a01          	or	a,(OFST-5,sp)
3311  03ac 01            	rrwa	x,a
3312  03ad 1f04          	ldw	(OFST-2,sp),x
3313  03af               L7561:
3314                     ; 917   if (((uint16_t)lastevent & (uint16_t)I2C_Event) == (uint16_t)I2C_Event)
3316  03af 1e04          	ldw	x,(OFST-2,sp)
3317  03b1 01            	rrwa	x,a
3318  03b2 140c          	and	a,(OFST+6,sp)
3319  03b4 01            	rrwa	x,a
3320  03b5 140b          	and	a,(OFST+5,sp)
3321  03b7 01            	rrwa	x,a
3322  03b8 130b          	cpw	x,(OFST+5,sp)
3323  03ba 2606          	jrne	L1661
3324                     ; 920     status = SUCCESS;
3326  03bc a601          	ld	a,#1
3327  03be 6b06          	ld	(OFST+0,sp),a
3329  03c0 2002          	jra	L3661
3330  03c2               L1661:
3331                     ; 925     status = ERROR;
3333  03c2 0f06          	clr	(OFST+0,sp)
3334  03c4               L3661:
3335                     ; 929   return status;
3337  03c4 7b06          	ld	a,(OFST+0,sp)
3340  03c6 5b08          	addw	sp,#8
3341  03c8 81            	ret
3406                     ; 947 I2C_Event_TypeDef I2C_GetLastEvent(I2C_TypeDef* I2Cx)
3406                     ; 948 {
3407                     	switch	.text
3408  03c9               _I2C_GetLastEvent:
3410  03c9 89            	pushw	x
3411  03ca 5206          	subw	sp,#6
3412       00000006      OFST:	set	6
3415                     ; 949   __IO uint16_t lastevent = 0;
3417  03cc 5f            	clrw	x
3418  03cd 1f05          	ldw	(OFST-1,sp),x
3419                     ; 950   uint16_t flag1 = 0;
3421                     ; 951   uint16_t flag2 = 0;
3423                     ; 953   if ((I2Cx->SR2 & I2C_SR2_AF) != 0x00)
3425  03cf 1e07          	ldw	x,(OFST+1,sp)
3426  03d1 e608          	ld	a,(8,x)
3427  03d3 a504          	bcp	a,#4
3428  03d5 2707          	jreq	L1271
3429                     ; 955     lastevent = I2C_EVENT_SLAVE_ACK_FAILURE;
3431  03d7 ae0004        	ldw	x,#4
3432  03da 1f05          	ldw	(OFST-1,sp),x
3434  03dc 201d          	jra	L3271
3435  03de               L1271:
3436                     ; 960     flag1 = I2Cx->SR1;
3438  03de 1e07          	ldw	x,(OFST+1,sp)
3439  03e0 e607          	ld	a,(7,x)
3440  03e2 5f            	clrw	x
3441  03e3 97            	ld	xl,a
3442  03e4 1f01          	ldw	(OFST-5,sp),x
3443                     ; 961     flag2 = I2Cx->SR3;
3445  03e6 1e07          	ldw	x,(OFST+1,sp)
3446  03e8 e609          	ld	a,(9,x)
3447  03ea 5f            	clrw	x
3448  03eb 97            	ld	xl,a
3449  03ec 1f03          	ldw	(OFST-3,sp),x
3450                     ; 964     lastevent = ((uint16_t)((uint16_t)flag2 << 8) | (uint16_t)flag1);
3452  03ee 1e03          	ldw	x,(OFST-3,sp)
3453  03f0 4f            	clr	a
3454  03f1 02            	rlwa	x,a
3455  03f2 01            	rrwa	x,a
3456  03f3 1a02          	or	a,(OFST-4,sp)
3457  03f5 01            	rrwa	x,a
3458  03f6 1a01          	or	a,(OFST-5,sp)
3459  03f8 01            	rrwa	x,a
3460  03f9 1f05          	ldw	(OFST-1,sp),x
3461  03fb               L3271:
3462                     ; 967   return (I2C_Event_TypeDef)lastevent;
3464  03fb 1e05          	ldw	x,(OFST-1,sp)
3467  03fd 5b08          	addw	sp,#8
3468  03ff 81            	ret
3725                     ; 1003 FlagStatus I2C_GetFlagStatus(I2C_TypeDef* I2Cx, I2C_FLAG_TypeDef I2C_FLAG)
3725                     ; 1004 {
3726                     	switch	.text
3727  0400               _I2C_GetFlagStatus:
3729  0400 89            	pushw	x
3730  0401 89            	pushw	x
3731       00000002      OFST:	set	2
3734                     ; 1005   uint8_t tempreg = 0;
3736  0402 0f02          	clr	(OFST+0,sp)
3737                     ; 1006   uint8_t regindex = 0;
3739                     ; 1007   FlagStatus bitstatus = RESET;
3741                     ; 1010   assert_param(IS_I2C_GET_FLAG(I2C_FLAG));
3743                     ; 1013   regindex = (uint8_t)((uint16_t)I2C_FLAG >> 8);
3745  0404 7b07          	ld	a,(OFST+5,sp)
3746  0406 6b01          	ld	(OFST-1,sp),a
3747                     ; 1015   switch (regindex)
3749  0408 7b01          	ld	a,(OFST-1,sp)
3751                     ; 1032     default:
3751                     ; 1033       break;
3752  040a 4a            	dec	a
3753  040b 2708          	jreq	L5271
3754  040d 4a            	dec	a
3755  040e 270d          	jreq	L7271
3756  0410 4a            	dec	a
3757  0411 2712          	jreq	L1371
3758  0413 2016          	jra	L7602
3759  0415               L5271:
3760                     ; 1018     case 0x01:
3760                     ; 1019       tempreg = (uint8_t)I2Cx->SR1;
3762  0415 1e03          	ldw	x,(OFST+1,sp)
3763  0417 e607          	ld	a,(7,x)
3764  0419 6b02          	ld	(OFST+0,sp),a
3765                     ; 1020       break;
3767  041b 200e          	jra	L7602
3768  041d               L7271:
3769                     ; 1023     case 0x02:
3769                     ; 1024       tempreg = (uint8_t)I2Cx->SR2;
3771  041d 1e03          	ldw	x,(OFST+1,sp)
3772  041f e608          	ld	a,(8,x)
3773  0421 6b02          	ld	(OFST+0,sp),a
3774                     ; 1025       break;
3776  0423 2006          	jra	L7602
3777  0425               L1371:
3778                     ; 1028     case 0x03:
3778                     ; 1029       tempreg = (uint8_t)I2Cx->SR3;
3780  0425 1e03          	ldw	x,(OFST+1,sp)
3781  0427 e609          	ld	a,(9,x)
3782  0429 6b02          	ld	(OFST+0,sp),a
3783                     ; 1030       break;
3785  042b               L3371:
3786                     ; 1032     default:
3786                     ; 1033       break;
3788  042b               L7602:
3789                     ; 1037   if ((tempreg & (uint8_t)I2C_FLAG ) != 0)
3791  042b 7b08          	ld	a,(OFST+6,sp)
3792  042d 1502          	bcp	a,(OFST+0,sp)
3793  042f 2706          	jreq	L1702
3794                     ; 1040     bitstatus = SET;
3796  0431 a601          	ld	a,#1
3797  0433 6b02          	ld	(OFST+0,sp),a
3799  0435 2002          	jra	L3702
3800  0437               L1702:
3801                     ; 1045     bitstatus = RESET;
3803  0437 0f02          	clr	(OFST+0,sp)
3804  0439               L3702:
3805                     ; 1048   return bitstatus;
3807  0439 7b02          	ld	a,(OFST+0,sp)
3810  043b 5b04          	addw	sp,#4
3811  043d 81            	ret
3867                     ; 1086 void I2C_ClearFlag(I2C_TypeDef* I2Cx, I2C_FLAG_TypeDef I2C_FLAG)
3867                     ; 1087 {
3868                     	switch	.text
3869  043e               _I2C_ClearFlag:
3871  043e 89            	pushw	x
3872  043f 89            	pushw	x
3873       00000002      OFST:	set	2
3876                     ; 1088   uint16_t flagpos = 0;
3878                     ; 1090   assert_param(IS_I2C_CLEAR_FLAG(I2C_FLAG));
3880                     ; 1093   flagpos = (uint16_t)I2C_FLAG & FLAG_Mask;
3882  0440 7b07          	ld	a,(OFST+5,sp)
3883  0442 97            	ld	xl,a
3884  0443 7b08          	ld	a,(OFST+6,sp)
3885  0445 a4ff          	and	a,#255
3886  0447 5f            	clrw	x
3887  0448 02            	rlwa	x,a
3888  0449 1f01          	ldw	(OFST-1,sp),x
3889  044b 01            	rrwa	x,a
3890                     ; 1095   I2Cx->SR2 = (uint8_t)((uint16_t)(~flagpos));
3892  044c 7b02          	ld	a,(OFST+0,sp)
3893  044e 43            	cpl	a
3894  044f 1e03          	ldw	x,(OFST+1,sp)
3895  0451 e708          	ld	(8,x),a
3896                     ; 1096 }
3899  0453 5b04          	addw	sp,#4
3900  0455 81            	ret
3976                     ; 1122 ITStatus I2C_GetITStatus(I2C_TypeDef* I2Cx, I2C_IT_TypeDef I2C_IT)
3976                     ; 1123 {
3977                     	switch	.text
3978  0456               _I2C_GetITStatus:
3980  0456 89            	pushw	x
3981  0457 5204          	subw	sp,#4
3982       00000004      OFST:	set	4
3985                     ; 1124   ITStatus bitstatus = RESET;
3987                     ; 1125   __IO uint8_t enablestatus = 0;
3989  0459 0f03          	clr	(OFST-1,sp)
3990                     ; 1126   uint16_t tempregister = 0;
3992                     ; 1129   assert_param(IS_I2C_GET_IT(I2C_IT));
3994                     ; 1131   tempregister = (uint8_t)( ((uint16_t)((uint16_t)I2C_IT & ITEN_Mask)) >> 8);
3996  045b 7b09          	ld	a,(OFST+5,sp)
3997  045d 97            	ld	xl,a
3998  045e 7b0a          	ld	a,(OFST+6,sp)
3999  0460 9f            	ld	a,xl
4000  0461 a407          	and	a,#7
4001  0463 97            	ld	xl,a
4002  0464 4f            	clr	a
4003  0465 02            	rlwa	x,a
4004  0466 4f            	clr	a
4005  0467 01            	rrwa	x,a
4006  0468 9f            	ld	a,xl
4007  0469 5f            	clrw	x
4008  046a 97            	ld	xl,a
4009  046b 1f01          	ldw	(OFST-3,sp),x
4010                     ; 1134   enablestatus = (uint8_t)(I2Cx->ITR & ( uint8_t)tempregister);
4012  046d 1e05          	ldw	x,(OFST+1,sp)
4013  046f e60a          	ld	a,(10,x)
4014  0471 1402          	and	a,(OFST-2,sp)
4015  0473 6b03          	ld	(OFST-1,sp),a
4016                     ; 1136   if ((uint16_t)((uint16_t)I2C_IT & REGISTER_Mask) == REGISTER_SR1_Index)
4018  0475 7b09          	ld	a,(OFST+5,sp)
4019  0477 97            	ld	xl,a
4020  0478 7b0a          	ld	a,(OFST+6,sp)
4021  047a 9f            	ld	a,xl
4022  047b a430          	and	a,#48
4023  047d 97            	ld	xl,a
4024  047e 4f            	clr	a
4025  047f 02            	rlwa	x,a
4026  0480 a30100        	cpw	x,#256
4027  0483 2616          	jrne	L5612
4028                     ; 1139     if (((I2Cx->SR1 & (uint8_t)I2C_IT) != RESET) && enablestatus)
4030  0485 1e05          	ldw	x,(OFST+1,sp)
4031  0487 e607          	ld	a,(7,x)
4032  0489 150a          	bcp	a,(OFST+6,sp)
4033  048b 270a          	jreq	L7612
4035  048d 0d03          	tnz	(OFST-1,sp)
4036  048f 2706          	jreq	L7612
4037                     ; 1142       bitstatus = SET;
4039  0491 a601          	ld	a,#1
4040  0493 6b04          	ld	(OFST+0,sp),a
4042  0495 2018          	jra	L3712
4043  0497               L7612:
4044                     ; 1147       bitstatus = RESET;
4046  0497 0f04          	clr	(OFST+0,sp)
4047  0499 2014          	jra	L3712
4048  049b               L5612:
4049                     ; 1153     if (((I2Cx->SR2 & (uint8_t)I2C_IT) != RESET) && enablestatus)
4051  049b 1e05          	ldw	x,(OFST+1,sp)
4052  049d e608          	ld	a,(8,x)
4053  049f 150a          	bcp	a,(OFST+6,sp)
4054  04a1 270a          	jreq	L5712
4056  04a3 0d03          	tnz	(OFST-1,sp)
4057  04a5 2706          	jreq	L5712
4058                     ; 1156       bitstatus = SET;
4060  04a7 a601          	ld	a,#1
4061  04a9 6b04          	ld	(OFST+0,sp),a
4063  04ab 2002          	jra	L3712
4064  04ad               L5712:
4065                     ; 1161       bitstatus = RESET;
4067  04ad 0f04          	clr	(OFST+0,sp)
4068  04af               L3712:
4069                     ; 1165   return  bitstatus;
4071  04af 7b04          	ld	a,(OFST+0,sp)
4074  04b1 5b06          	addw	sp,#6
4075  04b3 81            	ret
4132                     ; 1205 void I2C_ClearITPendingBit(I2C_TypeDef* I2Cx, I2C_IT_TypeDef I2C_IT)
4132                     ; 1206 {
4133                     	switch	.text
4134  04b4               _I2C_ClearITPendingBit:
4136  04b4 89            	pushw	x
4137  04b5 89            	pushw	x
4138       00000002      OFST:	set	2
4141                     ; 1207   uint16_t flagpos = 0;
4143                     ; 1210   assert_param(IS_I2C_CLEAR_IT(I2C_IT));
4145                     ; 1213   flagpos = (uint16_t)I2C_IT & FLAG_Mask;
4147  04b6 7b07          	ld	a,(OFST+5,sp)
4148  04b8 97            	ld	xl,a
4149  04b9 7b08          	ld	a,(OFST+6,sp)
4150  04bb a4ff          	and	a,#255
4151  04bd 5f            	clrw	x
4152  04be 02            	rlwa	x,a
4153  04bf 1f01          	ldw	(OFST-1,sp),x
4154  04c1 01            	rrwa	x,a
4155                     ; 1216   I2Cx->SR2 = (uint8_t)((uint16_t)~flagpos);
4157  04c2 7b02          	ld	a,(OFST+0,sp)
4158  04c4 43            	cpl	a
4159  04c5 1e03          	ldw	x,(OFST+1,sp)
4160  04c7 e708          	ld	(8,x),a
4161                     ; 1217 }
4164  04c9 5b04          	addw	sp,#4
4165  04cb 81            	ret
4178                     	xref	_CLK_GetClockFreq
4179                     	xdef	_I2C_ClearITPendingBit
4180                     	xdef	_I2C_GetITStatus
4181                     	xdef	_I2C_ClearFlag
4182                     	xdef	_I2C_GetFlagStatus
4183                     	xdef	_I2C_GetLastEvent
4184                     	xdef	_I2C_CheckEvent
4185                     	xdef	_I2C_GetPEC
4186                     	xdef	_I2C_CalculatePEC
4187                     	xdef	_I2C_TransmitPEC
4188                     	xdef	_I2C_ReadRegister
4189                     	xdef	_I2C_Send7bitAddress
4190                     	xdef	_I2C_ReceiveData
4191                     	xdef	_I2C_SendData
4192                     	xdef	_I2C_PECPositionConfig
4193                     	xdef	_I2C_SMBusAlertConfig
4194                     	xdef	_I2C_FastModeDutyCycleConfig
4195                     	xdef	_I2C_AckPositionConfig
4196                     	xdef	_I2C_ITConfig
4197                     	xdef	_I2C_DualAddressCmd
4198                     	xdef	_I2C_OwnAddress2Config
4199                     	xdef	_I2C_AcknowledgeConfig
4200                     	xdef	_I2C_GenerateSTOP
4201                     	xdef	_I2C_GenerateSTART
4202                     	xdef	_I2C_ARPCmd
4203                     	xdef	_I2C_StretchClockCmd
4204                     	xdef	_I2C_SoftwareResetCmd
4205                     	xdef	_I2C_GeneralCallCmd
4206                     	xdef	_I2C_DMALastTransferCmd
4207                     	xdef	_I2C_DMACmd
4208                     	xdef	_I2C_Cmd
4209                     	xdef	_I2C_Init
4210                     	xdef	_I2C_DeInit
4211                     	xref.b	c_lreg
4212                     	xref.b	c_x
4231                     	xref	c_uitol
4232                     	xref	c_sdivx
4233                     	xref	c_lzmp
4234                     	xref	c_rtol
4235                     	xref	c_smul
4236                     	xref	c_lmul
4237                     	xref	c_lcmp
4238                     	xref	c_ltor
4239                     	xref	c_ludv
4240                     	end
