   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Parser V4.8.32.1 - 30 Mar 2010
   3                     ; Generator V4.3.4 - 23 Mar 2010
  43                     ; 46 void PWR_DeInit(void)
  43                     ; 47 {
  45                     	switch	.text
  46  0000               _PWR_DeInit:
  50                     ; 48   PWR->CSR1 = PWR_CSR1_PVDIF;
  52  0000 352050b2      	mov	20658,#32
  53                     ; 49   PWR->CSR2 = PWR_CSR2_RESET_VALUE;
  55  0004 725f50b3      	clr	20659
  56                     ; 50 }
  59  0008 81            	ret
 114                     ; 57 void PWR_FastWakeUpCmd(FunctionalState NewState)
 114                     ; 58 {
 115                     	switch	.text
 116  0009               _PWR_FastWakeUpCmd:
 120                     ; 60   assert_param(IS_FUNCTIONAL_STATE(NewState));
 122                     ; 62   if (NewState != DISABLE)
 124  0009 4d            	tnz	a
 125  000a 2706          	jreq	L74
 126                     ; 65     PWR->CSR2 |= PWR_CSR2_FWU;
 128  000c 721450b3      	bset	20659,#2
 130  0010 2004          	jra	L15
 131  0012               L74:
 132                     ; 70     PWR->CSR2 &= (uint8_t)(~PWR_CSR2_FWU);
 134  0012 721550b3      	bres	20659,#2
 135  0016               L15:
 136                     ; 72 }
 139  0016 81            	ret
 175                     ; 79 void PWR_UltraLowPowerCmd(FunctionalState NewState)
 175                     ; 80 {
 176                     	switch	.text
 177  0017               _PWR_UltraLowPowerCmd:
 181                     ; 82   assert_param(IS_FUNCTIONAL_STATE(NewState));
 183                     ; 84   if (NewState != DISABLE)
 185  0017 4d            	tnz	a
 186  0018 2706          	jreq	L17
 187                     ; 87     PWR->CSR2 |= PWR_CSR2_ULP;
 189  001a 721250b3      	bset	20659,#1
 191  001e 2004          	jra	L37
 192  0020               L17:
 193                     ; 92     PWR->CSR2 &= (uint8_t)(~PWR_CSR2_ULP);
 195  0020 721350b3      	bres	20659,#1
 196  0024               L37:
 197                     ; 94 }
 200  0024 81            	ret
 235                     ; 101 void PWR_PVDCmd(FunctionalState NewState)
 235                     ; 102 {
 236                     	switch	.text
 237  0025               _PWR_PVDCmd:
 241                     ; 104   assert_param(IS_FUNCTIONAL_STATE(NewState));
 243                     ; 106   if (NewState != DISABLE)
 245  0025 4d            	tnz	a
 246  0026 2706          	jreq	L311
 247                     ; 109     PWR->CSR1 |= PWR_CSR1_PVDE;
 249  0028 721050b2      	bset	20658,#0
 251  002c 2004          	jra	L511
 252  002e               L311:
 253                     ; 114     PWR->CSR1 &= (uint8_t)(~PWR_CSR1_PVDE);
 255  002e 721150b2      	bres	20658,#0
 256  0032               L511:
 257                     ; 116 }
 260  0032 81            	ret
 295                     ; 123 void PWR_PVDITConfig(FunctionalState NewState)
 295                     ; 124 {
 296                     	switch	.text
 297  0033               _PWR_PVDITConfig:
 301                     ; 126   assert_param(IS_FUNCTIONAL_STATE(NewState));
 303                     ; 128   if (NewState != DISABLE)
 305  0033 4d            	tnz	a
 306  0034 2706          	jreq	L531
 307                     ; 131     PWR->CSR1 |= PWR_CSR1_PVDIEN;
 309  0036 721850b2      	bset	20658,#4
 311  003a 2004          	jra	L731
 312  003c               L531:
 313                     ; 136     PWR->CSR1 &= (uint8_t)(~PWR_CSR1_PVDIEN);
 315  003c 721950b2      	bres	20658,#4
 316  0040               L731:
 317                     ; 138 }
 320  0040 81            	ret
 417                     ; 146 void PWR_PVDLevelConfig(PWR_PVDLevel_TypeDef PWR_PVDLevel)
 417                     ; 147 {
 418                     	switch	.text
 419  0041               _PWR_PVDLevelConfig:
 421  0041 88            	push	a
 422       00000000      OFST:	set	0
 425                     ; 149   assert_param(IS_PWR_PVD_LEVEL(PWR_PVDLevel));
 427                     ; 152   PWR->CSR1 &= (uint8_t)(~PWR_CSR1_PLS);
 429  0042 c650b2        	ld	a,20658
 430  0045 a4f1          	and	a,#241
 431  0047 c750b2        	ld	20658,a
 432                     ; 155   PWR->CSR1 |= PWR_PVDLevel;
 434  004a c650b2        	ld	a,20658
 435  004d 1a01          	or	a,(OFST+1,sp)
 436  004f c750b2        	ld	20658,a
 437                     ; 157 }
 440  0052 84            	pop	a
 441  0053 81            	ret
 534                     ; 165 FlagStatus PWR_GetFlagStatus(PWR_FLAG_TypeDef PWR_FLAG)
 534                     ; 166 {
 535                     	switch	.text
 536  0054               _PWR_GetFlagStatus:
 538  0054 88            	push	a
 539  0055 88            	push	a
 540       00000001      OFST:	set	1
 543                     ; 167   FlagStatus bitstatus = RESET;
 545                     ; 170   assert_param(IS_PWR_FLAG(PWR_FLAG));
 547                     ; 172   if ((PWR_FLAG & PWR_FLAG_VREFINTF) != 0)
 549  0056 a501          	bcp	a,#1
 550  0058 2711          	jreq	L742
 551                     ; 174     if ((PWR->CSR2 & PWR_CR2_VREFINTF) != (uint8_t)RESET )
 553  005a c650b3        	ld	a,20659
 554  005d a501          	bcp	a,#1
 555  005f 2706          	jreq	L152
 556                     ; 176       bitstatus = SET;
 558  0061 a601          	ld	a,#1
 559  0063 6b01          	ld	(OFST+0,sp),a
 561  0065 2013          	jra	L552
 562  0067               L152:
 563                     ; 180       bitstatus = RESET;
 565  0067 0f01          	clr	(OFST+0,sp)
 566  0069 200f          	jra	L552
 567  006b               L742:
 568                     ; 185     if ((PWR->CSR1 & PWR_FLAG) != (uint8_t)RESET )
 570  006b c650b2        	ld	a,20658
 571  006e 1502          	bcp	a,(OFST+1,sp)
 572  0070 2706          	jreq	L752
 573                     ; 187       bitstatus = SET;
 575  0072 a601          	ld	a,#1
 576  0074 6b01          	ld	(OFST+0,sp),a
 578  0076 2002          	jra	L552
 579  0078               L752:
 580                     ; 191       bitstatus = RESET;
 582  0078 0f01          	clr	(OFST+0,sp)
 583  007a               L552:
 584                     ; 196   return((FlagStatus)bitstatus);
 586  007a 7b01          	ld	a,(OFST+0,sp)
 589  007c 85            	popw	x
 590  007d 81            	ret
 613                     ; 203 void PWR_PVDClearFlag(void)
 613                     ; 204 {
 614                     	switch	.text
 615  007e               _PWR_PVDClearFlag:
 619                     ; 206   PWR->CSR1 |= PWR_CSR1_PVDIF;
 621  007e 721a50b2      	bset	20658,#5
 622                     ; 207 }
 625  0082 81            	ret
 679                     ; 214 ITStatus PWR_PVDGetITStatus(void)
 679                     ; 215 {
 680                     	switch	.text
 681  0083               _PWR_PVDGetITStatus:
 683  0083 89            	pushw	x
 684       00000002      OFST:	set	2
 687                     ; 216   ITStatus bitstatus = RESET;
 689                     ; 218   uint8_t PVD_itStatus = 0x0, PVD_itEnable = 0x0;
 693                     ; 220   PVD_itStatus = (uint8_t)(PWR->CSR1 & (uint8_t)PWR_CSR1_PVDIF);
 695  0084 c650b2        	ld	a,20658
 696  0087 a420          	and	a,#32
 697  0089 6b01          	ld	(OFST-1,sp),a
 698                     ; 221   PVD_itEnable = (uint8_t)(PWR->CSR1 & (uint8_t)PWR_CSR1_PVDIEN);
 700  008b c650b2        	ld	a,20658
 701  008e a410          	and	a,#16
 702  0090 6b02          	ld	(OFST+0,sp),a
 703                     ; 223   if ((PVD_itStatus != (uint8_t)RESET ) && (PVD_itEnable != (uint8_t)RESET))
 705  0092 0d01          	tnz	(OFST-1,sp)
 706  0094 270a          	jreq	L123
 708  0096 0d02          	tnz	(OFST+0,sp)
 709  0098 2706          	jreq	L123
 710                     ; 225     bitstatus = (ITStatus)SET;
 712  009a a601          	ld	a,#1
 713  009c 6b02          	ld	(OFST+0,sp),a
 715  009e 2002          	jra	L323
 716  00a0               L123:
 717                     ; 229     bitstatus = (ITStatus)RESET;
 719  00a0 0f02          	clr	(OFST+0,sp)
 720  00a2               L323:
 721                     ; 231   return ((ITStatus)bitstatus);
 723  00a2 7b02          	ld	a,(OFST+0,sp)
 726  00a4 85            	popw	x
 727  00a5 81            	ret
 751                     ; 239 void PWR_PVDClearITPendingBit(void)
 751                     ; 240 {
 752                     	switch	.text
 753  00a6               _PWR_PVDClearITPendingBit:
 757                     ; 242   PWR->CSR1 |= PWR_CSR1_PVDIF;
 759  00a6 721a50b2      	bset	20658,#5
 760                     ; 243 }
 763  00aa 81            	ret
 776                     	xdef	_PWR_PVDClearITPendingBit
 777                     	xdef	_PWR_PVDGetITStatus
 778                     	xdef	_PWR_PVDClearFlag
 779                     	xdef	_PWR_GetFlagStatus
 780                     	xdef	_PWR_PVDLevelConfig
 781                     	xdef	_PWR_PVDITConfig
 782                     	xdef	_PWR_PVDCmd
 783                     	xdef	_PWR_UltraLowPowerCmd
 784                     	xdef	_PWR_FastWakeUpCmd
 785                     	xdef	_PWR_DeInit
 804                     	end
